"use strict";var juju={components:{}};chai.config.includeStack=true;chai.config.truncateThreshold=0;describe("DeploymentBar",function(){var previousNotifications;beforeAll(function(done){YUI().use("deployment-bar",function(){done()})});beforeEach(function(){var DeploymentBar=juju.components.DeploymentBar;previousNotifications=DeploymentBar.prototype.previousNotifications;juju.components.DeploymentBar.prototype.previousNotifications=[]});afterEach(function(){var DeploymentBar=juju.components.DeploymentBar;DeploymentBar.prototype.previousNotifications=previousNotifications});it("can render and pass the correct props",function(){var currentChangeSet={one:1,two:2};var deployButtonAction=sinon.stub();var renderer=jsTestUtils.shallowRender(React.createElement(juju.components.DeploymentBar,{currentChangeSet:currentChangeSet,deployButtonAction:deployButtonAction,exportEnvironmentFile:sinon.stub()}),true);var instance=renderer.getMountedInstance();var output=renderer.getRenderOutput();var expected=React.createElement(juju.components.Panel,{instanceName:"deployment-bar-panel",visible:true},React.createElement("span",{className:"deployment-bar__export link",onClick:instance._handleExport,role:"button",tabIndex:"0"},"Export"),React.createElement("span",{className:"deployment-bar__import link",onClick:instance._handleImportClick,role:"button",tabIndex:"0"},"Import"),React.createElement("input",{className:"deployment-bar__file",type:"file",onChange:instance._handleImportFile,accept:".zip,.yaml,.yml",ref:"file-input"}),React.createElement("a",{className:"deployment-bar__install-button",href:"https://jujucharms.com/get-started",target:"_blank"},"Install Juju"),React.createElement(juju.components.DeploymentBarNotification,{change:null}),React.createElement(juju.components.GenericButton,{action:deployButtonAction,type:"blue",disabled:false,title:"2"}),React.createElement(juju.components.GenericButton,{action:deployButtonAction,type:"confirm",disabled:false,title:"Deploy changes"}));assert.deepEqual(output,expected)});it("enables the button if there are changes",function(){var currentChangeSet={one:1,two:2};var deployButtonAction=sinon.stub();var output=jsTestUtils.shallowRender(React.createElement(juju.components.DeploymentBar,{currentChangeSet:currentChangeSet,deployButtonAction:deployButtonAction,exportEnvironmentFile:sinon.stub()}));assert.deepEqual(output.props.children[6],React.createElement(juju.components.GenericButton,{action:deployButtonAction,type:"confirm",disabled:false,title:"Deploy changes"}))});it("can export the env",function(){var currentChangeSet={one:1,two:2};var deployButtonAction=sinon.stub();var exportEnvironmentFile=sinon.stub();var output=jsTestUtils.shallowRender(React.createElement(juju.components.DeploymentBar,{currentChangeSet:currentChangeSet,deployButtonAction:deployButtonAction,exportEnvironmentFile:exportEnvironmentFile}));output.props.children[0].props.onClick();assert.equal(exportEnvironmentFile.callCount,1)});it("can open the file dialog when import is clicked",function(){var currentChangeSet={one:1,two:2};var fileClick=sinon.stub();var importBundleFile=sinon.stub();var generateChangeDescription=sinon.stub();var hideDragOverNotification=sinon.stub();var renderDragOverNotification=sinon.stub();var exportEnvironmentFile=sinon.stub();var deployButtonAction=sinon.stub();var shallowRenderer=jsTestUtils.shallowRender(React.createElement(juju.components.DeploymentBar,{hasCommits:false,deployButtonAction:deployButtonAction,exportEnvironmentFile:exportEnvironmentFile,renderDragOverNotification:renderDragOverNotification,importBundleFile:importBundleFile,hideDragOverNotification:hideDragOverNotification,generateChangeDescription:generateChangeDescription,currentChangeSet:currentChangeSet}),true);var instance=shallowRenderer.getMountedInstance();instance.refs={"file-input":{click:fileClick}};var output=shallowRenderer.getRenderOutput();output.props.children[1].props.onClick();assert.equal(fileClick.callCount,1)});it("can get a file when a file is selected",function(){var currentChangeSet={one:1,two:2};var importBundleFile=sinon.stub();var generateChangeDescription=sinon.stub();var hideDragOverNotification=sinon.stub();var renderDragOverNotification=sinon.stub();var exportEnvironmentFile=sinon.stub();var deployButtonAction=sinon.stub();var shallowRenderer=jsTestUtils.shallowRender(React.createElement(juju.components.DeploymentBar,{hasCommits:false,deployButtonAction:deployButtonAction,exportEnvironmentFile:exportEnvironmentFile,renderDragOverNotification:renderDragOverNotification,importBundleFile:importBundleFile,hideDragOverNotification:hideDragOverNotification,generateChangeDescription:generateChangeDescription,currentChangeSet:currentChangeSet}),true);var instance=shallowRenderer.getMountedInstance();instance.refs={"file-input":{files:["apache2.yaml"]}};var output=shallowRenderer.getRenderOutput();output.props.children[2].props.onChange();assert.equal(importBundleFile.callCount,1);assert.equal(importBundleFile.args[0][0],"apache2.yaml")});it("disables the button if there are no changes",function(){var currentChangeSet={};var deployButtonAction=sinon.stub();var output=jsTestUtils.shallowRender(React.createElement(juju.components.DeploymentBar,{currentChangeSet:currentChangeSet,deployButtonAction:deployButtonAction,exportEnvironmentFile:sinon.stub()}));assert.deepEqual(output.props.children[6],React.createElement(juju.components.GenericButton,{action:deployButtonAction,type:"confirm",disabled:true,title:"Deploy changes"}))});it("passes the button the correct title if there are commits",function(){var currentChangeSet={};var deployButtonAction=sinon.stub();var output=jsTestUtils.shallowRender(React.createElement(juju.components.DeploymentBar,{currentChangeSet:currentChangeSet,hasCommits:true,deployButtonAction:deployButtonAction,exportEnvironmentFile:sinon.stub()}));assert.deepEqual(output.props.children[6],React.createElement(juju.components.GenericButton,{action:deployButtonAction,type:"confirm",disabled:true,title:"Commit changes"}))});it("can display a notification",function(){var change="add-services-1";var currentChangeSet={"add-services-1":"add-services-change"};var deployButtonAction=sinon.stub();var generateChangeDescription=sinon.stub().returns(change);var renderer=jsTestUtils.shallowRender(React.createElement(juju.components.DeploymentBar,{currentChangeSet:currentChangeSet,exportEnvironmentFile:sinon.stub(),generateChangeDescription:generateChangeDescription,hasCommits:true,deployButtonAction:deployButtonAction}),true);var output=renderer.getRenderOutput();renderer.render(React.createElement(juju.components.DeploymentBar,{currentChangeSet:currentChangeSet,exportEnvironmentFile:sinon.stub(),generateChangeDescription:generateChangeDescription,hasCommits:true,deployButtonAction:deployButtonAction}));output=renderer.getRenderOutput();assert.deepEqual(output.props.children[4],React.createElement(juju.components.DeploymentBarNotification,{change:change}));assert.equal(generateChangeDescription.args[0][0],"add-services-change")});it("can display a new notification",function(){var change="add-services-1";var currentChangeSet={"add-services-1":"add-services-change"};var deployButtonAction=sinon.stub();var generateChangeDescription=sinon.stub().returns(change);var renderer=jsTestUtils.shallowRender(React.createElement(juju.components.DeploymentBar,{currentChangeSet:currentChangeSet,exportEnvironmentFile:sinon.stub(),generateChangeDescription:generateChangeDescription,hasCommits:true,deployButtonAction:deployButtonAction}),true);var output=renderer.getRenderOutput();renderer.render(React.createElement(juju.components.DeploymentBar,{currentChangeSet:currentChangeSet,exportEnvironmentFile:sinon.stub(),generateChangeDescription:generateChangeDescription,hasCommits:true,deployButtonAction:deployButtonAction}));output=renderer.getRenderOutput();assert.deepEqual(output.props.children[4],React.createElement(juju.components.DeploymentBarNotification,{change:change}));change="added-unit-1";currentChangeSet["added-unit-1"]="added-unit-change";generateChangeDescription.returns(change);renderer.render(React.createElement(juju.components.DeploymentBar,{currentChangeSet:currentChangeSet,exportEnvironmentFile:sinon.stub(),generateChangeDescription:generateChangeDescription,hasCommits:true,deployButtonAction:deployButtonAction}));output=renderer.getRenderOutput();assert.deepEqual(output.props.children[4],React.createElement(juju.components.DeploymentBarNotification,{change:change}))});it("does not display a previously displayed notification",function(){var change="add-services-1";var currentChangeSet={"add-services-1":"add-services-change"};var deployButtonAction=sinon.stub();var generateChangeDescription=sinon.stub().returns(change);var renderer=jsTestUtils.shallowRender(React.createElement(juju.components.DeploymentBar,{currentChangeSet:currentChangeSet,exportEnvironmentFile:sinon.stub(),generateChangeDescription:generateChangeDescription,hasCommits:true,deployButtonAction:deployButtonAction}),true);var output=renderer.getRenderOutput();renderer.render(React.createElement(juju.components.DeploymentBar,{currentChangeSet:currentChangeSet,exportEnvironmentFile:sinon.stub(),generateChangeDescription:generateChangeDescription,hasCommits:true,deployButtonAction:deployButtonAction}));output=renderer.getRenderOutput();assert.deepEqual(output.props.children[4],React.createElement(juju.components.DeploymentBarNotification,{change:change}));change="added-unit-1";currentChangeSet["added-unit-1"]="added-unit-change";generateChangeDescription.returns(change);renderer.render(React.createElement(juju.components.DeploymentBar,{currentChangeSet:currentChangeSet,exportEnvironmentFile:sinon.stub(),generateChangeDescription:generateChangeDescription,hasCommits:true,deployButtonAction:deployButtonAction}));output=renderer.getRenderOutput();assert.deepEqual(output.props.children[4],React.createElement(juju.components.DeploymentBarNotification,{change:change}));delete currentChangeSet["added-unit-1"];generateChangeDescription.returns("add-services-change");renderer.render(React.createElement(juju.components.DeploymentBar,{currentChangeSet:currentChangeSet,exportEnvironmentFile:sinon.stub(),generateChangeDescription:generateChangeDescription,hasCommits:true,deployButtonAction:deployButtonAction}));output=renderer.getRenderOutput();assert.deepEqual(output.props.children[4],React.createElement(juju.components.DeploymentBarNotification,{change:change}))})});