"use strict";var juju={components:{}};chai.config.includeStack=true;chai.config.truncateThreshold=0;describe("Deployment",function(){beforeAll(function(done){YUI().use("deployment-component",function(){done()})});it("can display the deployment bar",function(){var currentChangeSet=sinon.stub();var exportEnvironmentFile=sinon.stub();var generateChangeDescription=sinon.stub();var renderDragOverNotification=sinon.stub();var importBundleFile=sinon.stub();var hideDragOverNotification=sinon.stub();var output=jsTestUtils.shallowRender(React.createElement(juju.components.Deployment,{exportEnvironmentFile:exportEnvironmentFile,currentChangeSet:currentChangeSet,renderDragOverNotification:renderDragOverNotification,importBundleFile:importBundleFile,hideDragOverNotification:hideDragOverNotification,generateChangeDescription:generateChangeDescription,activeComponent:"deployment-bar"}));assert.deepEqual(output,React.createElement("div",{className:"deployment-view"},React.createElement(juju.components.DeploymentBar,{hasCommits:false,deployButtonAction:output.props.children.props.deployButtonAction,exportEnvironmentFile:exportEnvironmentFile,renderDragOverNotification:renderDragOverNotification,importBundleFile:importBundleFile,hideDragOverNotification:hideDragOverNotification,generateChangeDescription:generateChangeDescription,currentChangeSet:currentChangeSet})))});it("displays the deployment bar by default",function(){var currentChangeSet=sinon.stub();var exportEnvironmentFile=sinon.stub();var generateChangeDescription=sinon.stub();var renderDragOverNotification=sinon.stub();var importBundleFile=sinon.stub();var hideDragOverNotification=sinon.stub();var output=jsTestUtils.shallowRender(React.createElement(juju.components.Deployment,{exportEnvironmentFile:exportEnvironmentFile,renderDragOverNotification:renderDragOverNotification,importBundleFile:importBundleFile,hideDragOverNotification:hideDragOverNotification,generateChangeDescription:generateChangeDescription,currentChangeSet:currentChangeSet}));assert.deepEqual(output,React.createElement("div",{className:"deployment-view"},React.createElement(juju.components.DeploymentBar,{exportEnvironmentFile:exportEnvironmentFile,hasCommits:false,renderDragOverNotification:renderDragOverNotification,importBundleFile:importBundleFile,hideDragOverNotification:hideDragOverNotification,generateChangeDescription:generateChangeDescription,deployButtonAction:output.props.children.props.deployButtonAction,currentChangeSet:currentChangeSet})))});it("tracks that it has commits after the first deploy",function(){var currentChangeSet=sinon.stub();var exportEnvironmentFile=sinon.stub();var generateChangeDescription=sinon.stub();var autoPlaceUnits=sinon.stub();var renderDragOverNotification=sinon.stub();var importBundleFile=sinon.stub();var hideDragOverNotification=sinon.stub();var shallowRenderer=jsTestUtils.shallowRender(React.createElement(juju.components.Deployment,{ecsCommit:sinon.stub(),exportEnvironmentFile:exportEnvironmentFile,renderDragOverNotification:renderDragOverNotification,importBundleFile:importBundleFile,hideDragOverNotification:hideDragOverNotification,generateChangeDescription:generateChangeDescription,activeComponent:"deployment-summary",currentChangeSet:currentChangeSet,autoPlaceUnits:autoPlaceUnits}),true);var output=shallowRenderer.getRenderOutput();output.props.children.props.deployButtonAction();shallowRenderer.render(React.createElement(juju.components.Deployment,{ecsCommit:sinon.stub(),exportEnvironmentFile:exportEnvironmentFile,renderDragOverNotification:renderDragOverNotification,importBundleFile:importBundleFile,hideDragOverNotification:hideDragOverNotification,generateChangeDescription:generateChangeDescription,activeComponent:"deployment-bar",currentChangeSet:currentChangeSet}));var output=shallowRenderer.getRenderOutput();assert.deepEqual(output,React.createElement("div",{className:"deployment-view"},React.createElement(juju.components.DeploymentBar,{exportEnvironmentFile:exportEnvironmentFile,hasCommits:true,renderDragOverNotification:renderDragOverNotification,importBundleFile:importBundleFile,hideDragOverNotification:hideDragOverNotification,generateChangeDescription:generateChangeDescription,deployButtonAction:output.props.children.props.deployButtonAction,currentChangeSet:currentChangeSet})))});it("tracks that it has commits if existing non-pending service",function(){var currentChangeSet=sinon.stub();var exportEnvironmentFile=sinon.stub();var generateChangeDescription=sinon.stub();var renderDragOverNotification=sinon.stub();var importBundleFile=sinon.stub();var hideDragOverNotification=sinon.stub();var services=[{get:sinon.stub().returns(true)},{get:sinon.stub().returns(false)}];var shallowRenderer=jsTestUtils.shallowRender(React.createElement(juju.components.Deployment,{ecsCommit:sinon.stub(),exportEnvironmentFile:exportEnvironmentFile,services:services,renderDragOverNotification:renderDragOverNotification,importBundleFile:importBundleFile,hideDragOverNotification:hideDragOverNotification,generateChangeDescription:generateChangeDescription,activeComponent:"deployment-summary",currentChangeSet:currentChangeSet}),true);var output=shallowRenderer.getRenderOutput();shallowRenderer.render(React.createElement(juju.components.Deployment,{ecsCommit:sinon.stub(),exportEnvironmentFile:exportEnvironmentFile,services:services,renderDragOverNotification:renderDragOverNotification,importBundleFile:importBundleFile,hideDragOverNotification:hideDragOverNotification,generateChangeDescription:generateChangeDescription,activeComponent:"deployment-bar",currentChangeSet:currentChangeSet}));var output=shallowRenderer.getRenderOutput();assert.deepEqual(output,React.createElement("div",{className:"deployment-view"},React.createElement(juju.components.DeploymentBar,{exportEnvironmentFile:exportEnvironmentFile,hasCommits:true,renderDragOverNotification:renderDragOverNotification,importBundleFile:importBundleFile,hideDragOverNotification:hideDragOverNotification,generateChangeDescription:generateChangeDescription,deployButtonAction:output.props.children.props.deployButtonAction,currentChangeSet:currentChangeSet})))});it("can display the deployment summary",function(){var currentChangeSet=sinon.stub();var exportEnvironmentFile=sinon.stub();var getUnplacedUnitCount=sinon.stub();var ecsClear=sinon.stub();var changeDescriptions={};var renderDragOverNotification=sinon.stub();var importBundleFile=sinon.stub();var hideDragOverNotification=sinon.stub();var output=jsTestUtils.shallowRender(React.createElement(juju.components.Deployment,{ecsClear:ecsClear,currentChangeSet:currentChangeSet,renderDragOverNotification:renderDragOverNotification,importBundleFile:importBundleFile,hideDragOverNotification:hideDragOverNotification,changeDescriptions:changeDescriptions,exportEnvironmentFile:exportEnvironmentFile,getUnplacedUnitCount:getUnplacedUnitCount,activeComponent:"deployment-summary"}));assert.deepEqual(output,React.createElement("div",{className:"deployment-view"},React.createElement(juju.components.DeploymentSummary,{summaryClearAction:output.props.children.props.summaryClearAction,deployButtonAction:output.props.children.props.deployButtonAction,closeButtonAction:output.props.children.props.closeButtonAction,changeDescriptions:changeDescriptions,handleViewMachinesClick:output.props.children.props.handleViewMachinesClick,handlePlacementChange:output.props.children.props.handlePlacementChange,autoPlace:true,getUnplacedUnitCount:getUnplacedUnitCount})))});it("can pass updated props to the components",function(){var currentChangeSet=sinon.stub();var exportEnvironmentFile=sinon.stub();var newChangeSet=sinon.stub();var generateChangeDescription=sinon.stub();var services=[];var renderDragOverNotification=sinon.stub();var importBundleFile=sinon.stub();var hideDragOverNotification=sinon.stub();var shallowRenderer=jsTestUtils.shallowRender(React.createElement(juju.components.Deployment,{ecsCommit:sinon.stub(),exportEnvironmentFile:exportEnvironmentFile,renderDragOverNotification:renderDragOverNotification,importBundleFile:importBundleFile,hideDragOverNotification:hideDragOverNotification,services:services,generateChangeDescription:generateChangeDescription,activeComponent:"deployment-summary",currentChangeSet:currentChangeSet}),true);var output=shallowRenderer.getRenderOutput();shallowRenderer.render(React.createElement(juju.components.Deployment,{ecsCommit:sinon.stub(),exportEnvironmentFile:exportEnvironmentFile,renderDragOverNotification:renderDragOverNotification,importBundleFile:importBundleFile,hideDragOverNotification:hideDragOverNotification,services:services,generateChangeDescription:generateChangeDescription,activeComponent:"deployment-bar",currentChangeSet:newChangeSet}));var output=shallowRenderer.getRenderOutput();assert.deepEqual(output,React.createElement("div",{className:"deployment-view"},React.createElement(juju.components.DeploymentBar,{hasCommits:false,exportEnvironmentFile:exportEnvironmentFile,renderDragOverNotification:renderDragOverNotification,importBundleFile:importBundleFile,hideDragOverNotification:hideDragOverNotification,generateChangeDescription:generateChangeDescription,deployButtonAction:output.props.children.props.deployButtonAction,currentChangeSet:newChangeSet})))});it("can commit to ecs changes",function(){var ecsCommit=sinon.stub();var autoPlaceUnits=sinon.stub();var currentChangeSet=sinon.stub();var exportEnvironmentFile=sinon.stub();var getUnplacedUnitCount=sinon.stub();var changeDescriptions={};var output=jsTestUtils.shallowRender(React.createElement(juju.components.Deployment,{ecsCommit:ecsCommit,exportEnvironmentFile:exportEnvironmentFile,autoPlaceUnits:autoPlaceUnits,currentChangeSet:currentChangeSet,changeDescriptions:changeDescriptions,getUnplacedUnitCount:getUnplacedUnitCount,activeComponent:"deployment-summary"}));output.props.children.props.deployButtonAction();assert.equal(ecsCommit.callCount,1);assert.equal(autoPlaceUnits.callCount,1)});it("can automatically place units on commit",function(){var ecsCommit=sinon.stub();var autoPlaceUnits=sinon.stub();var currentChangeSet=sinon.stub();var exportEnvironmentFile=sinon.stub();var getUnplacedUnitCount=sinon.stub();var changeDescriptions={};var output=jsTestUtils.shallowRender(React.createElement(juju.components.Deployment,{ecsCommit:ecsCommit,exportEnvironmentFile:exportEnvironmentFile,autoPlaceUnits:autoPlaceUnits,currentChangeSet:currentChangeSet,changeDescriptions:changeDescriptions,getUnplacedUnitCount:getUnplacedUnitCount,activeComponent:"deployment-summary"}));output.props.children.props.handlePlacementChange({currentTarget:{getAttribute:sinon.stub().returns("placed")}});output.props.children.props.deployButtonAction();assert.equal(autoPlaceUnits.callCount,1)});it("can handle navigating to the machine view",function(){var ecsCommit=sinon.stub();var changeState=sinon.stub();var autoPlaceUnits=sinon.stub();var currentChangeSet=sinon.stub();var exportEnvironmentFile=sinon.stub();var getUnplacedUnitCount=sinon.stub();var generateChangeDescription=sinon.stub();var changeDescriptions={};var shallowRenderer=jsTestUtils.shallowRender(React.createElement(juju.components.Deployment,{ecsCommit:ecsCommit,exportEnvironmentFile:exportEnvironmentFile,changeState:changeState,autoPlaceUnits:autoPlaceUnits,currentChangeSet:currentChangeSet,changeDescriptions:changeDescriptions,generateChangeDescription:generateChangeDescription,getUnplacedUnitCount:getUnplacedUnitCount,activeComponent:"deployment-summary"}),true);var instance=shallowRenderer.getMountedInstance();var output=shallowRenderer.getRenderOutput();output.props.children.props.handleViewMachinesClick();assert.equal(changeState.callCount,1);assert.deepEqual(changeState.args[0][0],{sectionB:{component:"machine",metadata:{}}});assert.equal(instance.state.activeComponent,"deployment-bar")})});