"use strict";var juju={components:{}};chai.config.includeStack=true;chai.config.truncateThreshold=0;describe("EntityDetails",function(){var mockEntity;beforeAll(function(done){YUI().use("entity-details","jujulib-utils",function(){done()})});beforeEach(function(){mockEntity=jsTestUtils.makeEntity()});afterEach(function(){mockEntity=undefined});it("can be rendered",function(){var output=jsTestUtils.shallowRender(React.createElement(juju.components.EntityDetails,{id:"test",deployService:sinon.spy(),changeState:sinon.spy(),getEntity:sinon.spy(),pluralize:sinon.spy()}));assert.equal(output.props.className,"entity-details")});it("fetches an entity properly",function(){var id=mockEntity.get("id");var getEntity=sinon.stub().callsArgWith(1,null,[mockEntity]);var makeEntityModel=sinon.stub().returns(mockEntity);var deployService=sinon.spy();var changeState=sinon.spy();var importBundleYAML=sinon.spy();var getBundleYAML=sinon.spy();var pluralize=sinon.spy();var getFile=sinon.spy();var renderMarkdown=sinon.spy();var addNotification=sinon.spy();var shallowRenderer=jsTestUtils.shallowRender(React.createElement(juju.components.EntityDetails,{deployService:deployService,changeState:changeState,importBundleYAML:importBundleYAML,getBundleYAML:getBundleYAML,getEntity:getEntity,getFile:getFile,scrollPosition:100,renderMarkdown:renderMarkdown,id:id,pluralize:pluralize,addNotification:addNotification,makeEntityModel:makeEntityModel}),true);shallowRenderer.getMountedInstance().componentDidMount();var output=shallowRenderer.getRenderOutput();assert.isTrue(getEntity.calledOnce,"getEntity function not called");assert.equal(getEntity.args[0][0],id,"getEntity not called with the entity ID");var expected=React.createElement("div",{className:"entity-details charm"},React.createElement("div",null,React.createElement(juju.components.EntityHeader,{entityModel:mockEntity,importBundleYAML:importBundleYAML,getBundleYAML:getBundleYAML,changeState:changeState,addNotification:addNotification,deployService:deployService,scrollPosition:100}),undefined,React.createElement(juju.components.EntityContent,{changeState:changeState,entityModel:mockEntity,getFile:getFile,pluralize:pluralize,renderMarkdown:renderMarkdown})));assert.deepEqual(output,expected)});it("can display a message if there is a loading error",function(){var id=mockEntity.get("id");var getEntity=sinon.stub().callsArgWith(1,"bad wolf",[mockEntity]);var deployService=sinon.spy();var changeState=sinon.spy();var importBundleYAML=sinon.spy();var getBundleYAML=sinon.spy();var pluralize=sinon.spy();var getFile=sinon.spy();var renderMarkdown=sinon.spy();var shallowRenderer=jsTestUtils.shallowRender(React.createElement(juju.components.EntityDetails,{deployService:deployService,changeState:changeState,importBundleYAML:importBundleYAML,getBundleYAML:getBundleYAML,getEntity:getEntity,getFile:getFile,renderMarkdown:renderMarkdown,id:id,pluralize:pluralize}),true);var instance=shallowRenderer.getMountedInstance();instance.componentDidMount();var output=shallowRenderer.getRenderOutput();var expected=React.createElement("div",{className:"entity-details"},React.createElement("p",{className:"error"},"There was a problem while loading the entity details. You could try searching for another charm or bundle or go"," ",React.createElement("span",{className:"link",onClick:instance._handleBack},"back"),"."));assert.deepEqual(output,expected)});it("can display a bundle diagram",function(){var mockEntity=jsTestUtils.makeEntity(true);var id=mockEntity.get("id");var getEntity=sinon.stub().callsArgWith(1,null,[mockEntity]);var makeEntityModel=sinon.stub().returns(mockEntity);var deployService=sinon.spy();var changeState=sinon.spy();var importBundleYAML=sinon.spy();var getBundleYAML=sinon.spy();var pluralize=sinon.spy();var getFile=sinon.spy();var renderMarkdown=sinon.spy();var getDiagramURL=sinon.spy();var addNotification=sinon.spy();var shallowRenderer=jsTestUtils.shallowRender(React.createElement(juju.components.EntityDetails,{deployService:deployService,changeState:changeState,importBundleYAML:importBundleYAML,getBundleYAML:getBundleYAML,getEntity:getEntity,getFile:getFile,scrollPosition:100,renderMarkdown:renderMarkdown,getDiagramURL:getDiagramURL,id:id,pluralize:pluralize,addNotification:addNotification,makeEntityModel:makeEntityModel}),true);shallowRenderer.getMountedInstance().componentDidMount();var output=shallowRenderer.getRenderOutput();assert.isTrue(getEntity.calledOnce,"getEntity function not called");assert.equal(getEntity.args[0][0],id,"getEntity not called with the entity ID");var expected=React.createElement("div",{className:"entity-details bundle"},React.createElement("div",null,React.createElement(juju.components.EntityHeader,{entityModel:mockEntity,importBundleYAML:importBundleYAML,getBundleYAML:getBundleYAML,changeState:changeState,deployService:deployService,addNotification:addNotification,scrollPosition:100}),React.createElement(juju.components.EntityContentDiagram,{getDiagramURL:getDiagramURL,id:id}),React.createElement(juju.components.EntityContent,{changeState:changeState,entityModel:mockEntity,getFile:getFile,pluralize:pluralize,renderMarkdown:renderMarkdown})));assert.deepEqual(output,expected)});it("will abort the request when unmounting",function(){var abort=sinon.stub();var id=mockEntity.get("id");var getEntity=sinon.stub().returns({abort:abort});var deployService=sinon.spy();var changeState=sinon.spy();var importBundleYAML=sinon.spy();var getBundleYAML=sinon.spy();var pluralize=sinon.spy();var getFile=sinon.spy();var renderMarkdown=sinon.spy();var shallowRenderer=jsTestUtils.shallowRender(React.createElement(juju.components.EntityDetails,{deployService:deployService,changeState:changeState,importBundleYAML:importBundleYAML,getBundleYAML:getBundleYAML,getEntity:getEntity,getFile:getFile,renderMarkdown:renderMarkdown,id:id,pluralize:pluralize}),true);shallowRenderer.getMountedInstance().componentDidMount();shallowRenderer.unmount();assert.equal(abort.callCount,1)})});