"use strict";var juju={components:{}};chai.config.includeStack=true;chai.config.truncateThreshold=0;describe("EntityFiles",function(){var mockEntity;beforeAll(function(done){YUI().use("entity-files",function(){done()})});beforeEach(function(){mockEntity=jsTestUtils.makeEntity(false,["foo.zip","bar/foo.txt"])});afterEach(function(){mockEntity=undefined});it("renders a list of files",function(){var renderer=jsTestUtils.shallowRender(React.createElement(juju.components.EntityFiles,{entityModel:mockEntity,pluralize:sinon.stub().returns("files")}),true);var output=renderer.getRenderOutput();var instance=renderer.getMountedInstance();var archiveUrl="https://api.jujucharms.com/charmstore/v4/trusty/django/archive";var fileItems=[React.createElement("li",{key:"foo.zip",className:"entity-files__file"},React.createElement("a",{href:archiveUrl+"/foo.zip",title:"foo.zip",target:"_blank"},"foo.zip")),React.createElement("li",{key:"bar",className:"entity-files__directory collapsed",tabIndex:"0",role:"button",onClick:instance._onDirectoryClick},"/bar",React.createElement("ul",{className:"entity-files__listing"},[React.createElement("li",{key:"bar/foo.txt",className:"entity-files__file"},React.createElement("a",{href:archiveUrl+"/bar/foo.txt",title:"foo.txt",target:"_blank"},"foo.txt"))]))];var expected=React.createElement("div",{className:"entity-files section",id:"files"},React.createElement("h3",{className:"section__title"},"2 files"),React.createElement("ul",{className:"section__list"},React.createElement("li",{className:"entity-files__link section__list-item"},React.createElement("a",{ref:"codeLink",target:"_blank",href:"https://code.launchpad.net/django/code"},"View code")),React.createElement("li",{className:"entity-files__link section__list-item"},React.createElement("a",{target:"_blank",href:archiveUrl},"Download .zip"))),React.createElement("ul",{ref:"files",className:"section__list entity-files__listing"},fileItems));assert.deepEqual(output,expected)});it("renders for an empty/null list of files",function(){mockEntity.set("files",[]);var output=testUtils.renderIntoDocument(React.createElement(juju.components.EntityFiles,{entityModel:mockEntity,pluralize:sinon.spy()}));assert.equal(output.refs.files.children.length,0)});it("excludes the code link when url is not present",function(){mockEntity.set("code_source",null);var output=testUtils.renderIntoDocument(React.createElement(juju.components.EntityFiles,{entityModel:mockEntity,pluralize:sinon.spy()}));assert.equal(output.refs.codeLink,undefined)});it("renders file urls correctly for bundle",function(){mockEntity.set("entityType","bundle");mockEntity.set("name","django");mockEntity.set("full_name","wordpress");var output=testUtils.renderIntoDocument(React.createElement(juju.components.EntityFiles,{entityModel:mockEntity,pluralize:sinon.spy()}));assert.equal(output.refs.files.children[0].children[0].href,"https://api.jujucharms.com/charmstore/v4/django/archive/foo.zip")});it("renders file urls correctly for charm",function(){mockEntity.set("entityType","charm");mockEntity.set("name","django");mockEntity.set("full_name","wordpress");var output=testUtils.renderIntoDocument(React.createElement(juju.components.EntityFiles,{entityModel:mockEntity,pluralize:sinon.spy()}));assert.equal(output.refs.files.children[0].children[0].href,"https://api.jujucharms.com/charmstore/v4/wordpress/archive/foo.zip")});it("properly builds a tree structure from file paths",function(){var component=new juju.components.EntityFiles;var files=["/foo/bar/baz.zip","/foo/bar/slo.tar.gz","/foo/da.txt","/a.txt","/b.txt"];var expectedTree={foo:{bar:{"baz.zip":null,"slo.tar.gz":null},"da.txt":null},"a.txt":null,"b.txt":null};var actualTree=component._buildFiletree(files);assert.deepEqual(actualTree,expectedTree)})});