"use strict";var juju={components:{}};chai.config.includeStack=true;chai.config.truncateThreshold=0;describe("EnvSwitcher",function(){beforeAll(function(done){YUI().use("env-switcher",function(){done()})});it("renders the closed switcher component",function(){var output=jsTestUtils.shallowRender(React.createElement(juju.components.EnvSwitcher.prototype.wrappedComponent,{showConnectingMask:sinon.stub(),dbEnvironmentSet:sinon.stub(),environmentName:"MyEnv"}));assert.deepEqual(output,React.createElement("div",{className:"env-switcher"},React.createElement("div",{className:"env-switcher--toggle",onClick:output.props.children[0].props.onClick},React.createElement("span",{className:"environment-name"},"MyEnv"),React.createElement(juju.components.SvgIcon,{name:"chevron_down_16",size:"16"})),""))});it("open the list on click",function(){var env={listEnvs:sinon.stub()};var renderer=jsTestUtils.shallowRender(React.createElement(juju.components.EnvSwitcher.prototype.wrappedComponent,{showConnectingMask:sinon.stub(),dbEnvironmentSet:sinon.stub(),env:env}),true);var output=renderer.getRenderOutput();output.props.children[0].props.onClick({preventDefault:function preventDefault(){return null}});renderer.render(React.createElement(juju.components.EnvSwitcher.prototype.wrappedComponent,{showConnectingMask:sinon.stub(),dbEnvironmentSet:sinon.stub(),env:env}));var instance=renderer.getMountedInstance();output=renderer.getRenderOutput();assert.deepEqual(output.props.children[1],React.createElement(juju.components.EnvList,{handleEnvClick:instance.handleEnvClick,createNewEnv:instance.createNewEnv,showUserProfile:instance.showUserProfile,envs:[]}))});it("fetches a list of environments on mount (JEM)",function(){var listEnvs=sinon.stub();var jem={listEnvironments:listEnvs};var renderer=jsTestUtils.shallowRender(React.createElement(juju.components.EnvSwitcher.prototype.wrappedComponent,{showConnectingMask:sinon.stub(),dbEnvironmentSet:sinon.stub(),jem:jem}),true);var instance=renderer.getMountedInstance();instance.componentDidMount();assert.equal(listEnvs.callCount,1);var envData={env:"env"};listEnvs.args[0][0](null,envData);assert.deepEqual(instance.state.envList,envData)});it("fetches a list of environments on mount (JES)",function(){var listEnvs=sinon.stub();var env={listEnvs:listEnvs};var renderer=jsTestUtils.shallowRender(React.createElement(juju.components.EnvSwitcher.prototype.wrappedComponent,{showConnectingMask:sinon.stub(),dbEnvironmentSet:sinon.stub(),env:env}),true);var instance=renderer.getMountedInstance();instance.componentDidMount();assert.equal(listEnvs.callCount,1);var envData={envs:{env:"env"}};listEnvs.args[0][1](envData);assert.deepEqual(instance.state.envList,envData.envs)});it("fetches the env list when opening",function(){var env={listEnvs:sinon.stub()};var renderer=jsTestUtils.shallowRender(React.createElement(juju.components.EnvSwitcher.prototype.wrappedComponent,{showConnectingMask:sinon.stub(),dbEnvironmentSet:sinon.stub(),env:env}),true);var output=renderer.getRenderOutput();var instance=renderer.getMountedInstance();output.props.children[0].props.onClick({preventDefault:function preventDefault(){return null}});assert.equal(env.listEnvs.callCount,1);var envData={envs:[{env:"env"}]};env.listEnvs.args[0][1](envData);assert.deepEqual(instance.state.envList,envData.envs)});it("can call to switch environments",function(){var envs=[{uuid:"abc123",name:"Tardis",user:"The Dr.",password:"buffalo"}];var socketURL="/a/socket/url/abc123";var createSocketURL=sinon.stub().returns(socketURL);var listEnvs=sinon.stub();var switchEnv=sinon.stub();var mask=sinon.stub();var jem={listEnvironments:listEnvs};var app={createSocketURL:createSocketURL,switchEnv:switchEnv};var renderer=jsTestUtils.shallowRender(React.createElement(juju.components.EnvSwitcher.prototype.wrappedComponent,{dbEnvironmentSet:sinon.stub(),showConnectingMask:mask,jem:jem,app:app}),true);var instance=renderer.getMountedInstance();instance.componentDidMount();listEnvs.args[0][0](null,envs);instance.handleEnvClick({currentTarget:{getAttribute:function getAttribute(){return"abc123"}}});assert.equal(mask.callCount,1);assert.equal(switchEnv.callCount,1);assert.deepEqual(instance.state,{showEnvList:false,envList:envs});assert.deepEqual(switchEnv.args[0],[socketURL,envs[0].user,envs[0].password])});function createNewJEMEnvTest(envName){var envs=[{uuid:"abc123",name:"Tardis",user:"The Dr.",password:"buffalo"}];var listEnvs=sinon.stub();var listSrv=sinon.stub();var newEnv=sinon.stub();listSrv.callsArgWith(0,null,[{path:"admin/foo"}]);var jem={listEnvironments:listEnvs,listServers:listSrv,newEnvironment:newEnv};var socketURL="/a/socket/url/abc123";var createSocketURL=sinon.stub().returns(socketURL);var switchEnv=sinon.stub();var app={createSocketURL:createSocketURL,switchEnv:switchEnv};var dbset=sinon.stub();var renderer=jsTestUtils.shallowRender(React.createElement(juju.components.EnvSwitcher.prototype.wrappedComponent,{showConnectingMask:sinon.stub(),dbEnvironmentSet:dbset,jem:jem,app:app}),true);var instance=renderer.getMountedInstance();instance.componentDidMount();listEnvs.args[0][0](null,envs);instance.createNewEnv(envName);assert.equal(newEnv.callCount,1);assert.equal(newEnv.args[0][0],"admin");assert.notEqual(newEnv.args[0][1],undefined);assert.equal(newEnv.args[0][1],envName||"new-env-1");assert.equal(newEnv.args[0][2],"admin/foo");assert.equal(newEnv.args[0][3],"admin/foo");assert.equal(newEnv.args[0][4].length>10,true);var createdEnv={uuid:"123abc",name:"newname"};newEnv.args[0][5](null,createdEnv);assert.equal(listEnvs.callCount,2);envs.push(createdEnv);listEnvs.args[1][0](null,envs);assert.equal(switchEnv.callCount,1);assert.equal(dbset.callCount,1);assert.deepEqual(dbset.args[0],["name","newname"])}it("can call to create a new env (JEM)",function(){createNewJEMEnvTest()});it("can use a custom env name if provided (JEM)",function(){createNewJEMEnvTest("custom-env-name")});it("can call to create a new env (JES)",function(){var envs=[{uuid:"abc123",name:"Tardis",user:"The Dr.",password:"buffalo"}];var listEnvs=sinon.stub();var createEnv=sinon.stub();var env={createEnv:createEnv,listEnvs:listEnvs};var renderer=jsTestUtils.shallowRender(React.createElement(juju.components.EnvSwitcher.prototype.wrappedComponent,{showConnectingMask:sinon.stub(),dbEnvironmentSet:sinon.stub(),env:env}),true);var instance=renderer.getMountedInstance();instance.componentDidMount();listEnvs.args[0][1](envs);instance.createNewEnv();assert.equal(createEnv.callCount,1);assert.equal(createEnv.args[0][0],"new-env-1");assert.equal(createEnv.args[0][1],"user-admin")});it("can call to change the state to the profile",function(){var changeState=sinon.stub();var renderer=jsTestUtils.shallowRender(React.createElement(juju.components.EnvSwitcher.prototype.wrappedComponent,{showConnectingMask:sinon.stub(),dbEnvironmentSet:sinon.stub(),changeState:changeState}),true);var instance=renderer.getMountedInstance();instance.showUserProfile();assert.equal(changeState.callCount,1);assert.deepEqual(changeState.args[0][0],{sectionC:{component:"profile",metadata:{}}})})});