"use strict";var juju={components:{}};chai.config.includeStack=true;chai.config.truncateThreshold=0;describe("InspectorExpose",function(){beforeAll(function(done){YUI().use("inspector-expose",function(){done()})});it("can render correctly if not exposed",function(){var getStub=sinon.stub();getStub.withArgs("id").returns("demo");getStub.withArgs("exposed").returns(false);var service={get:getStub};var toggle={key:"expose-toggle"};var output=jsTestUtils.shallowRender(React.createElement(juju.components.InspectorExpose,{service:service}));var toggleItem=output.props.children[0].props.children;assert.deepEqual(output,React.createElement("div",{className:"inspector-expose"},React.createElement("div",{className:"inspector-expose__control"},React.createElement(juju.components.BooleanConfig,{key:toggle.key,ref:toggle.key,option:toggle,onChange:toggleItem.props.onChange,label:"Expose service",config:false})),React.createElement("p",{className:"inspector-expose__warning"},"Exposing this service may make it publicly accessible from the web"),undefined))});it("can render correctly if exposed",function(){var changeState=sinon.stub();var getStub=sinon.stub();getStub.withArgs("id").returns("demo");getStub.withArgs("exposed").returns(true);var service={get:getStub};var toggle={key:"expose-toggle"};var unitList=[{id:"django/1"},{id:"django/2"}];var units={toArray:sinon.stub().returns(unitList)};var output=jsTestUtils.shallowRender(React.createElement(juju.components.InspectorExpose,{changeState:changeState,units:units,service:service}));var toggleItem=output.props.children[0].props.children;assert.deepEqual(output,React.createElement("div",{className:"inspector-expose"},React.createElement("div",{className:"inspector-expose__control"},React.createElement(juju.components.BooleanConfig,{key:toggle.key,ref:toggle.key,option:toggle,onChange:toggleItem.props.onChange,label:"Expose service",config:true})),React.createElement("p",{className:"inspector-expose__warning"},"Exposing this service may make it publicly accessible from the web"),React.createElement("ul",{className:"inspector-expose__units"},React.createElement(juju.components.InspectorExposeUnit,{key:unitList[0].id,action:output.props.children[2].props.children[0].props.action,unit:unitList[0]}),React.createElement(juju.components.InspectorExposeUnit,{key:unitList[1].id,action:output.props.children[2].props.children[1].props.action,unit:unitList[1]}))))});it("can navigate to a unit",function(){var changeState=sinon.stub();var getStub=sinon.stub();getStub.withArgs("id").returns("demo");getStub.withArgs("exposed").returns(true);var service={get:getStub};var unitList=[{id:"django/1"}];var units={toArray:sinon.stub().returns(unitList)};var output=jsTestUtils.shallowRender(React.createElement(juju.components.InspectorExpose,{changeState:changeState,units:units,service:service}));output.props.children[2].props.children[0].props.action({currentTarget:{getAttribute:sinon.stub().returns("django/1")}});assert.equal(changeState.callCount,1);assert.deepEqual(changeState.args[0][0],{sectionA:{component:"inspector",metadata:{id:"demo",unit:"1",activeComponent:"unit"}}})});it("can expose the service",function(){var changeState=sinon.stub();var exposeService=sinon.stub();var getStub=sinon.stub();getStub.withArgs("id").returns("demo");getStub.withArgs("exposed").returns(false);var service={get:getStub};var output=jsTestUtils.shallowRender(React.createElement(juju.components.InspectorExpose,{changeState:changeState,exposeService:exposeService,service:service}));output.props.children[0].props.children.props.onChange();assert.equal(exposeService.callCount,1);assert.deepEqual(exposeService.args[0][0],"demo")});it("can unexpose the service",function(){var changeState=sinon.stub();var unexposeService=sinon.stub();var getStub=sinon.stub();getStub.withArgs("id").returns("demo");getStub.withArgs("exposed").returns(true);var service={get:getStub};var unitList=[{id:"django/1"}];var units={toArray:sinon.stub().returns(unitList)};var output=jsTestUtils.shallowRender(React.createElement(juju.components.InspectorExpose,{changeState:changeState,unexposeService:unexposeService,units:units,service:service}));output.props.children[0].props.children.props.onChange();assert.equal(unexposeService.callCount,1);assert.deepEqual(unexposeService.args[0][0],"demo")});it("can display a notification if there is an error",function(){var changeState=sinon.stub();var exposeService=sinon.stub().callsArgWith(1,{err:"error"});var addNotification=sinon.stub();var getStub=sinon.stub();getStub.withArgs("id").returns("demo");getStub.withArgs("exposed").returns(false);var service={get:getStub};var output=jsTestUtils.shallowRender(React.createElement(juju.components.InspectorExpose,{changeState:changeState,exposeService:exposeService,addNotification:addNotification,service:service}));output.props.children[0].props.children.props.onChange();assert.equal(addNotification.callCount,1);assert.equal(addNotification.args[0][0].title,"Exposing charm failed")})});