"use strict";var juju={components:{}};var testUtils=React.addons.TestUtils;chai.config.includeStack=true;chai.config.truncateThreshold=0;describe("Inspector",function(){beforeAll(function(done){YUI().use("inspector-component",function(){done()})});it('displays the service overview for the "inspector" state',function(){var service={get:function get(val){if(val==="id"){return"apache2"}return{name:"demo"}}};var appState={sectionA:{metadata:{}}};var clearState=sinon.stub();var destroyService=sinon.stub();var getUnitStatusCounts=sinon.stub();var appPreviousState=sinon.stub();var serviceRelations=sinon.stub();var output=jsTestUtils.shallowRender(React.createElement(juju.components.Inspector,{service:service,destroyService:destroyService,getUnitStatusCounts:getUnitStatusCounts,clearState:clearState,appPreviousState:appPreviousState,appState:appState,serviceRelations:serviceRelations}));var expected=React.createElement(juju.components.ServiceOverview,{changeState:undefined,destroyService:destroyService,getUnitStatusCounts:getUnitStatusCounts,clearState:clearState,service:service,serviceRelations:serviceRelations});assert.deepEqual(output.props.children[1].props.children,expected)});it("displays the unit list when the app state calls for it",function(){var envResolved=sinon.stub();var changeStateStub=sinon.stub();var destroyUnits=sinon.stub();var appPreviousState=sinon.stub();var getStub=sinon.stub();getStub.withArgs("id").returns("demo");getStub.withArgs("units").returns({filterByStatus:sinon.stub().returns([])});var service={get:getStub};var appState={sectionA:{metadata:{activeComponent:"units",units:"error"}}};var output=jsTestUtils.shallowRender(React.createElement(juju.components.Inspector,{service:service,appState:appState,destroyUnits:destroyUnits,envResolved:envResolved,appPreviousState:appPreviousState,changeState:changeStateStub}));var children=output.props.children[1].props.children;assert.deepEqual(children,React.createElement(juju.components.UnitList,{service:service,unitStatus:"error",units:[],envResolved:envResolved,destroyUnits:destroyUnits,changeState:changeStateStub}))});it("displays the configuration when the app state calls for it",function(){var setConfig=sinon.stub();var charm="charm";var getStub=sinon.stub();var changeState=sinon.stub();var getYAMLConfig=sinon.stub();var appPreviousState=sinon.stub();var updateServiceUnitsDisplayname=sinon.stub();var getServiceByName=sinon.stub();var addNotification=sinon.stub();var linkify=sinon.stub();var service={get:getStub};var appState={sectionA:{metadata:{activeComponent:"config"}}};var output=jsTestUtils.shallowRender(React.createElement(juju.components.Inspector,{appState:appState,service:service,changeState:changeState,getYAMLConfig:getYAMLConfig,charm:charm,appPreviousState:appPreviousState,updateServiceUnitsDisplayname:updateServiceUnitsDisplayname,addNotification:addNotification,getServiceByName:getServiceByName,linkify:linkify,setConfig:setConfig}));var children=output.props.children[1].props.children;assert.deepEqual(children,React.createElement(juju.components.Configuration,{service:service,changeState:changeState,getYAMLConfig:getYAMLConfig,charm:charm,setConfig:setConfig,updateServiceUnitsDisplayname:updateServiceUnitsDisplayname,addNotification:addNotification,linkify:linkify,getServiceByName:getServiceByName}))});it("displays the unit details when the app state calls for it",function(){var destroyUnits=sinon.stub();var changeState=sinon.stub();var getStub=sinon.stub();getStub.withArgs("id").returns("demo");getStub.withArgs("units").returns({getById:function getById(){return"unit"}});var service={get:getStub};var appState={sectionA:{metadata:{activeComponent:"unit",unit:"5"}}};var appPreviousState=sinon.stub();var output=jsTestUtils.shallowRender(React.createElement(juju.components.Inspector,{service:service,destroyUnits:destroyUnits,changeState:changeState,appPreviousState:appPreviousState,appState:appState}));var children=output.props.children[1].props.children;assert.deepEqual(children,React.createElement(juju.components.UnitDetails,{destroyUnits:destroyUnits,service:service,changeState:changeState,previousComponent:undefined,unitStatus:null,unit:"unit"}))});it("handles the unit being removed while viewing the unit",function(){var changeState=sinon.stub();var getStub=sinon.stub();getStub.withArgs("id").returns("demo");getStub.withArgs("units").returns({filterByStatus:sinon.stub().returns([])});var service={get:getStub};var appState={sectionA:{metadata:{activeComponent:"units",units:"error"}}};var shallowRenderer=jsTestUtils.shallowRender(React.createElement(juju.components.Inspector,{service:service,appState:appState,destroyUnits:sinon.stub(),envResolved:sinon.stub(),appPreviousState:sinon.stub(),changeState:changeState}),true);var instance=shallowRenderer.getMountedInstance();assert.equal(instance.state.activeComponent,"units");getStub.withArgs("units").returns({getById:function getById(){return}});service={get:getStub};appState={sectionA:{metadata:{activeComponent:"unit",unit:"5"}}};shallowRenderer.render(React.createElement(juju.components.Inspector,{service:service,appState:appState,destroyUnits:sinon.stub(),envResolved:sinon.stub(),appPreviousState:sinon.stub(),changeState:sinon.stub()}));assert.equal(instance.state.activeComponent,"units");assert.equal(changeState.callCount,1);assert.deepEqual(changeState.args[0][0],{sectionA:{component:"inspector",metadata:{id:"demo",activeComponent:"units",unit:null,unitStatus:null}}})});it("can go back from the unit details to a status list",function(){var destroyUnits=sinon.stub();var changeState=sinon.stub();var getStub=sinon.stub();getStub.withArgs("id").returns("demo");getStub.withArgs("units").returns({getById:function getById(){return"unit"}});var service={get:getStub};var appState={sectionA:{metadata:{activeComponent:"unit",unit:"5"}}};var appPreviousState={sectionA:{metadata:{activeComponent:"units",units:"error",id:"demo"}}};var output=jsTestUtils.shallowRender(React.createElement(juju.components.Inspector,{service:service,destroyUnits:destroyUnits,changeState:changeState,appPreviousState:appPreviousState,appState:appState}));output.props.children[0].props.backCallback();assert.equal(changeState.callCount,1);assert.deepEqual(changeState.args[0][0],{sectionA:{component:"inspector",metadata:{id:"demo",activeComponent:"units",unit:null,unitStatus:"error"}}})});it("defaults to go back from the unit details to the all list",function(){var destroyUnits=sinon.stub();var changeState=sinon.stub();var getStub=sinon.stub();getStub.withArgs("id").returns("demo");getStub.withArgs("units").returns({getById:function getById(){return"unit"}});var service={get:getStub};var appState={sectionA:{metadata:{activeComponent:"unit",unit:"5"}}};var appPreviousState={};var output=jsTestUtils.shallowRender(React.createElement(juju.components.Inspector,{service:service,destroyUnits:destroyUnits,changeState:changeState,appPreviousState:appPreviousState,appState:appState}));output.props.children[0].props.backCallback();assert.equal(changeState.callCount,1);assert.deepEqual(changeState.args[0][0],{sectionA:{component:"inspector",metadata:{id:"demo",activeComponent:"units",unit:null,unitStatus:null}}})});it("goes back to the previous service from unit details",function(){var destroyUnits=sinon.stub();var changeState=sinon.stub();var getStub=sinon.stub();getStub.withArgs("id").returns("demo");getStub.withArgs("units").returns({getById:function getById(){return"unit"}});var service={get:getStub};var appState={sectionA:{metadata:{activeComponent:"unit",unit:"5"}}};var appPreviousState={sectionA:{metadata:{id:"previousService",units:true}}};var output=jsTestUtils.shallowRender(React.createElement(juju.components.Inspector,{service:service,destroyUnits:destroyUnits,changeState:changeState,appPreviousState:appPreviousState,appState:appState}));output.props.children[0].props.backCallback();assert.equal(changeState.callCount,1);assert.deepEqual(changeState.args[0][0],{sectionA:{component:"inspector",metadata:{id:"previousService",activeComponent:"units",unit:null,unitStatus:null}}})});it("displays the Scale Service when the app state calls for it",function(){var appPreviousState=sinon.stub();var getStub=sinon.stub();getStub.withArgs("id").returns("demo");var service={get:getStub};var appState={sectionA:{metadata:{activeComponent:"scale"}}};var output=jsTestUtils.shallowRender(React.createElement(juju.components.Inspector,{service:service,appPreviousState:appPreviousState,appState:appState}));var children=output.props.children[1].props.children;assert.deepEqual(children,React.createElement(juju.components.ScaleService,{serviceId:service.get("id"),addGhostAndEcsUnits:children.props.addGhostAndEcsUnits,createMachinesPlaceUnits:children.props.createMachinesPlaceUnits,changeState:children.props.changeState}))});it("displays Expose when the app state calls for it",function(){var addNotification=sinon.stub();var changeState=sinon.stub();var exposeService=sinon.stub();var unexposeService=sinon.stub();var service=sinon.stub();var units=sinon.stub();var appPreviousState=sinon.stub();var getStub=sinon.stub();getStub.withArgs("id").returns("demo");getStub.withArgs("units").returns(units);var service={get:getStub};var appState={sectionA:{metadata:{activeComponent:"expose"}}};var output=jsTestUtils.shallowRender(React.createElement(juju.components.Inspector,{addNotification:addNotification,changeState:changeState,exposeService:exposeService,unexposeService:unexposeService,service:service,appPreviousState:appPreviousState,appState:appState}));var children=output.props.children[1].props.children;assert.deepEqual(children,React.createElement(juju.components.InspectorExpose,{addNotification:addNotification,changeState:changeState,exposeService:exposeService,unexposeService:unexposeService,service:service,units:units}))});it("displays Relations when the app state calls for it",function(){var changeState=sinon.stub();var service=sinon.stub();var appPreviousState=sinon.stub();var getStub=sinon.stub();getStub.withArgs("id").returns("demo");var service={get:getStub};var appState={sectionA:{metadata:{activeComponent:"relations"}}};var serviceRelations=sinon.stub();var output=jsTestUtils.shallowRender(React.createElement(juju.components.Inspector,{changeState:changeState,service:service,appPreviousState:appPreviousState,appState:appState,serviceRelations:serviceRelations}));var children=output.props.children[1].props.children;assert.deepEqual(children,React.createElement(juju.components.InspectorRelations,{changeState:changeState,service:service,serviceRelations:serviceRelations}))});it("displays Change versions when the app state calls for it",function(){var addNotification=sinon.stub();var changeState=sinon.stub();var service=sinon.stub();var setCharm=sinon.stub();var getCharm=sinon.stub();var getAvailableVersions=sinon.stub();var appPreviousState=sinon.stub();var getStub=sinon.stub();getStub.withArgs("id").returns("demo");getStub.withArgs("charm").returns("cs:demo");var service={get:getStub};var appState={sectionA:{metadata:{activeComponent:"change-version"}}};var output=jsTestUtils.shallowRender(React.createElement(juju.components.Inspector,{addNotification:addNotification,changeState:changeState,setCharm:setCharm,getCharm:getCharm,getAvailableVersions:getAvailableVersions,appPreviousState:appPreviousState,service:service,appState:appState}));var children=output.props.children[1].props.children;assert.deepEqual(children,React.createElement(juju.components.InspectorChangeVersion,{addNotification:addNotification,changeState:changeState,charmId:"cs:demo",service:service,setCharm:setCharm,getCharm:getCharm,getAvailableVersions:getAvailableVersions}))});it("passes changeState callable to header component",function(){var appPreviousState=sinon.stub();var service={get:function get(val){if(val==="id"){return"apache2"}return{name:"demo"}}};var appState={sectionA:{metadata:{}}};var changeStub=sinon.stub();var shallowRenderer=testUtils.createRenderer();shallowRenderer.render(React.createElement(juju.components.Inspector,{changeState:changeStub,appState:appState,appPreviousState:appPreviousState,service:service}));var output=shallowRenderer.getRenderOutput();output.props.children[0].props.backCallback();assert.equal(changeStub.callCount,1);assert.deepEqual(changeStub.args[0][0],{sectionA:{component:"services",metadata:null}})});it("can navigate back to the inspector from a service",function(){var appPreviousState={sectionA:{metadata:{activeComponent:"relations",id:"service2"}}};var service={get:function get(val){if(val==="id"){return"apache2"}return{name:"demo"}}};var appState={sectionA:{metadata:{}}};var changeStub=sinon.stub();var shallowRenderer=testUtils.createRenderer();shallowRenderer.render(React.createElement(juju.components.Inspector,{changeState:changeStub,appState:appState,appPreviousState:appPreviousState,service:service}));var output=shallowRenderer.getRenderOutput();output.props.children[0].props.backCallback();assert.equal(changeStub.callCount,1);assert.deepEqual(changeStub.args[0][0],{sectionA:{component:"inspector",metadata:{id:"service2",activeComponent:"relations"}}})});it("does not go back to the inspector from the same service",function(){var appPreviousState={sectionA:{metadata:{activeComponent:"relations",id:"demo"}}};var getStub=sinon.stub();getStub.withArgs("id").returns("demo");getStub.withArgs("name").returns("demo");var service={get:getStub};var appState={sectionA:{metadata:{}}};var changeStub=sinon.stub();var shallowRenderer=testUtils.createRenderer();shallowRenderer.render(React.createElement(juju.components.Inspector,{changeState:changeStub,appState:appState,appPreviousState:appPreviousState,service:service}));var output=shallowRenderer.getRenderOutput();output.props.children[0].props.backCallback();assert.equal(changeStub.callCount,1);assert.deepEqual(changeStub.args[0][0],{sectionA:{component:"services",metadata:null}})});it("passes a title to the header component",function(){var appPreviousState=sinon.stub();var service={get:function get(){return"demo"}};var appState={sectionA:{metadata:{}}};var changeStub=sinon.stub();var shallowRenderer=testUtils.createRenderer();shallowRenderer.render(React.createElement(juju.components.Inspector,{changeState:changeStub,appState:appState,appPreviousState:appPreviousState,service:service}));var output=shallowRenderer.getRenderOutput();assert.deepEqual(output.props.children[0],React.createElement(juju.components.InspectorHeader,{backCallback:output.props.children[0].props.backCallback,activeComponent:undefined,count:undefined,type:undefined,title:"demo"}))});it("passes the type to the header component",function(){var appPreviousState=sinon.stub();var service={get:sinon.stub().returns({filterByStatus:sinon.stub().returns([])})};var appState={sectionA:{metadata:{id:"django",activeComponent:"units",units:"error"}}};var changeStub=sinon.stub();var shallowRenderer=testUtils.createRenderer();shallowRenderer.render(React.createElement(juju.components.Inspector,{changeState:changeStub,appState:appState,appPreviousState:appPreviousState,service:service}));var output=shallowRenderer.getRenderOutput();assert.deepEqual(output.props.children[0],React.createElement(juju.components.InspectorHeader,{backCallback:output.props.children[0].props.backCallback,count:0,activeComponent:"units",type:"error",title:"Units"}))});it("displays the service overview when switching services",function(){var appPreviousState={sectionA:{metadata:{activeComponent:"relations",id:"service2"}}};var service={get:function get(val){if(val==="id"){return"apache2"}return{name:"demo"}}};var appState={sectionA:{metadata:{}}};var changeStub=sinon.stub();var shallowRenderer=testUtils.createRenderer();shallowRenderer.render(React.createElement(juju.components.Inspector,{changeState:changeStub,appState:appState,appPreviousState:appPreviousState,service:service}));shallowRenderer.getRenderOutput();assert.equal(changeStub.callCount,0);service={get:function get(val){if(val==="id"){return"django"}return{name:"demo"}}};shallowRenderer.render(React.createElement(juju.components.Inspector,{changeState:changeStub,appState:appState,appPreviousState:appPreviousState,service:service}));shallowRenderer.getRenderOutput();assert.equal(changeStub.callCount,1);assert.deepEqual(changeStub.args[0][0],{sectionA:{component:"inspector",metadata:{id:"django",activeComponent:undefined,unit:null,unitStatus:null}}})})});