"use strict";var juju={components:{}};var testUtils=React.addons.TestUtils;describe("MachineViewAddMachine",function(){beforeAll(function(done){YUI().use("machine-view-add-machine",function(){done()})});it("can render for creating a machine",function(){var close=sinon.stub();var createMachine=sinon.stub();var renderer=jsTestUtils.shallowRender(React.createElement(juju.components.MachineViewAddMachine,{close:close,createMachine:createMachine}),true);var instance=renderer.getMountedInstance();var output=renderer.getRenderOutput();var buttons=[{title:"Cancel",action:close},{title:"Create",action:instance._submitForm,type:"confirm"}];var expected=React.createElement("div",{className:"add-machine"},React.createElement("div",{className:"add-machine__constraints",key:"constraints"},React.createElement("h4",{className:"add-machine__title"},"Define constraints"),React.createElement(juju.components.Constraints,{valuesChanged:instance._updateConstraints})),React.createElement(juju.components.ButtonRow,{buttons:buttons,key:"buttons"}));assert.deepEqual(output,expected)});it("can render for creating a container",function(){var close=sinon.stub();var createMachine=sinon.stub();var renderer=jsTestUtils.shallowRender(React.createElement(juju.components.MachineViewAddMachine,{close:close,createMachine:createMachine,parentId:"new0"}),true);var instance=renderer.getMountedInstance();var output=renderer.getRenderOutput();var buttons=[{title:"Cancel",action:close},{title:"Create",action:instance._submitForm,type:"confirm"}];var expected=React.createElement("div",{className:"add-machine"},React.createElement("select",{className:"add-machine__container",defaultValue:"",key:"containers",onChange:instance._updateSelectedContainer},React.createElement("option",{disabled:true,value:""},"Choose container type..."),undefined,React.createElement("option",{value:"lxc"},"LXC"),React.createElement("option",{value:"kvm"},"KVM")),React.createElement(juju.components.ButtonRow,{buttons:buttons,key:"buttons"}));assert.deepEqual(output,expected)});it("can render for selecting a machine",function(){var close=sinon.stub();var createMachine=sinon.stub();var unit={};var machines={filterByParent:sinon.stub().returns([{id:"new0",displayName:"new0"},{id:"new1",displayName:"new1"},{id:"new2",deleted:true,displayName:"new2"}])};var renderer=jsTestUtils.shallowRender(React.createElement(juju.components.MachineViewAddMachine,{close:close,createMachine:createMachine,machines:machines,parentId:"new0",unit:unit}),true);var instance=renderer.getMountedInstance();var output=renderer.getRenderOutput();var expected=React.createElement("select",{defaultValue:"",key:"machines",onChange:instance._updateSelectedMachine},React.createElement("option",{disabled:true,value:""},"Move to..."),React.createElement("option",{value:"new"},"New machine"),[React.createElement("option",{key:"new0",value:"new0"},"new0"),React.createElement("option",{key:"new1",value:"new1"},"new1")]);assert.deepEqual(output.props.children[0],expected)});it("can render for selecting a container",function(){var close=sinon.stub();var createMachine=sinon.stub();var unit={};var machines={filterByParent:sinon.stub().returns([{id:"new0/lxc/new0",displayName:"new0/lxc/new0"},{id:"new0/lxc/new1",displayName:"new0/lxc/new1"},{id:"new0/lxc/new2",deleted:true,displayName:"new0/lxc/new2"}])};var renderer=jsTestUtils.shallowRender(React.createElement(juju.components.MachineViewAddMachine,{close:close,createMachine:createMachine,machines:machines,unit:unit}),true);var instance=renderer.getMountedInstance();instance._updateSelectedMachine({currentTarget:{value:"new0"}});var output=renderer.getRenderOutput();var expected=React.createElement("select",{className:"add-machine__container",defaultValue:"",key:"containers",onChange:instance._updateSelectedContainer},React.createElement("option",{disabled:true,value:""},"Choose container type..."),[React.createElement("option",{key:"root",value:"new0"},"new0","/root-container"),React.createElement("option",{key:"new0/lxc/new0",value:"new0/lxc/new0"},"new0/lxc/new0"),React.createElement("option",{key:"new0/lxc/new1",value:"new0/lxc/new1"},"new0/lxc/new1")],React.createElement("option",{value:"lxc"},"LXC"),React.createElement("option",{value:"kvm"},"KVM"));assert.deepEqual(output.props.children[1],expected)});it("can call the cancel method",function(){var close=sinon.stub();var createMachine=sinon.stub();var renderer=jsTestUtils.shallowRender(React.createElement(juju.components.MachineViewAddMachine,{close:close,createMachine:createMachine}),true);var output=renderer.getRenderOutput();output.props.children[1].props.buttons[0].action();assert.equal(close.callCount,1)});it("can create a machine",function(){var close=sinon.stub();var createMachine=sinon.stub();var renderer=jsTestUtils.shallowRender(React.createElement(juju.components.MachineViewAddMachine,{close:close,createMachine:createMachine}),true);var instance=renderer.getMountedInstance();var output=renderer.getRenderOutput();output.props.children[1].props.buttons[1].action();assert.equal(createMachine.callCount,1);assert.equal(createMachine.args[0][0],null);assert.equal(createMachine.args[0][1],null);assert.equal(createMachine.args[0][2],instance.state.constraints)});it("can create a container",function(){var close=sinon.stub();var createMachine=sinon.stub();var output=testUtils.renderIntoDocument(React.createElement(juju.components.MachineViewAddMachine,{close:close,createMachine:createMachine,parentId:"new0"}));var outputNode=ReactDOM.findDOMNode(output);var selectNode=outputNode.querySelector(".add-machine__container");selectNode.value="lxc";testUtils.Simulate.change(selectNode);testUtils.Simulate.click(outputNode.querySelector(".generic-button--type-confirm"));assert.equal(createMachine.callCount,1);assert.equal(createMachine.args[0][0],"lxc");assert.equal(createMachine.args[0][1],"new0")});it("can place a unit on a new machine",function(){var close=sinon.stub();var createMachine=sinon.stub().returns({id:"new0"});var machines={filterByParent:sinon.stub().returns([])};var placeUnit=sinon.stub();var unit={id:"unit1"};var renderer=jsTestUtils.shallowRender(React.createElement(juju.components.MachineViewAddMachine,{close:close,createMachine:createMachine,machines:machines,parentId:"new0",placeUnit:placeUnit,unit:unit}),true);var instance=renderer.getMountedInstance();instance.state={selectedMachine:"new"};instance._submitForm();assert.equal(createMachine.callCount,1);assert.equal(createMachine.args[0][0],null);assert.equal(createMachine.args[0][1],null);assert.equal(createMachine.args[0][2],instance.state.constraints);assert.equal(placeUnit.callCount,1);assert.deepEqual(placeUnit.args[0][0],{id:"unit1"});assert.equal(placeUnit.args[0][1],"new0")});it("can place a unit on a new container",function(){var close=sinon.stub();var createMachine=sinon.stub().returns({id:"new0/lxc/new1"});var machines={filterByParent:sinon.stub().returns([])};var placeUnit=sinon.stub();var unit={id:"unit1"};var renderer=jsTestUtils.shallowRender(React.createElement(juju.components.MachineViewAddMachine,{close:close,createMachine:createMachine,machines:machines,parentId:"new0",placeUnit:placeUnit,unit:unit}),true);var instance=renderer.getMountedInstance();instance.state={selectedContainer:"lxc"};instance._submitForm();assert.equal(createMachine.callCount,1);assert.equal(createMachine.args[0][0],"lxc");assert.equal(createMachine.args[0][1],"new0");assert.equal(createMachine.args[0][2],instance.state.constraints);assert.equal(placeUnit.callCount,1);assert.deepEqual(placeUnit.args[0][0],{id:"unit1"});assert.equal(placeUnit.args[0][1],"new0/lxc/new1")});it("can place a unit on an existing machine",function(){var close=sinon.stub();var createMachine=sinon.stub().returns({id:"new0"});var machines={filterByParent:sinon.stub().returns([])};var placeUnit=sinon.stub();var unit={id:"unit1"};var renderer=jsTestUtils.shallowRender(React.createElement(juju.components.MachineViewAddMachine,{close:close,createMachine:createMachine,machines:machines,parentId:"new0",placeUnit:placeUnit,unit:unit}),true);var instance=renderer.getMountedInstance();instance.state={selectedMachine:"new0",selectedContainer:"new0"};instance._submitForm();assert.equal(createMachine.callCount,0);assert.equal(placeUnit.callCount,1);assert.deepEqual(placeUnit.args[0][0],{id:"unit1"});assert.equal(placeUnit.args[0][1],"new0")});it("can place a unit on an existing container",function(){var close=sinon.stub();var createMachine=sinon.stub().returns({id:"new0"});var machines={filterByParent:sinon.stub().returns([])};var placeUnit=sinon.stub();var unit={id:"unit1"};var renderer=jsTestUtils.shallowRender(React.createElement(juju.components.MachineViewAddMachine,{close:close,createMachine:createMachine,machines:machines,parentId:"new0",placeUnit:placeUnit,unit:unit}),true);var instance=renderer.getMountedInstance();instance.state={selectedMachine:"new0",selectedContainer:"new0/lxc/new0"};instance._submitForm();assert.equal(createMachine.callCount,0);assert.equal(placeUnit.callCount,1);assert.deepEqual(placeUnit.args[0][0],{id:"unit1"});assert.equal(placeUnit.args[0][1],"new0/lxc/new0")});it("can select a machine when created",function(){var close=sinon.stub();var createMachine=sinon.stub().returns({id:"new0"});var machines={filterByParent:sinon.stub().returns([])};var placeUnit=sinon.stub();var selectMachine=sinon.stub();var unit={id:"unit1"};var renderer=jsTestUtils.shallowRender(React.createElement(juju.components.MachineViewAddMachine,{close:close,createMachine:createMachine,machines:machines,parentId:"new0",placeUnit:placeUnit,selectMachine:selectMachine,unit:unit}),true);var instance=renderer.getMountedInstance();instance.state={selectedMachine:"new"};instance._submitForm();assert.equal(selectMachine.callCount,1);assert.equal(selectMachine.args[0][0],"new0")});it("does not select a container when created",function(){var close=sinon.stub();var createMachine=sinon.stub().returns({id:"new0/lxc/new1"});var machines={filterByParent:sinon.stub().returns([])};var placeUnit=sinon.stub();var selectMachine=sinon.stub();var unit={id:"unit1"};var renderer=jsTestUtils.shallowRender(React.createElement(juju.components.MachineViewAddMachine,{close:close,createMachine:createMachine,machines:machines,parentId:"new0",placeUnit:placeUnit,selectMachine:selectMachine,unit:unit}),true);var instance=renderer.getMountedInstance();instance.state={selectedContainer:"lxc"};instance._submitForm();assert.equal(selectMachine.callCount,0)})});