"use strict";YUI.add("juju-charm-models",function(Y){var models=Y.namespace("juju.models");var charmIdRe=/^(?:(\w+):)?(?:~([\w-\.]+)\/)?(?:(\w+)\/)?([\w-\.]+?)(?:-(\d+|HEAD))?$/;var idElements=["scheme","owner","series","package_name","revision"];var simpleCharmIdRe=/^(?:(\w+):)?(?!:~)(\w+)$/;var simpleIdElements=["scheme","package_name"];var parseCharmId=models.parseCharmId=function(charmId,defaultSeries){if(typeof charmId==="string"){var parts=charmIdRe.exec(charmId);var pairs;if(parts){parts.shift();pairs=Y.Array.zip(idElements,parts)}else if(defaultSeries){parts=simpleCharmIdRe.exec(charmId);if(parts){parts.shift();pairs=Y.Array.zip(simpleIdElements,parts);pairs.push(["series",defaultSeries])}}if(parts){var result={},storeId;Y.Array.map(pairs,function(pair){result[pair[0]]=pair[1]});storeId=[result.series,result.package_name+(result.revision?"-"+result.revision:"")];if(result.owner){storeId.unshift("~"+result.owner)}result.storeId=storeId.join("/");return result}}};var unsetIfNoValue=function unsetIfNoValue(val){if(!val||Y.Object.size(val)===0){return null}else{return val}};models.charmIdRe=charmIdRe;models.Charm=Y.Base.create("browser-charm",Y.Model,[models.EntityExtension],{_parseRelations:function _parseRelations(attr){var relations=this.get("relations");if(relations&&relations[attr]){return relations[attr]}else{return null}},initializer:function initializer(cfg){if(cfg){if(cfg.downloads_in_past_30_days){this.set("recent_download_count",cfg.downloads_in_past_30_days)}if(cfg.id){this.set("storeId",cfg.id)}if(cfg.url){this.set("id",cfg.url)}}var id=this.get("id"),parts=parseCharmId(id);if(!parts){throw"Developers must initialize charms with a well-formed id."}this.loaded=false;this.on("load",function(){this.loaded=true});Y.Object.each(parts,function(value,key){this.set(key,value)},this)},sync:function sync(action,options,callback){if(action!=="read"){throw'Only use the "read" action; "'+action+'" not supported.'}if(Y.Lang.isValue(options.get_charm)){options.get_charm(this.get("id"),function(response){if(response.err){callback(true,response)}else if(response.result){callback(false,response.result)}else{callback(true,response)}})}else{throw"You must supply a get_charm function."}},parse:function parse(response){var data=models.Charm.superclass.parse.apply(this,arguments),self=this;if(data.config){data.options=data.config.options;data.relations={requires:data.requires,provides:data.provides};data.is_subordinate=data.subordinate;delete data.config;delete data.subordinate;delete data.requires;delete data.provides}Y.each(data,function(value,key){if(!Y.Lang.isValue(value)||!self.attrAdded(key)||Y.Lang.isValue(self.get(key))){delete data[key]}});if(data.owner==="charmers"){delete data.owner}return data},compare:function compare(other,relevance,otherRelevance){var owner=this.get("owner"),otherOwner=other.get("owner");if(!owner&&otherOwner){return-1}else if(owner&&!otherOwner){return 1}else if(relevance&&relevance!==otherRelevance){return otherRelevance-relevance}else{return this.get("package_name").localeCompare(other.get("package_name"))||(owner?owner.localeCompare(otherOwner):0)||this.get("revision")-other.get("revision")}},_processRelatedCharms:function _processRelatedCharms(relatedCharms){var provides,requires;if(relatedCharms.provides){provides=this._dedupeRelatedCharms(relatedCharms.provides)}if(relatedCharms.requires){requires=this._dedupeRelatedCharms(relatedCharms.requires)}return{all:relatedCharms,provides:provides,requires:requires}},_dedupeRelatedCharms:function _dedupeRelatedCharms(charmList){var names=Object.keys(charmList);var collection={};names.forEach(function(name){var indexes=Object.keys(charmList[name]);var charms=this._splitIntoCharmCollections(indexes,name,charmList);charms=this._keepLatestRevision(charms);collection[name]=charms},this);return collection},_splitIntoCharmCollections:function _splitIntoCharmCollections(indexes,name,charmList){var charms={};indexes.forEach(function(index){var id=charmList[name][index].id;var charm=id.replace("cs:","").split("-").slice(0,-1).join("-");if(charms[charm]){charms[charm].push(id)}else{charms[charm]=[id]}});return this._keepTopThreeCharms(charms)},_keepTopThreeCharms:function _keepTopThreeCharms(charms){var keys=Object.keys(charms);var length=keys.length;if(length>3){for(var i=3;i<keys.length;i+=1){delete charms[keys[i]]}}return charms},_keepLatestRevision:function _keepLatestRevision(charms){var keys=Object.keys(charms);var ids={};keys.forEach(function(key){var keepId="";var keepRevno;charms[key].forEach(function(id){var revno=parseInt(id.split("-").pop(),10);if(keepRevno===undefined||revno>keepRevno){keepId=id;keepRevno=revno}});ids[key]=keepId});return ids}},{entityType:"charm",ATTRS:{id:{validator:function validator(val){return Y.Lang.isString(val)&&!!charmIdRe.exec(val)}},storeId:{validator:function validator(val){return Y.Lang.isString(val)&&!!charmIdRe.exec(val)}},bzr_branch:{},categories:{value:[]},changelog:{value:{}},charm_path:{getter:function getter(){var owner=this.get("owner");var revision=this.get("revision");revision=Y.Lang.isValue(revision)?"-"+revision:"";return[owner?"~"+owner:"charms",this.get("series"),this.get("package_name")+revision,"json"].filter(function(val){return val}).join("/")}},code_source:{},commitCount:{valueFn:function valueFn(){var revisions=this.get("revisions");if(revisions){return Object.keys(revisions).length}}},date_created:{},description:{},providers:{valueFn:function valueFn(){var failures=[],successes=[],providers=this.get("tested_providers");Y.Object.each(providers,function(value,key){if(value!=="SUCCESS"){failures.push(key)}else{successes.push(key)}});if(failures.length>0||successes.length>0){return{successes:successes,failures:failures}}else{return null}}},downloads:{value:0},files:{value:[],setter:function setter(value){if(Y.Lang.isArray(value)){value.sort(function(a,b){var segments=[a,b].map(function(path){var segs=path.split("/");if(segs.length===1){segs.unshift("")}return segs});var maxLength=Math.max(segments[0].length,segments[1].length);for(var i=0;i<maxLength;i+=1){var segmentA=segments[0][i];var segmentB=segments[1][i];if(segmentA===undefined){return-1}else if(segmentB===undefined){return 1}else{var result=segmentA.localeCompare(segmentB,undefined,{sensitivity:"accent"})||segmentA.localeCompare(segmentB);if(result){return result}}}return 0})}}},full_name:{getter:function getter(){var tmp=[this.get("series"),this.get("package_name")],owner=this.get("owner");if(owner){tmp.unshift("~"+owner)}return tmp.join("/")}},shouldShowIcon:{valueFn:function valueFn(){var files=this.get("files")||[];if(!Y.Lang.isArray(files)){files=Object.keys(files)}if(files.indexOf("icon.svg")!==-1&&this.get("is_approved")){return true}else{return false}}},is_approved:{},is_subordinate:{},maintainer:{},metadata:{},name:{},options:{setter:unsetIfNoValue},owner:{},peers:{},proof:{},provides:{getter:function getter(value,key){return this._parseRelations(key)}},rating_numerator:{},rating_denominator:{},recent_download_count:{value:0},relatedCharms:{setter:"_processRelatedCharms"},relations:{},requires:{getter:function getter(value,key){return this._parseRelations(key)}},revision:{setter:function setter(val){if(val){return parseInt(val,10)}}},scheme:{value:"cs",setter:function setter(val){if(!Y.Lang.isValue(val)){val="cs"}return val}},series:{},summary:{},tested_providers:{},url:{},iconPath:{getter:function getter(){var owner=this.get("owner");var revision=this.get("revision");revision=Y.Lang.isValue(revision)?"-"+revision:"";return[owner?"~"+owner:"",this.get("series"),this.get("package_name")+revision,"icon.svg"].join("/")}}}});models.CharmList=Y.Base.create("browserCharmList",Y.ModelList,[],{model:models.Charm,find:function find(charmId,defaultSeries){var result=this.getById(charmId);var partial=charmId;if(result){return result}if(/^(cs:|local:)/.exec(partial)!==null){partial=partial.slice(partial.indexOf(":")+1)}if(charmId.indexOf("/")===-1&&defaultSeries){partial=defaultSeries+"/"+partial}if(/\-\d+$/.exec(partial)){partial=partial.slice(0,partial.indexOf("-"))}result=this.filter(function(charm){return charm.get("full_name")===partial});if(result.length===1){return result[0]}return null},addFromCharmData:function addFromCharmData(metadata,series,revision,scheme,options){var id=series+"/"+metadata.name+"-"+revision;var url=scheme+":"+id;var data={categories:metadata.categories,description:metadata.description,distro_series:series,is_subordinate:metadata.subordinate,name:metadata.name,options:options,relations:{provides:metadata.provides,requires:metadata.requires,peers:metadata.peers},revision:revision,summary:metadata.summary};var charm=this.getById(url);if(charm){charm.setAttrs(data);return charm}data.id=id;data.url=url;return this.add(data)}},{ATTRS:{}});models.validateCharmMetadata=function(metadata){var errors=[];["name","summary","description"].forEach(function(name){var value=metadata[name]||"";var stringValue=value+"";if(!stringValue.trim()){errors.push("missing "+name)}});return errors}},"0.1.0",{requires:["model","model-list","entity-extension"]});