"use strict";YUI.add("juju-delta-handlers",function(Y){var models=Y.namespace("juju.models");var utils={cleanUpEntityTags:function cleanUpEntityTags(tag){var result=tag.replace(/^(service|unit|machine|environment)-/,"");if(!result){return tag}var unitPrefix="unit-";if(tag.slice(0,unitPrefix.length)===unitPrefix){result=result.replace(/-(\d+)$/,"/$1")}return result},convertOpenPorts:function convertOpenPorts(ports){if(!ports){return[]}return Y.Array.map(ports,function(port){return port.Number+"/"+port.Protocol})},createEndpoints:function createEndpoints(endpoints){return Y.Array.map(endpoints,function(endpoint){var relation=endpoint.Relation,data={role:relation.Role,name:relation.Name};return[endpoint.ServiceName,data]})},convertConstraints:function convertConstraints(constraints){var result=constraints||{};var tags=result.tags||[];delete result.tags;if(tags.length){result.tags=tags.join(",")}return result}};models.utils=utils;var serviceChangedHooks=Object.create(null);models._serviceChangedHooks=serviceChangedHooks;models.handlers={defaultHandler:function defaultHandler(db,action,change,kind){console.error("Unknown delta type: "+kind);console.log(action,change)},unitInfo:function unitInfo(db,action,change){var unitData={id:change.Name,charmUrl:change.CharmURL,service:change.Service,machine:change.MachineId,agent_state:change.Status,agent_state_info:change.StatusInfo,agent_state_data:change.StatusData,public_address:change.PublicAddress,private_address:change.PrivateAddress,open_ports:utils.convertOpenPorts(change.Ports),subordinate:change.Subordinate};var machineData={id:change.MachineId,public_address:change.PublicAddress};db.units.process_delta(action,unitData,db);if(machineData.id){db.machines.process_delta("change",machineData,db)}},serviceInfo:function serviceInfo(db,action,change){var data={id:change.Name,name:change.Name,charm:change.CharmURL,exposed:change.Exposed,life:change.Life,constraints:utils.convertConstraints(change.Constraints),subordinate:change.Subordinate};db.services.process_delta(action,data);if(action!=="remove"){db.services.getById(change.Name).updateConfig(change.Config);var hooks=serviceChangedHooks[change.Name]||[];hooks.forEach(function(hook){hook()})}delete serviceChangedHooks[change.Name]},remoteserviceInfo:function remoteserviceInfo(db,action,change){var status=change.Status||{};var data={id:change.ServiceURL,service:change.Name,sourceId:change.EnvUUID,life:change.Life,status:{current:status.Current,message:status.Message,data:status.Data,since:status.Since}};db.remoteServices.process_delta(action,data)},relationInfo:function relationInfo(db,action,change){var endpoints=change.Endpoints;var firstEndpoint=endpoints[0];var firstRelation=firstEndpoint.Relation;var data={id:change.Key,interface:firstRelation.Interface,scope:firstRelation.Scope,endpoints:utils.createEndpoints(endpoints)};var processRelation=function processRelation(){db.relations.process_delta(action,data,db)};var serviceName=firstEndpoint.ServiceName;if(!db.services.getById(serviceName)){console.log("relation change",change.Key,"delayed, waiting for missing service",serviceName);var hooks=serviceChangedHooks[serviceName]||[];hooks.push(processRelation);serviceChangedHooks[serviceName]=hooks;return}processRelation()},machineInfo:function machineInfo(db,action,change){var addresses=change.Addresses||[];var data={id:change.Id,addresses:addresses.map(function(address){return{name:address.NetworkName,scope:address.NetworkScope,type:address.Type,value:address.Value}}),instance_id:change.InstanceId,agent_state:change.Status,agent_state_info:change.StatusInfo,agent_state_data:change.StatusData,hardware:{},jobs:change.Jobs,life:change.Life,series:change.Series,supportedContainers:null};var hardwareCharacteristics=change.HardwareCharacteristics;if(hardwareCharacteristics){data.hardware={arch:hardwareCharacteristics.Arch,cpuCores:hardwareCharacteristics.CpuCores,cpuPower:hardwareCharacteristics.CpuPower,mem:hardwareCharacteristics.Mem,disk:hardwareCharacteristics.RootDisk}}if(change.SupportedContainersKnown){data.supportedContainers=change.SupportedContainers}db.machines.process_delta(action,data)},annotationInfo:function annotationInfo(db,action,change){var tag=change.Tag,kind=tag.split("-")[0],id=utils.cleanUpEntityTags(tag),instance;if(kind==="environment"){instance=db.environment}else{instance=db.resolveModelByName(id)}if(!instance){return}models.setAnnotations(instance,change.Annotations,true);if(instance.name==="serviceUnit"){var service=db.services.getById(instance.service);if(service){var serviceUnits=service.get("units");if(serviceUnits){var nestedInstance=serviceUnits.getById(id);models.setAnnotations(nestedInstance,change.Annotations,true)}}}}}},"0.1.0",{requires:["base","array-extras"]});