"use strict";YUI.add("juju-models",function(Y){var models=Y.namespace("juju.models"),utils=Y.namespace("juju.views.utils"),environments=Y.namespace("juju.environments"),handlers=models.handlers;var ALIVE="alive";var DYING="dying";var JUJU_GUI_SERVICE_NAME="juju-gui";var _process_delta=function _process_delta(list,action,change_data,change_base){var instanceId;if(Y.Lang.isObject(change_data)){if("id"in change_data){instanceId=change_data.id}else{console.warn("Invalid change data in _process_delta:",change_data);return}}else if(action==="remove"){instanceId=change_data}else{console.warn("Invalid change data in _process_delta:",change_data);return}var instance=list.getById(instanceId),exists=Y.Lang.isValue(instance);if(action==="add"||action==="change"){var data=Y.merge(change_base||{},change_data);if(!exists){if(list.name==="serviceUnitList"){instance=list.add(data,true)}else{instance=list.add(data)}}else{if(instance instanceof Y.Model){instance.setAttrs(data)}else{var changed={};Y.each(data,function(value,key){if(value===undefined){return}changed[key]={prevVal:instance[key],newVal:value};instance[key]=value});list.fire("change",{changed:changed,instance:instance})}}}else if(action==="remove"){if(exists){if(list.name==="serviceUnitList"){list.remove(instance,true)}else{list.remove(instance)}if(list.name==="serviceList"){instance.destroy()}}}else{console.warn("Unknown change kind in _process_delta:",action)}return instance};var getServicesfromDelta=function getServicesfromDelta(modelInstance,data,db){var services;if(modelInstance&&modelInstance.service){services=db.services.getById(modelInstance.service)}else if(typeof data==="string"){services=db.services.getById(data.split("/")[0])}else if(data.service){services=db.services.getById(data.service)}else if(data.endpoints){services=[];services.push(db.services.getById(data.endpoints[0][0]));if(data.endpoints[1]){services.push(db.services.getById(data.endpoints[1][0]))}}if(!services){return}return services};var Environment=Y.Base.create("environment",Y.Model,[],{process_delta:function process_delta(action,data){this.set("annotations",data)}},{ATTRS:{name:{},provider:{},defaultSeries:{},annotations:{valueFn:function valueFn(){return{}}}}});models.Environment=Environment;var Service=Y.Base.create("service",Y.Model,[],{initializer:function initializer(){this.setAttrs({units:new models.ServiceUnitList({preventDirectChanges:true}),relations:new models.RelationList});this._events=[];this._bindAttributes()},_bindAttributes:function _bindAttributes(){this._events.push(this.get("relations").on(["*:change","*:add","*:remove"],function(e){this.set("relationChangeTrigger",e)},this))},updateConfig:function updateConfig(changeConfig){changeConfig=changeConfig||{};var serviceConfig=this.get("config")||{};var combined=Y.merge(serviceConfig,changeConfig);this.set("environmentConfig",Y.merge(this.get("environmentConfig"),changeConfig));this.set("config",combined)},isAlive:function isAlive(){var life=this.get("life");return life===ALIVE||life===DYING},hasErrors:function hasErrors(){var aggregates=this.get("aggregated_status")||{},errors=aggregates.error||false;return errors&&errors>=1},removeRelations:function removeRelations(relationId){var relations=this.get("relations");relations.some(function(rel){if(rel.get("relation_id")===relationId){relations.remove(rel);return true}})},getOtherServiceFromRelation:function getOtherServiceFromRelation(relation,db){var endpoints=relation.get("endpoints");if(!endpoints||endpoints.length!==2){return}if(endpoints[0][0]===this.get("id")){return db.services.getById(endpoints[1][0])}return db.services.getById(endpoints[0][0])},updateSubordinateUnits:function updateSubordinateUnits(db,halt){var relations=db.relations.get_relations_for_service(this);if(this.get("subordinate")){var units=new models.ServiceUnitList;relations.forEach(function(relation){if(relation.get("scope")!=="container"){return}var farService=this.getOtherServiceFromRelation(relation,db);if(farService&&!farService.get("subordinate")){units.add(farService.get("units").toArray(),true)}}.bind(this));this.set("units",units)}else{relations.forEach(function(relation){var farService=this.getOtherServiceFromRelation(relation,db);if(farService&&farService.get("subordinate")&&!halt){farService.updateSubordinateUnits(db,true)}}.bind(this))}},destructor:function destructor(){this._events.forEach(function(event){event.detach()})}},{ATTRS:{_dirtyFields:{value:[]},displayName:{getter:function getter(val){var name=val||this.get("id").replace("service-","");if(this.get("pending")){name="("+name+")"}return name}},name:{getter:function getter(value){if(value){return value}return this.get("packageName")}},charm:{},deleted:{},icon:{},config:{},environmentConfig:{value:{}},annotations:{value:{}},charmChanged:{value:false},constraints:{setter:function setter(value){if(typeof value==="string"){var output={};value.split(" ").map(function(pair){var kv=pair.split("=");output[kv[0]]=kv[1]});value=output}return value}},constraintsStr:{getter:function getter(){var result=[];Y.each(this.get("constraints"),function(v,k){if(v!==undefined){result.push(k+"="+v)}});if(result.length){return result.join(" ")}return undefined}},exposed:{value:false},subordinate:{value:false},pending:{value:false},life:{value:ALIVE},unit_count:{},units:{},relations:{},relationChangeTrigger:{value:{}},aggregateRelationError:{},available_versions:{},aggregated_status:{},packageName:{getter:function getter(value){if(value){return value}else{var charmUrl=this.get("charm"),charmName;if(charmUrl){var urlParts=charmUrl.split("/");var nameParts=urlParts[urlParts.length-1].split("-");var possibleVersion=nameParts[nameParts.length-1];if(possibleVersion==parseInt(possibleVersion,10)){nameParts.pop()}charmName=nameParts.join("-")}return charmName}}},highlight:{value:false},hide:{value:false},fade:{value:false}}});models.Service=Service;var ServiceList=Y.Base.create("serviceList",Y.ModelList,[],{model:Service,getServiceByName:function getServiceByName(serviceName){var service=this.getById(serviceName);if(service!==null){return service}else{this.some(function(serv){if(serv.get("name")===serviceName){service=serv;return true}})}return service},visible:function visible(){return this.filter({asList:true},function(model){return model.isAlive()||model.hasErrors()})},filterUnits:function filterUnits(predicate){var units=[];this.each(function(service){service.get("units").filter(predicate).forEach(function(unit){units.push(unit)})});return units},principals:function principals(){return this.filter({asList:true},function(service){return!service.get("subordinate")})},getServicesFromCharmName:function getServicesFromCharmName(charmName){return this.filter(function(service){var charm=service.get("charm");if(charm){return charm.indexOf(charmName)>0}},this)},ghostService:function ghostService(charm){var config=charm&&charm.get("config");var randomId,invalid=true;do{randomId=Math.floor(Math.random()*1e8)+"$";invalid=this.some(function(service){if(service.get("id")===randomId){return true}})}while(invalid);var charmId=charm.get("id");var charmName=charm.get("package_name");var name=this._generateServiceName(charmName,charmId);var ghostService=this.create({id:randomId,displayName:name,name:name,annotations:{},pending:true,charm:charmId,unit_count:0,loaded:false,subordinate:charm.get("is_subordinate"),config:config});return ghostService},_generateServiceName:function _generateServiceName(charmName,charmId){var highestId=Math.max.apply(Math,this.map(function(service){if(service.get("charm")===charmId){var count=parseInt(service.get("name").replace(charmName+"-",""));return count||1}return 0}));if(highestId<1||isNaN(highestId)||highestId===null){return charmName}return charmName+"-"+(highestId+1)},process_delta:function process_delta(action,data){_process_delta(this,action,data,{exposed:false})}});models.ServiceList=ServiceList;var RemoteService=Y.Base.create("remoteService",Y.Model,[],{idAttribute:"url",isAlive:function isAlive(){var life=this.get("life");return life===ALIVE||life===DYING},addDetails:function addDetails(details){this.setAttrs({description:details.description,sourceName:details.sourceName,endpoints:details.endpoints})}},{ATTRS:{url:{},service:{},sourceId:{},life:{},status:{value:{}},description:{},sourceName:{},endpoints:{value:[]}}});models.RemoteService=RemoteService;var RemoteServiceList=Y.Base.create("remoteServiceList",Y.ModelList,[],{model:RemoteService,process_delta:function process_delta(action,data){_process_delta(this,action,data)}});models.RemoteServiceList=RemoteServiceList;var ServiceUnit=Y.Base.create("serviceUnit",Y.Model,[],{},{ATTRS:{displayName:{},charmUrl:{},machine:{},agent_state:{},agent_state_info:{},agent_state_data:{},relation_errors:{},deleted:{},hide:{value:false},fade:{value:false},config:{},subordinate:{value:false},open_ports:{},public_address:{},private_address:{}}});models.ServiceUnit=ServiceUnit;var ServiceUnitList=Y.Base.create("serviceUnitList",Y.LazyModelList,[],{model:ServiceUnit,createDisplayName:function createDisplayName(name){return name.replace("unit-","").replace(/^(.+)-(\d+)$/,"$1/$2")},process_delta:function process_delta(action,data,db){var existingCharmUrl;if(action==="change"&&data.charmUrl){var existingUnit=db.units.getById(data.id);if(existingUnit){existingCharmUrl=existingUnit.charmUrl}}var instance=_process_delta(this,action,data,{});var service=getServicesfromDelta(instance,data,db);if(!service){console.error("Units added without matching Service");return}instance.hide=service.get("hide");instance.fade=service.get("fade");instance.highlight=service.get("highlight");if(existingCharmUrl&&existingCharmUrl!==instance.charmUrl&&!service.get("charmChanged")){service.set("charmChanged",true)}_process_delta(service.get("units"),action,data,{});service.updateSubordinateUnits(db)},_setDefaultsAndCalculatedValues:function _setDefaultsAndCalculatedValues(obj){var raw=obj.id.split("/");obj.service=raw[0];obj.number=parseInt(raw[1],10);obj.urlName=obj.id.replace("/","-");obj.name="serviceUnit";if(!obj.displayName){obj.displayName=this.createDisplayName(obj.id)}},add:function add(models,allowed){if(!allowed&&this.get("preventDirectChanges")){throw new Error("direct calls to units.add() are not allowed: "+"use db.addUnits() instead")}if(Y.Lang.isArray(models)){models.forEach(this._setDefaultsAndCalculatedValues,this)}else{this._setDefaultsAndCalculatedValues(models)}return ServiceUnitList.superclass.add.call(this,models)},remove:function remove(models,allowed){if(!allowed&&this.get("preventDirectChanges")){throw new Error("direct calls to units.remove() are not allowed: "+"use db.removeUnits() instead")}return ServiceUnitList.superclass.remove.call(this,models)},filterByMachine:function filterByMachine(machine,includeChildren){var predicate;if(machine){if(includeChildren){predicate=function(unit){if(machine&&machine.toString().indexOf("/")>=0){return unit.machine&&unit.machine.indexOf(machine)===0}else{return unit.machine&&unit.machine.split("/")[0]===machine}}}else{predicate=function(unit){return unit.machine===machine}}}else{predicate=function(unit){return!unit.machine}}machine=machine||null;return this.filter(predicate)},filterByStatus:function filterByStatus(status){if(!status){return this.toArray()}return this.filter(function(unit){var agentState=unit.agent_state||"uncommitted";if(agentState===status){return unit}})},get_informative_states_for_service:function get_informative_states_for_service(service){var aggregate_map={},relationError={},units_for_service=service.get("units"),serviceLife=service.get("life");units_for_service.each(function(unit){var state=utils.determineCategoryType(utils.simplifyState(unit,serviceLife));if(aggregate_map[state]===undefined){aggregate_map[state]=1}else{aggregate_map[state]+=1}if(state==="error"){var info=unit.agent_state_info;if(info!==undefined&&info.indexOf("failed")>-1){if(info.indexOf("relation")>-1){var stateData=unit.agent_state_data;if(stateData){var remoteUnit=stateData["remote-unit"];var svc=remoteUnit?remoteUnit.split("/")[0]:unit.service;relationError[svc]=stateData.hook}}}}});return[aggregate_map,relationError]},update_service_unit_aggregates:function update_service_unit_aggregates(service){var aggregate=this.get_informative_states_for_service(service);var sum=Y.Array.reduce(Y.Object.values(aggregate[0]),0,function(a,b){return a+b});var previous_unit_count=service.get("unit_count");service.set("unit_count",sum);service.set("aggregated_status",aggregate[0]);service.set("relationChangeTrigger",{error:aggregate[1]});if(previous_unit_count!==sum&&window._gaq){window._gaq.push(["_trackEvent","Service Stats","Update",service.get("id"),sum])}}},{ATTRS:{preventDirectChanges:{value:false,writeOnce:"initOnly"}}});models.ServiceUnitList=ServiceUnitList;var Machine=Y.Base.create("machine",Y.Model,[],{idAttribute:"machine_id"},{ATTRS:{commitStatus:{},displayName:{},deleted:{},parentId:{},containerType:{},number:{},machine_id:{},public_address:{},addresses:{},instance_id:{},agent_state:{},agent_state_info:{},agent_state_data:{},hardware:{},jobs:{},isStateServer:{},life:{},series:{},supportedContainers:{}}});models.Machine=Machine;var MachineList=Y.Base.create("machineList",Y.LazyModelList,[],{model:Machine,_ghostCounter:0,createDisplayName:function createDisplayName(name){return(name+"").replace("machine-","")},parseMachineName:function parseMachineName(name){name=name+"";var parts=name.split("/");var partsLength=parts.length;if(partsLength<3){return{parentId:null,containerType:null,number:parseInt(name,10)}}return{parentId:parts.slice(0,partsLength-2).join("/"),containerType:parts[partsLength-2],number:parseInt(parts[partsLength-1],10)}},_modelToObject:function _modelToObject(model){var result=MachineList.superclass._modelToObject.call(this,model);if(!Y.Lang.isValue(result.id)){result.id=result.machine_id}return result},_setDefaultsAndCalculatedValues:function _setDefaultsAndCalculatedValues(obj){obj.name="machine";obj.displayName=this.createDisplayName(obj.id);var info=this.parseMachineName(obj.id);obj.parentId=info.parentId;obj.containerType=info.containerType;obj.number=info.number;if(obj.jobs){var MANAGE_ENVIRON=environments.machineJobs.MANAGE_ENVIRON;obj.isStateServer=obj.jobs.indexOf(MANAGE_ENVIRON)!==-1}else{obj.jobs=[environments.machineJobs.HOST_UNITS];obj.isStateServer=false}},add:function add(models,options){if(Y.Lang.isArray(models)){models.forEach(this._setDefaultsAndCalculatedValues,this)}else{this._setDefaultsAndCalculatedValues(models)}var result=MachineList.superclass.add.apply(this,arguments);return result},addGhost:function addGhost(parentId,containerType,attrs){var obj=attrs?Y.clone(attrs):{};obj.id="new"+this._ghostCounter;obj.commitStatus="uncommitted";this._ghostCounter+=1;if(parentId){if(!containerType){throw new Error("parent id specified without a container type")}obj.id=parentId+"/"+containerType+"/"+obj.id}return this.add(obj)},filterByParent:function filterByParent(parentId){return this.filter(function(item){if(!parentId){return item.parentId===null||item.parentId===undefined}return item.parentId===parentId})},filterByAncestor:function filterByAncestor(ancestorId){if(ancestorId===null){return this._items}var prefix=ancestorId+"/";return this.filter(function(item){return item.id.indexOf(prefix)===0})},process_delta:function process_delta(action,data){_process_delta(this,action,data,{})},comparator:function comparator(model){return this._getSortMethod(this.get("sortMethod"))(model)},_getSortMethod:function _getSortMethod(sort){var sortMethod;var weight=0;switch(sort){case"units":sortMethod=function(model){if(model.units){weight=model.units.length}return-weight};break;case"name":sortMethod=function(model){var maxLength=50;var name=model.displayName;for(var i=0;i<maxLength-name.length;i+=1){name="0"+name}return name};break;case"disk":sortMethod=function(model){if(model.hardware){weight=model.hardware.disk}return-weight};break;case"ram":sortMethod=function(model){if(model.hardware){weight=model.hardware.mem}return-weight};break;case"cpu":sortMethod=function(model){if(model.hardware){weight=model.hardware.cpuPower}return-weight};break;case"service":sortMethod=function(model){if(model.units){var services={};model.units.forEach(function(unit){services[unit.service]=true});weight=Object.keys(services)}return weight};break;case"services":sortMethod=function(model){if(model.units){var services={};model.units.forEach(function(unit){services[unit.service]=true});weight=Object.keys(services).length}return-weight};break;case"size":sortMethod=function(model){if(model.hardware){weight=model.hardware.mem+model.hardware.disk}return-weight};break}return sortMethod}},{ATTRS:{sortMethod:{value:"name"}}});models.MachineList=MachineList;var Relation=Y.Base.create("relation",Y.Model,[],{idAttribute:"relation_id"},{ATTRS:{relation_id:{},type:{},endpoints:{},pending:{value:false},scope:{},deleted:{},display_name:{getter:function getter(value){if(value){return value}var names=[];this.get("endpoints").forEach(function(endpoint){names.push(endpoint[1].name)});return names.join(":")}}}});models.Relation=Relation;var RelationList=Y.Base.create("relationList",Y.ModelList,[],{model:Relation,process_delta:function process_delta(action,data,db){if(action==="remove"){var endpoints;if(Y.Lang.isString(data)){db.relations.each(function(relation){if(relation.get("id")===data){endpoints=relation.get("endpoints")}})}else{endpoints=data.endpoints}if(endpoints){var service;endpoints.forEach(function(endpoint){service=db.services.getById(endpoint[0]);if(service){service.removeRelations(data);service.updateSubordinateUnits(db)}else{console.error("Relation added without matching service")}})}_process_delta(this,action,data,{})}else{var instance=_process_delta(this,action,data,{});var services=getServicesfromDelta(instance,data,db);services.forEach(function(service){if(service){_process_delta(service.get("relations"),action,data,db);service.updateSubordinateUnits(db)}else{console.error("Relation added without matching service")}})}},getRelationFromEndpoints:function getRelationFromEndpoints(endpoints){var relationModel,matching;this.some(function(relation){matching=this.compareRelationEndpoints(relation.get("endpoints"),endpoints);if(matching){relationModel=relation;return true}},this);return relationModel},compareRelationEndpoints:function compareRelationEndpoints(endpointSetA,endpointSetB){var matched=true;if(!this._compareEndpointSets(endpointSetA,endpointSetB)){var reversedSetB=endpointSetB.slice(0).reverse();if(!this._compareEndpointSets(endpointSetA,reversedSetB)){matched=false}}return matched},_compareEndpointSets:function _compareEndpointSets(endpointSetA,endpointSetB){if(endpointSetA.length!==endpointSetB.length){return false}for(var i=0,l=endpointSetA.length;i<l;i+=1){var endpointA=endpointSetA[i],endpointB=endpointSetB[i];if(endpointA[0]!==endpointB[0]||endpointA[1].name!==endpointB[1].name){return false}}return true},has_relation_for_endpoint:function has_relation_for_endpoint(ep,svc_name){var svc_matched=false,ep_matched=false;return this.some(function(rel){svc_matched=ep_matched=false;Y.Array.each(rel.get("endpoints"),function(rep){if(ep.type!==rel.get("interface")){return}if(!ep_matched){ep_matched=ep.service===rep[0]&&ep.name===rep[1].name}if(svc_name&&!svc_matched&&rep[0]===svc_name){svc_matched=true}});if(!svc_name&&ep_matched){return true}else if(svc_name&&ep_matched&&svc_matched){return true}return false})},get_relations_for_service:function get_relations_for_service(service,asList){var service_id=service.get("id");return this.filter({asList:Boolean(asList)},function(relation){return Y.Array.some(relation.get("endpoints"),function(endpoint){return endpoint[0]===service_id})})}},{ATTRS:{}});models.RelationList=RelationList;var Notification=Y.Base.create("notification",Y.Model,[],{},{ATTRS:{title:{},message:{},level:{value:"info"},kind:{},seen:{value:false},timestamp:{valueFn:function valueFn(){return Y.Lang.now()}},modelId:{setter:function setter(model){if(!model){return null}if(Y.Lang.isArray(model)){return model}return Y.mix([model.name,model instanceof Y.Model?model.get("id"):model.id])}},isDelta:{value:false},link:{},link_title:{value:"View Details"}}});models.Notification=Notification;var NotificationList=Y.Base.create("notificationList",Y.ModelList,[],{model:Notification,add:function add(){this.trim();return NotificationList.superclass.add.apply(this,arguments)},comparator:function comparator(model){return-model.get("timestamp")},trim:function trim(e){while(this.size()>=this.get("max_size")){this.removeOldest()}},removeOldest:function removeOldest(){this.remove(this.size()-1)},getNotificationsForModel:function getNotificationsForModel(model){var modelKey=model instanceof Y.Model?model.get("id"):model.id;return this.filter(function(notification){var modelId=notification.get("modelId"),modelList;if(modelId){modelList=modelId[0];modelId=modelId[1];return modelList===model.name&&modelId===modelKey}return false})}},{ATTRS:{max_size:{value:150,writeOnce:"initOnly"}}});models.NotificationList=NotificationList;var _annotationProperty={serviceUnit:true,machine:true};models.getAnnotations=function(entity){if(!entity){return undefined}if(_annotationProperty[entity.name]){return entity.annotations}return entity.get("annotations")};models.setAnnotations=function(entity,annotations,merge){if(!entity){return}if(merge){var existing=models.getAnnotations(entity)||{};annotations=Y.mix(existing,annotations,true)}if(_annotationProperty[entity.name]){entity.annotations=annotations}else{entity.set("annotations",annotations)}};var Database=Y.Base.create("database",Y.Base,[],{_highlightedServices:[],initializer:function initializer(){this.environment=new Environment;this.services=new ServiceList;this.remoteServices=new RemoteServiceList;this.charms=new models.CharmList;this.relations=new RelationList;this.notifications=new NotificationList;this.machines=new MachineList;this.units=new ServiceUnitList({preventDirectChanges:true})},destructor:function destructor(){var modelLists=[this.environment,this.services,this.remoteServices,this.charms,this.relations,this.notifications,this.machines,this.units];modelLists.forEach(function(modelList){modelList.detachAll();modelList.destroy()})},resolveModelByName:function resolveModelByName(entityName){if(!entityName){return undefined}if(entityName==="env"){return this.environment}if(/^\d+$/.test(entityName)){return this.machines.getById(entityName)}if(/^\S+\/\d+$/.test(entityName)){return this.units.getById(entityName)}return this.services.getById(entityName)},getModelFromChange:function getModelFromChange(change){var change_kind=change[1],data=change[2],model_id=change_kind==="remove"&&data||data.id;return this.resolveModelByName(model_id)},reset:function reset(){this.services.reset();this.remoteServices.reset();this.machines.reset();this.charms.reset();this.relations.reset();this.notifications.reset();this.units.reset()},onDelta:function onDelta(deltaEvent){var self=this,changes=deltaEvent.data.result,defaultHandler=handlers.defaultHandler;changes.forEach(function(change){var kind=change[0],action=change[1],data=change[2],handler=defaultHandler;if(handlers.hasOwnProperty(kind)){handler=handlers[kind]}handler(self,action,data,kind)});var units=this.units;this.services.each(function(service){units.update_service_unit_aggregates(service);if(service.get("subordinate")){service.updateSubordinateUnits(this)}}.bind(this));this.fire("update")},_mapServicesToMachines:function _mapServicesToMachines(machineList){var machinePlacement={};var owners={};var machineNames={};var db=this;var machines=machineList.filter(function(machine){if(machine.commitStatus==="uncommitted"||machine.commitStatus==="in-progress"||db.units.filterByMachine(machine.id).length===0){return false}return true});machines.sort(function(a,b){var aLxc=0,bLxc=0;if(a.parentId){aLxc=-1}if(b.parentId){bLxc=-1}return bLxc-aLxc});machines.forEach(function(machine){var units=this.units.filterByMachine(machine.id).filter(function(unit){return unit.agent_state});var machineName;var containerType=machine.containerType;if(containerType!==null&&containerType!==undefined){var machineId=machine.parentId;if(machineNames[machineId]){machineName=containerType+":"+machineNames[machineId]}else{machineName=containerType+":"+machine.parentId}}else{var owner=units[0].service;var ownerIndex=owners[owner]>=0?owners[owner]+1:0;owners[owner]=ownerIndex;machineName=owner+"/"+ownerIndex;machineNames[machine.id]=machineName}units.forEach(function(unit){var serviceName=unit.service;if(!machinePlacement[serviceName]){machinePlacement[serviceName]=[]}if(serviceName===owner){machineName=unit.machine}machinePlacement[serviceName].push(machineName)})},this);return machinePlacement},exportDeployer:function exportDeployer(){var defaultSeries=this.environment.get("defaultSeries"),result={};if(defaultSeries){result.series=defaultSeries}result.services=this._generateServiceList(this.services);var machinePlacement=this._mapServicesToMachines(this.machines);result.relations=this._generateRelationSpec(this.relations);result.machines=this._generateMachineSpec(machinePlacement,this.machines,result.services);return result},_generateServiceList:function _generateServiceList(serviceList){var services={};serviceList.each(function(service){var units=service.get("units");var charm=this.charms.getById(service.get("charm"));var serviceOptions={};var charmOptions=charm.get("options");var serviceName=service.get("id");if(service.get("pending")===true||serviceName===JUJU_GUI_SERVICE_NAME){return}Y.each(service.get("config"),function(value,key){if(Y.Lang.isValue(value)){var optionData=charmOptions&&charmOptions[key];switch(optionData.type){case"boolean":value=value+""==="true";break;case"float":value=parseFloat(value);break;case"int":value=parseInt(value,10);break}var defaultVal=optionData&&optionData["default"];var hasDefault=Y.Lang.isValue(defaultVal);if(!hasDefault||value!==defaultVal){serviceOptions[key]=value}}});var serviceData={charm:charm.get("id")};if(charm.get("is_subordinate")){delete serviceData.num_units}else{serviceData.num_units=units&&units.size()||0}if(serviceOptions&&Y.Object.size(serviceOptions)>=1){serviceData.options=serviceOptions}var constraints=service.get("constraintsStr");if(constraints){serviceData.constraints=constraints}if(service.get("exposed")){serviceData.expose=true}var anno=service.get("annotations");if(anno&&anno["gui-x"]&&anno["gui-y"]){serviceData.annotations={"gui-x":anno["gui-x"],"gui-y":anno["gui-y"]}}services[serviceName]=serviceData},this);return services},_generateRelationSpec:function _generateRelationSpec(relationList){var relations=[];relationList.each(function(relation){if(relation.get("id").indexOf("pending-")===0){return}var endpoints=relation.get("endpoints");if(endpoints.length===1){return}var serviceNames=endpoints.map(function(endpoint){return endpoint[0]});if(serviceNames.indexOf(JUJU_GUI_SERVICE_NAME)!==-1){return}var relationData=endpoints.map(function(endpoint){return endpoint[0]+":"+endpoint[1].name});relations.push(relationData)},this);return relations},_generateMachineSpec:function _generateMachineSpec(machinePlacement,machineList,serviceList){var machines={};var counter=0;var machineIdList=[];var machineIdMap={};Object.keys(machinePlacement).forEach(function(serviceName){machinePlacement[serviceName].forEach(function(machineId){var charmName=this.services.getById(serviceName).get("name");if(charmName===JUJU_GUI_SERVICE_NAME){return}var idExists=machineIdList.some(function(id){if(id===machineId){return true}});if(!idExists){machineIdList.push(machineId);var parts=machineId.split(":");var parentId;if(parts.length===2){var partInt=parseInt(parts[1],10);if(!isNaN(partInt)){parentId=partInt}}else{parentId=machineId}if(parentId&&machineIdMap[parentId]===undefined){machineIdMap[parentId]=counter;counter+=1}}},this);if(serviceName!==JUJU_GUI_SERVICE_NAME){serviceList[serviceName].to=machinePlacement[serviceName].map(function(machineId){var parts=machineId.split(":");if(parts.length===2){var partInt=parseInt(parts[1],10);if(!isNaN(partInt)){parts[1]=machineIdMap[partInt]}return parts.join(":")}else{return machineIdMap[machineId]+""}})}},this);machineList.each(function(machine){var parentId=machine.parentId;if(parentId!==undefined&&parentId!==null){return}var machineId=machine.id;machineIdList.some(function(listMachineId){var parts=listMachineId.split(":");if(parts.length===2){var partInt=parseInt(parts[1],10);if(!isNaN(partInt)&&machineId===partInt+""){machineId=listMachineId;return true}}});if(machineIdList.indexOf(machineId)>-1){var parts=machineId.split(":");if(parts.length===2){machineId=parts[1]}machines[machineIdMap[machineId]]={};machines[machineIdMap[machineId]].series=machine.series;var constraints=this._collapseMachineConstraints(machine.hardware);if(constraints.length>0){machines[machineIdMap[machineId]].constraints=constraints}}},this);return machines},_collapseMachineConstraints:function _collapseMachineConstraints(constraints){var constraint="";var constraintMap={arch:"arch",cpuCores:"cpu-cores",cpuPower:"cpu-power",mem:"mem",disk:"root-disk"};Object.keys(constraints).forEach(function(key){var value=constraints[key];if(value){constraint+=constraintMap[key]+"="+value+" "}});return constraint.trim()},addUnits:function addUnits(models){var unitOrUnits=this.units.add(models,true);var units=Y.Lang.isArray(unitOrUnits)?unitOrUnits:[unitOrUnits];units.forEach(function(unit){var service=this.services.getById(unit.service);var serviceUnits=service.get("units");serviceUnits.add(unit,true);this.units.update_service_unit_aggregates(service)},this);return unitOrUnits},removeUnits:function removeUnits(models){var unitOrUnits=this.units.remove(models,true);var units=Y.Lang.isArray(unitOrUnits)?unitOrUnits:[unitOrUnits];units.forEach(function(unit){var service=this.services.getById(unit.service);var serviceUnits=service.get("units");serviceUnits.remove(unit,true);this.units.update_service_unit_aggregates(service)},this);return unitOrUnits},updateServiceUnitsDisplayname:function updateServiceUnitsDisplayname(serviceId){var service=this.services.getById(serviceId);var serviceName=service.get("name");var serviceUnits=service.get("units");serviceUnits.each(function(unit){unit.displayName=serviceName+"/"+unit.number});this.fire("update")},updateUnitId:function updateUnitId(serviceId,oldId){var service=this.services.getById(serviceId);var serviceUnits=service.get("units");var units=this.units;var unit=units.getById(oldId);var unitNumber=unit.number;var newId=serviceId+"/"+unitNumber;unit.service=serviceId;unit.id=newId;unit.urlName=serviceId+"-"+unitNumber;delete units._idMap[oldId];units._idMap[newId]=unit;delete serviceUnits._idMap[oldId];serviceUnits._idMap[unit.id]=unit;units.fire("change");serviceUnits.fire("change");return unit},findRelatedServices:function findRelatedServices(service,asArray){var relationData=utils.getRelationDataForService(this,service);var related=[service.get("name")];relationData.forEach(function(relation){if(relation.far&&relation.far.service){related.push(relation.far.service)}});if(asArray){return related}return this.services.filter({asList:true},function(s){return related.indexOf(s.get("name"))>-1})},findUnrelatedServices:function findUnrelatedServices(service){var related=this.findRelatedServices(service,true);var unrelated=this.services.filter({asList:true},function(s){return related.indexOf(s.get("name"))===-1});return unrelated},updateUnitFlags:function updateUnitFlags(serviceOrServiceList,flag){var dbUnits=this.units;function updateOneService(service){var value=service.get(flag),units=service.get("units");units.each(function(unit){var dbUnit=dbUnits.getById(unit.id);unit=units.revive(unit);dbUnit=dbUnits.revive(dbUnit);unit.set(flag,value);dbUnit.set(flag,value)});if(service.get("subordinate")){service.updateSubordinateUnits(this)}}if(serviceOrServiceList instanceof models.ServiceList){
serviceOrServiceList.each(updateOneService.bind(this))}else{updateOneService.call(this,serviceOrServiceList)}},setMVVisibility:function setMVVisibility(serviceId,highlight){var highlightIndex=this._highlightedServices.indexOf(serviceId);if(highlightIndex>=0&&highlight===false){this._highlightedServices.splice(highlightIndex,1)}else if(highlightIndex<0&&highlight===true){this._highlightedServices.push(serviceId)}var changedMachines=[];this.machines.each(function(machine){var units=this.units.filterByMachine(machine.id,true);var keepVisible=this._highlightedServices.some(function(highlightedService){return units.some(function(unit){return unit.service===highlightedService})});if(this._highlightedServices.length<1){keepVisible=true}var oldHideValue=machine.hide;machine.hide=keepVisible?false:true;if(oldHideValue!==machine.hide){changedMachines.push(machine)}},this);if(changedMachines.length){this.machines.fire("changes",{instances:changedMachines})}}});models.Database=Database},"0.1.0",{requires:["model","model-list","lazy-model-list","datasource-io","datasource-jsonschema","io-base","json-parse","juju-delta-handlers","juju-endpoints","juju-view-utils","juju-charm-models","juju-env-go","promise"]});