"use strict";YUI.add("juju-env-bakery",function(Y){var module=Y.namespace("juju.environments.web");var macaroon=Y.namespace("macaroon");var Bakery=Y.Base.create("Bakery",Y.Base,[],{initializer:function initializer(cfg){this.webhandler=cfg.webhandler;if(cfg.visitMethod){this.visitMethod=cfg.visitMethod}else if(cfg.interactive!==undefined&&!cfg.interactive){this.visitMethod=this._nonInteractiveVisitMethod}else{this.visitMethod=this._defaultVisitMethod}this.macaroonName="Macaroons-"+cfg.serviceName;this.setCookiePath=cfg.setCookiePath;this.nonceLen=24},sendGetRequest:function sendGetRequest(path,successCallback,failureCallback){var macaroons=this._getMacaroon();var headers={"Bakery-Protocol-Version":1};if(macaroons!==null){headers["Macaroons"]=macaroons}return this.webhandler.sendGetRequest(path,headers,null,null,false,null,this._requestHandlerWithInteraction.bind(this,path,successCallback,failureCallback))},sendPostRequest:function sendPostRequest(path,data,successCallback,failureCallback){var macaroons=this._getMacaroon();var headers={"Bakery-Protocol-Version":1,"Content-type":"application/json"};if(macaroons!==null){headers["Macaroons"]=macaroons}return this.webhandler.sendPostRequest(path,headers,data,null,null,false,null,this._requestHandlerWithInteraction.bind(this,path,successCallback,failureCallback))},_requestHandlerWithInteraction:function _requestHandlerWithInteraction(path,successCallback,failureCallback,response){var target=response.target;if(target.status===401&&target.getResponseHeader("Www-Authenticate")==="Macaroon"){var jsonResponse=JSON.parse(target.responseText);this._authenticate(jsonResponse.Info.Macaroon,this._sendOriginalRequest.bind(this,path,successCallback,failureCallback),failureCallback)}else{this._requestHandler(successCallback,failureCallback,response)}},_requestHandler:function _requestHandler(successCallback,failureCallback,response){var target=response.target;if(target.status>=400){failureCallback(response);return}successCallback(response)},_sendOriginalRequest:function _sendOriginalRequest(path,successCallback,failureCallback){var macaroons=this._getMacaroon();var headers={"Bakery-Protocol-Version":1};if(macaroons!==null){headers["Macaroons"]=macaroons}return this.webhandler.sendGetRequest(path,headers,null,null,false,null,this._requestHandler.bind(this,successCallback,failureCallback))},_authenticate:function _authenticate(m,requestFunction,failureCallback){try{macaroon.discharge(macaroon["import"](m),this._obtainThirdPartyDischarge.bind(this),this._processDischarges.bind(this,requestFunction,failureCallback),failureCallback)}catch(ex){failureCallback(ex.message)}},_processDischarges:function _processDischarges(requestFunction,failureCallback,discharges){var jsonMacaroon;try{jsonMacaroon=macaroon["export"](discharges)}catch(ex){failureCallback(ex.message)}var content=JSON.stringify({Macaroons:jsonMacaroon});if(this.setCookiePath===undefined){this._successfulDischarges(requestFunction,jsonMacaroon);return}return this.webhandler.sendPutRequest(this.setCookiePath,null,content,null,null,true,null,this._requestHandler.bind(this,this._successfulDischarges.bind(this,requestFunction,jsonMacaroon),failureCallback))},_successfulDischarges:function _successfulDischarges(originalRequest,jsonMacaroon){var prefix=this.macaroonName+"=";document.cookie=prefix+btoa(JSON.stringify(jsonMacaroon));window.addEventListener("unload",function(){document.cookie=prefix+";"});originalRequest()},_obtainThirdPartyDischarge:function _obtainThirdPartyDischarge(location,thirdPartyLocation,condition,successCallback,failureCallback){thirdPartyLocation+="/discharge";var headers={"Bakery-Protocol-Version":1,"Content-Type":"application/x-www-form-urlencoded"};var content="id="+encodeURIComponent(condition)+"&location="+encodeURIComponent(location);return this.webhandler.sendPostRequest(thirdPartyLocation,headers,content,null,null,false,null,this._requestHandler.bind(this,this._exportMacaroon.bind(this,successCallback,failureCallback),this._interact.bind(this,successCallback,failureCallback)))},_exportMacaroon:function _exportMacaroon(successCallback,failureCallback,response){try{var dm=macaroon["import"](JSON.parse(response.target.responseText).Macaroon);successCallback(dm)}catch(ex){failureCallback(ex.message)}},_interact:function _interact(successCallback,failureCallback,e){var response=JSON.parse(e.target.responseText);if(response.Code!=="interaction required"){failureCallback(response.Code);return}this.visitMethod(response);return this.webhandler.sendGetRequest(response.Info.WaitURL,null,null,null,false,null,this._requestHandler.bind(this,this._exportMacaroon.bind(this,successCallback,failureCallback),failureCallback))},_nonInteractiveVisitMethod:function _nonInteractiveVisitMethod(response){var acceptHeaders={Accept:"application/json"};var contentHeaders={"Content-Type":"application/json"};var login=function login(response){var method=JSON.parse(response.target.responseText).jujugui;var data=JSON.stringify({login:window.juju_config.auth});return this.webhandler.sendPostRequest(method,contentHeaders,data,null,null,false,null,null)};return this.webhandler.sendGetRequest(response.Info.VisitURL,acceptHeaders,null,null,false,null,login.bind(this))},addThirdPartyCaveat:function addThirdPartyCaveat(m,condition,location,thirdPartyPublicKey,myKeyPair){var nonce=nacl.randomBytes(this.nonceLen);var rootKey=nacl.randomBytes(this.nonceLen);var plain=JSON.stringify({RootKey:nacl.util.encodeBase64(rootKey),Condition:condition});var sealed=nacl.box(nacl.util.decodeUTF8(plain),nonce,thirdPartyPublicKey,myKeyPair.secretKey);var caveatIdObj={ThirdPartyPublicKey:nacl.util.encodeBase64(thirdPartyPublicKey),FirstPartyPublicKey:nacl.util.encodeBase64(myKeyPair.publicKey),Nonce:nacl.util.encodeBase64(nonce),Id:nacl.util.encodeBase64(sealed)};var caveatId=JSON.stringify(caveatIdObj);m.addThirdPartyCaveat(rootKey,caveatId,location)},dischargeThirdPartyCaveat:function dischargeThirdPartyCaveat(caveatId,myKeyPair,check){var caveatIdObj={};try{caveatIdObj=JSON.parse(caveatId)}catch(ex){throw new Exception("Unable to parse caveatId")}if(nacl.util.encodeBase64(myKeyPair.publicKey)!==caveatIdObj.ThirdPartyPublicKey){throw new Exception("public key mismatch")}var nonce=nacl.util.decodeBase64(caveatIdObj.Nonce);var firstPartyPub=nacl.util.decodeBase64(caveatIdObj.FirstPartyPublicKey);if(nonce.length!==this.nonceLen){throw new Exception("bad nonce length")}var sealed=nacl.util.decodeBase64(caveatIdObj.Id);var unsealed=nacl.box.open(sealed,nonce,firstPartyPub,myKeyPair.secretKey);var unsealedStr=nacl.util.encodeUTF8(unsealed);var plain=JSON.parse(unsealedStr);if(plain.Condition===undefined){throw new Exception("empty condition in third party caveat")}check(plain.Condition);return macaroon.newMacaroon(nacl.util.decodeBase64(plain.RootKey),caveatId,"")},_defaultVisitMethod:function _defaultVisitMethod(response){window.open(response.Info.VisitURL,"Login")},_getMacaroon:function _getMacaroon(){var name=this.macaroonName+"=";var ca=document.cookie.split(";");for(var i=0;i<ca.length;i++){var c=ca[i];while(c.charAt(0)===" "){c=c.substring(1)}if(c.indexOf(name)===0){return c.substring(name.length,c.length)}}return null}});module.Bakery=Bakery},"0.1.0",{requires:["base","cookie","node","juju-env-base","juju-env-web-handler","macaroon"]});