"use strict";YUI.add("juju-env-fakebackend",function(Y){var models=Y.namespace("juju.models");var ziputils=Y.namespace("juju.ziputils");var viewUtils=Y.namespace("juju.views.utils");var VALUE_ERROR={error:"Unparsable environment data."};var UNAUTHENTICATED_ERROR={error:"Please log in."};function FakeBackend(config){FakeBackend.superclass.constructor.apply(this,arguments)}FakeBackend.NAME="fake-backend";FakeBackend.ATTRS={authenticated:{value:false},authorizedUsers:{value:{"user-admin":"password","user-test":"test"}},defaultSeries:{value:"trusty"},name:{value:"Environment"},maasServer:{value:null},providerType:{value:"demonstration"},charmstore:{},token:{value:"demoToken"}};Y.extend(FakeBackend,Y.Base,{initializer:function initializer(){this.db=new models.Database;this._resetChanges();this._resetAnnotations();this._relationCount=0;this._importId=0;this._importChanges=[];this._deploymentId=0},_resetChanges:function _resetChanges(){this.changes={services:{},machines:{},units:{},relations:{}}},nextChanges:function nextChanges(){if(!this.get("authenticated")){return UNAUTHENTICATED_ERROR}var result;if(Y.Object.isEmpty(this.changes.services)&&Y.Object.isEmpty(this.changes.machines)&&Y.Object.isEmpty(this.changes.units)&&Y.Object.isEmpty(this.changes.relations)){result=null}else{result=this.changes;this._resetChanges()}return result},_resetAnnotations:function _resetAnnotations(){this.annotations={services:{},machines:{},units:{},relations:{},annotations:{}}},nextAnnotations:function nextAnnotations(){if(!this.get("authenticated")){return UNAUTHENTICATED_ERROR}var result;if(Y.Object.isEmpty(this.annotations.services)&&Y.Object.isEmpty(this.annotations.machines)&&Y.Object.isEmpty(this.annotations.units)&&Y.Object.isEmpty(this.annotations.relations)&&Y.Object.isEmpty(this.annotations.annotations)){result=null}else{result=this.annotations;this._resetAnnotations()}return result},login:function login(username,submittedPassword){var password=this.get("authorizedUsers")[username],authenticated=password===submittedPassword;this.set("authenticated",authenticated);return authenticated},tokenlogin:function tokenlogin(submittedToken){var token=this.get("token"),authorizedUsers=this.get("authorizedUsers"),authenticated=token===submittedToken;this.set("authenticated",authenticated);if(authenticated){var username=Object.keys(authorizedUsers)[0];var password=authorizedUsers[username];return[username,password]}},logout:function logout(){this.set("authenticated",false)},deploy:function deploy(charmId,callback,options){if(!this.get("authenticated")){return callback(UNAUTHENTICATED_ERROR)}if(!options){options={}}var self=this;this._loadCharm(charmId,{success:function success(charm){self._deployFromCharm(charm,callback,options)},failure:callback})},promiseDeploy:function promiseDeploy(charmId,options){var self=this;return new Y.Promise(function(resolve,reject){var intermediateCallback=function intermediateCallback(result){if(result.error){reject(result)}else{resolve(result)}};self.deploy(charmId,intermediateCallback,options)})},setCharm:function setCharm(serviceName,charmId,force,callback){if(!this.get("authenticated")){return callback(UNAUTHENTICATED_ERROR)}var self=this;var service=this.db.services.getById(serviceName);if(!service){return callback({error:'Service "'+serviceName+'" not found.'})}var unitsInError=service.get("units").some(function(unit){return/error/.test(unit.agent_state)});if(unitsInError&&!force){return callback({error:"Cannot set charm on a service with units in "+"error without the force flag."})}this._loadCharm(charmId,{success:function success(charm){service.set("charm",charm.get("id"));self.changes.services[service.get("id")]=[service,true];callback({})},failure:callback})},_loadCharm:function _loadCharm(charmId,callbacks){var charmIdParts=models.parseCharmId(charmId,this.get("defaultSeries"));if(!callbacks){callbacks={}}if(!charmIdParts){return callbacks.failure&&callbacks.failure({error:"Invalid charm id: "+charmId})}var charm=this.db.charms.getById(charmId);if(charm){callbacks.success(charm)}else{this.get("charmstore").getEntity(charmIdParts.storeId,function(error,charm){if(error){console.warn("error loading charm: ",error);if(callbacks.failure){callbacks.failure({error:"Error interacting with the charmstore API."})}}else{var charm=Y.juju.makeEntityModel(charm[0]);this._saveCharmModel(charm);if(callbacks.success){callbacks.success(charm)}}}.bind(this))}},_saveCharmModel:function _saveCharmModel(charm){var storedCharm=this.db.charms.getById(charm.id);if(!storedCharm){this.db.charms.add(charm)}return charm},_deployFromCharm:function _deployFromCharm(charm,callback,options){if(!options){options={}}if(!options.name){options.name=charm.get("package_name")}if(this.db.services.getById(options.name)){console.log(options);return callback({error:"A service with this name already exists ("+options.name+")."})}if(options.configYAML){if(!Y.Lang.isString(options.configYAML)){console.log(options);return callback({error:"Developer error: configYAML is not a string."})}try{options.config=jsyaml.safeLoad(options.configYAML)}catch(e){if(e instanceof jsyaml.YAMLException){console.log(options,e);return callback({error:"Error parsing YAML.\n"+e})}throw e}}var constraints={};if(options.constraints){constraints=options.constraints}var annotations=options.annotations||{};var constraintsMap={},vals;if(typeof constraints==="string"){var numPairs=constraints.match(/=/g).length;var pairs=constraints.split(",");if(numPairs!==pairs.length){pairs=constraints.split(" ")}constraints=pairs}if(Y.Lang.isArray(constraints)){constraints.forEach(function(cons){vals=cons.split("=");constraintsMap[vals[0].trim()]=vals[1].trim()})}else{constraintsMap=constraints}var charmOptions=charm.get("options")||{};var config={};var explicitConfig=options.config||{};Object.keys(charmOptions).forEach(function(key){var opt=charmOptions[key],value=explicitConfig[key]||opt["default"],type=opt.type;if(typeof value==="string"&&type!=="string"){if(type==="int"){config[key]=parseInt(value,10)}else if(type==="boolean"){config[key]=value.toLowerCase()==="true"}else if(type==="float"){config[key]=parseFloat(value)}}else{config[key]=value}});var service=this.db.services.add({id:options.name,name:options.name,charm:charm.get("id"),constraints:constraintsMap,exposed:false,subordinate:charm.get("is_subordinate"),annotations:annotations,config:config});this.changes.services[service.get("id")]=[service,true];if(Object.keys(annotations).length){this.annotations.services[service.get("id")]=service}var unitCount=options.unitCount;if(!Y.Lang.isValue(unitCount)&&!charm.get("is_subordinate")){unitCount=1}var response={};if(unitCount!==0){response=this.addUnit(options.name,unitCount,options.toMachine)}response.service=service;callback(response)},addMachines:function addMachines(params){if(!this.get("authenticated")){return UNAUTHENTICATED_ERROR}return{machines:params.map(function(param){return this._addMachine(param.parentId,param.containerType,param.series||"precise",param.constraints,param.jobs)},this)}},_addMachine:function _addMachine(parentId,containerType,series,constraints,jobs){var machines=this.db.machines;var parent;if(parentId){if(!containerType){return{error:"parent machine specified without container type"}}parent=machines.getById(parentId);if(!parent){return{error:"cannot add a new machine: machine "+parentId+" not found"}}}if(containerType){if(containerType!=="lxc"&&containerType!=="kvm"){return{error:"cannot add a new machine: machine "+parentId+" cannot host "+containerType+" containers"}}if(!parent){parentId=this._getNextMachineName();parent=machines.add({id:parentId,agent_state:"started",addresses:[],instance_id:"fake-instance",hardware:this._getHardwareCharacteristics(false),jobs:["JobHostUnits"],life:"alive",series:series,supportedContainers:["lxc","kvm"]});this.changes.machines[parentId]=[parent,true]}}var name=this._getNextMachineName(parentId,containerType);var machine=machines.add({id:name,agent_state:"started",addresses:[],instance_id:"fake-instance",hardware:this._getHardwareCharacteristics(!!parentId,constraints),jobs:jobs,life:"alive",series:series,supportedContainers:["lxc","kvm"]});this.changes.machines[name]=[machine,true];return{name:name}},_getHardwareCharacteristics:function _getHardwareCharacteristics(isContainer,constraints){var defaults={arch:"amd64",cpuCores:1,cpuPower:100,mem:1740,disk:8192};constraints=constraints||{};if(isContainer){return{arch:constraints.arch||defaults.arch}}if(Y.Object.isEmpty(constraints)){return defaults}return{arch:constraints.arch||defaults.arch,cpuCores:constraints["cpu-cores"]||defaults.cpuCores,cpuPower:constraints["cpu-power"]||defaults.cpuPower,mem:constraints.mem||defaults.mem,disk:constraints.disk||defaults.disk}},_getNextMachineName:function _getNextMachineName(parentId,containerType){var parts=[];if(parentId){parts.push(parentId)}else{parentId=null}if(containerType){parts.push(containerType)}else{containerType=null}var numbers=this.db.machines.filter(function(machine){return machine.parentId===parentId&&machine.containerType===containerType}).map(function(machine){return machine.number});var nextNumber=0;if(numbers.length){nextNumber=Math.max.apply(Math,numbers)+1}parts.push(nextNumber);return parts.join("/")},destroyMachines:function destroyMachines(names,force){var self=this;if(!self.get("authenticated")){return UNAUTHENTICATED_ERROR}var machineUnitsMap=self.db.services.filterUnits(function(unit){return names.indexOf(unit.machine)!==-1}).reduce(function(result,unit){var machine=unit.machine;if(result[machine]){result[machine].push(unit)}else{result[machine]=[unit]}return result},Object.create(null));var errors=[];var destroyed=false;names.forEach(function(name){var error=self._destroyMachine(name,force,machineUnitsMap);if(error===null){destroyed=true}else{errors.push(error)}});var response={};if(errors.length){var msg;if(destroyed){msg="some machines were not destroyed: "}else{msg="no machines were destroyed: "}response.error=msg+errors.join("; ")}return response},_destroyMachine:function _destroyMachine(name,force,machineUnitsMap){var machines=this.db.machines;var machine=machines.getById(name);if(!machine){return"machine "+name+" does not exist"}var descendants=machines.filterByAncestor(name);if(descendants.length){if(!force){var descendantNames=descendants.map(function(descendant){return descendant.id});return"machine "+name+" is hosting containers "+descendantNames.join(", ")}machines.remove(descendants);descendants.forEach(function(descendant){this.changes.machines[descendant.id]=[descendant,false]},this)}var units=machineUnitsMap[name];if(units){if(!force){var unitNames=units.map(function(unit){return unit.id});return"machine "+name+" has unit(s) "+unitNames.join(", ")+" assigned"}units.forEach(function(unit){this.db.removeUnits(unit);this.changes.units[unit.id]=[unit,false]},this)}machines.remove(machine);this.changes.machines[machine.id]=[machine,false];return null},destroyService:function destroyService(serviceName){if(!this.get("authenticated")){return UNAUTHENTICATED_ERROR}var service=this.db.services.getById(serviceName);if(!service){return{error:"Invalid service id: "+serviceName}}var relations=this.db.relations.get_relations_for_service(service);Y.Array.each(relations,function(rel){this.db.relations.remove(rel);this.changes.relations[rel.get("relation_id")]=[rel,false]},this);var unitNames=service.get("units").get("id");var result=this.removeUnits(unitNames);if(result.error&&result.error.length>0){console.log(result,result.error);return{error:"Error removing units ["+unitNames.join(", ")+"] of "+serviceName}}else if(result.warning&&result.warning.length>0){console.log(result,result.warning);return{error:"Warning removing units ["+unitNames.join(", ")+"] of "+serviceName}}this.db.services.remove(service);this.changes.services[serviceName]=[service,false];service.destroy();return{result:serviceName}},getService:function getService(serviceName){if(!this.get("authenticated")){return UNAUTHENTICATED_ERROR}var service=this.db.services.getById(serviceName);if(!service){return{error:"Invalid service id: "+serviceName}}var serviceData=service.getAttrs();if(!serviceData.constraints){serviceData.constraints={}}var relations=this.db.relations.get_relations_for_service(service);var rels=relations.map(function(r){return r.getAttrs()});serviceData.rels=rels;return{result:serviceData}},getCharm:function getCharm(charmName,callback){if(!this.get("authenticated")){return callback(UNAUTHENTICATED_ERROR)}var formatCharm=function formatCharm(charm){var charmLoadDelay=0;if(window.flags.charmLoadDelay){charmLoadDelay=parseInt(window.flags.charmLoadDelay,10)}setTimeout(function(){callback({result:charm.getAttrs()})},charmLoadDelay)};this._loadCharm(charmName,{success:formatCharm,failure:callback})},addUnit:function addUnit(serviceName,numUnits,toMachine){if(!this.get("authenticated")){return UNAUTHENTICATED_ERROR}var service=this.db.services.getById(serviceName);if(!service){return{error:'Service "'+serviceName+'" does not exist.'}}var isSubordinate=service.get("subordinate");if(Y.Lang.isUndefined(numUnits)){numUnits=isSubordinate?0:1}if(!Y.Lang.isNumber(numUnits)||!isSubordinate&&numUnits<1||isSubordinate&&numUnits!==0){return{error:"Invalid number of units ["+numUnits+"] for service: "+serviceName}}if(!Y.Lang.isValue(service.unitSequence)){service.unitSequence=0}var unit,machine,machines;if(Y.Lang.isValue(toMachine)){if(numUnits>1){return{error:"When deploying to a specific machine, the "+"number of units requested must be 1."}}var targetMachine=this.db.machines.getById(toMachine);if(targetMachine===null){return{error:"no machine matching "+toMachine+" found"}}machines=[targetMachine]}else{machines=this._getUnitMachines(numUnits)}var units=[];for(var i=0;i<numUnits;i+=1){var unitId=service.unitSequence;machine=machines[i];unit=this.db.addUnits({id:serviceName+"/"+unitId,machine:machine.id,agent_state:"started",subordinate:isSubordinate});units.push(unit);service.unitSequence+=1;this.changes.units[unit.id]=[unit,true]}return{units:units,machines:machines}},_getAvailableMachines:function _getAvailableMachines(){var machines=[];var usedMachineIds={};this.db.services.each(function(service){service.get("units").each(function(unit){if(unit.machine){usedMachineIds[unit.machine]=true}})});this.db.machines.each(function(machine){if(!usedMachineIds[machine.id]){machines.push(machine)}});return machines},_getUnitMachines:function _getUnitMachines(count){var machines=[];var availableMachines=this._getAvailableMachines();if(!Y.Lang.isValue(this.db.machines.sequence)){this.db.machines.sequence=0}for(var i=0;i<count;i+=1){if(i<availableMachines.length){machines.push(availableMachines[i])}else{var result=this._addMachine(null,null,"precise",null,["JobHostUnits"]);machines.push(this.db.machines.getById(result.name))}}return machines},removeUnits:function removeUnits(unitNames){var service,warning,error;if(typeof unitNames==="string"){unitNames=[unitNames]}Y.Array.each(unitNames,function(unitName){service=this.db.services.getById(unitName.split("/")[0]);if(service&&service.get("subordinate")){if(!Y.Lang.isArray(error)){error=[]}error.push(unitName+" is a subordinate, cannot remove.")}else{if(service){var unit=this.db.units.getById(unitName);if(unit){this.db.removeUnits(unit);this.changes.units[unitName]=[unit,false];return}}if(!Y.Lang.isArray(warning)){warning=[]}warning.push(unitName+" does not exist, cannot remove.")}},this);return{error:error,warning:warning}},expose:function expose(serviceName){var service=this.db.services.getById(serviceName),warning,error;if(!this.get("authenticated")){return UNAUTHENTICATED_ERROR}if(service){if(!service.get("exposed")){service.set("exposed",true);this.changes.services[service.get("id")]=[service,true]}else{warning='Service "'+serviceName+'" was already exposed.'}}else{error='"'+serviceName+'" is an invalid service name.'}return{error:error,warning:warning}},unexpose:function unexpose(serviceName){var service=this.db.services.getById(serviceName),warning,error;if(!this.get("authenticated")){return UNAUTHENTICATED_ERROR}if(service){if(service.get("exposed")){service.set("exposed",false);this.changes.services[service.get("id")]=[service,true]}else{warning='Service "'+serviceName+'" is not exposed.'}}else{error='"'+serviceName+'" is an invalid service name.'}return{error:error,warning:warning}},addRelations:function addRelations(endpointA,endpoints,useRelationCount){if(!this.get("authenticated")){return UNAUTHENTICATED_ERROR}if(typeof endpointA!=="string"){return{error:"Relation source not a string"}}if(typeof endpoints==="string"){return this.addRelation(endpointA,endpoints,useRelationCount)}if(Y.Lang.isArray(endpoints)===true){var result=[];endpoints.forEach(function(ep){result.push(this.addRelation(endpointA,ep,useRelationCount))},this);return result}return{error:"Relations in unexpected format"}},addRelation:function addRelation(endpointA,endpointB,useRelationCount){if(!this.get("authenticated")){return UNAUTHENTICATED_ERROR}if(typeof endpointA!=="string"||typeof endpointB!=="string"){return{error:"Two string endpoint names"+" required to establish a relation"}}var endpointData=viewUtils.parseEndpointStrings(this.db,[endpointA,endpointB]);if(!endpointData[0].charm||!endpointData[1].charm){return{error:"Charm not loaded."}}var match=viewUtils.findEndpointMatch(endpointData);if(match.error){return match}var relationId="";if(useRelationCount){relationId="relation-"+this._relationCount}else{relationId=[match.requires.name+":"+match.requires.type,match.provides.name+":"+match.provides.type].join(" ")}var endpoints=Y.Array.map([match.requires,match.provides],function(endpoint){return[endpoint.name,{name:endpoint.type}]});endpoints[0][1].role="client";endpoints[1][1].role="server";var relation=this.db.relations.create({relation_id:relationId,type:match["interface"],endpoints:endpoints,pending:false,scope:match.scope||"global",display_name:endpointData[0].type});if(relation){this._relationCount+=1;this.changes.relations[relationId]=[relation,true];return{relationId:relationId,type:match["interface"],endpoints:endpoints,scope:match.scope||"global",displayName:endpointData[0].type,relation:relation}}return false},removeRelation:function removeRelation(endpointA,endpointB){if(!this.get("authenticated")){return UNAUTHENTICATED_ERROR}if(typeof endpointA!=="string"||typeof endpointB!=="string"){return{error:"Two string endpoint names"+" required to establish a relation"}}var endpointData=viewUtils.parseEndpointStrings(this.db,[endpointA,endpointB]);if(!endpointData[0].charm||!endpointData[1].charm){return{error:"Charm not loaded."}}var relation;this.db.relations.some(function(rel){var endpoints=rel.getAttrs().endpoints;return[0,1].some(function(index){if(endpoints[index][0]===endpointData[0].name&&endpoints[!index+0][0]===endpointData[1].name){if(endpoints[index][1].name===endpointData[0].type&&endpoints[!index+0][1].name===endpointData[1].type){relation=rel;return true}}})});if(relation){var result=this.db.relations.remove(relation);this.changes.relations[relation.get("id")]=[relation,false];return result}else{return{error:"Relationship does not exist"}}},_getAnnotationGroup:function _getAnnotationGroup(entity){var annotationGroup={serviceUnit:"units",environment:"annotations"}[entity.name];if(!annotationGroup){annotationGroup=entity.name+"s"}return annotationGroup},updateAnnotations:function updateAnnotations(entityName,annotations){if(!this.get("authenticated")){return UNAUTHENTICATED_ERROR}var entity=this.db.resolveModelByName(entityName);var existing;if(!entity){return{error:"Unable to resolve entity: "+entityName}}existing=models.getAnnotations(entity);if(existing===undefined){existing={}}models.setAnnotations(entity,annotations,true);if(entity.name==="serviceUnit"){var serviceUnits=this.db.services.getById(entity.service).get("units");var nestedEntity=serviceUnits.getById(entityName);models.setAnnotations(nestedEntity,annotations,true)}var annotationGroup=this._getAnnotationGroup(entity);this.annotations[annotationGroup][entityName]=entity;return{result:true}},getAnnotations:function getAnnotations(entityName){if(!this.get("authenticated")){return UNAUTHENTICATED_ERROR}var entity=this.db.resolveModelByName(entityName);if(!entity){return{error:"Unable to resolve entity: "+entityName}}return{result:models.getAnnotations(entity)}},removeAnnotations:function removeAnnotations(entityName,keys){if(!this.get("authenticated")){return UNAUTHENTICATED_ERROR}var entity=this.db.resolveModelByName(entityName);var annotations;if(!entity){return{error:"Unable to resolve entity: "+entityName}}annotations=models.getAnnotations(entity);if(annotations===undefined){annotations={}}if(keys){Y.each(keys,function(k){if(Y.Object.owns(annotations,k)){delete annotations[k]}})}else{annotations={}}models.setAnnotations(entity,annotations);var annotationGroup=this._getAnnotationGroup(entity);this.annotations[annotationGroup][entityName]=entity;return{result:true}},setConfig:function setConfig(serviceName,config){if(!this.get("authenticated")){return UNAUTHENTICATED_ERROR}var service=this.db.services.getById(serviceName);if(!service){return{error:'Service "'+serviceName+'" does not exist.'}}var existing=service.get("config");if(!existing){existing={}}if(!config){config={}}existing=Y.mix(existing,config,true,undefined,0,true);service.set("config",existing);this.changes.services[service.get("id")]=[service,true];return{result:existing}},setConstraints:function setConstraints(serviceName,data){var constraints={};if(!this.get("authenticated")){return UNAUTHENTICATED_ERROR}var service=this.db.services.getById(serviceName);if(!service){return{error:'Service "'+serviceName+'" does not exist.'}}if(Y.Lang.isArray(data)){Y.Array.each(data,function(i){var kv=i.split("=");constraints[kv[0]]=kv[1]})}else if(data){constraints=data}var tags=constraints.tags;if(tags){constraints.tags=tags.join(",")}service.set("constraints",constraints);this.changes.services[service.get("id")]=[service,true];return{result:true}},resolved:function resolved(unitName,relationName){if(!this.get("authenticated")){return UNAUTHENTICATED_ERROR}var serviceName=unitName.split("/",1)[0];var service=this.db.services.getById(serviceName);var unit;if(service){unit=service.get("units").getById(unitName)}if(!service||!unit){return{error:'Unit "'+unitName+'" does not exist.'}}if(relationName){var relation=this.db.relations.get_relations_for_service(service).filter(function(rel){return rel.endpoints[0].name===relationName||rel.endpoints[1].name===relationName});if(relation.length===0){return{error:"Relation "+relationName+" not found for "+unitName}}}return{result:true}},_promiseCharmForService:function _promiseCharmForService(serviceData){var self=this,charmId=serviceData.charm;return Y.Promise(function(resolve,reject){self._loadCharm(charmId,{success:function success(charm){resolve([charm,serviceData])},failure:reject})})},exportEnvironment:function exportEnvironment(){var serviceList=this.db.services,relationList=this.db.relations,result={meta:{exportFormat:1},services:[],relations:[]},blackLists={service:["id","aggregated_status","clientId","initialized","constraintsStr","destroyed","pending"],relation:["id","relation_id","clientId","initialized","destroyed","pending"]};if(!this.get("authenticated")){return UNAUTHENTICATED_ERROR}serviceList.each(function(s){var serviceData=s.getAttrs();if(serviceData.pending===true){return}Y.each(blackLists.service,function(key){if(key in serviceData){delete serviceData[key]}var units=s.get("units");serviceData.unit_count=units.size()||1});result.services.push(serviceData)});relationList.each(function(r){var relationData=r.getAttrs();if(relationData.pending===true){return}Y.each(blackLists.relation,function(key){if(key in relationData){delete relationData[key]}});result.relations.push(relationData)});return{result:result}},ingestDeployer:function ingestDeployer(data,options){if(!data){return}options=options||{};var db=this.db;var targetBundle=options.targetBundle;var useGhost=options.useGhost;if(useGhost===undefined){useGhost=true}var source;if(data.services&&!data.services.services){source=data}else{if(!targetBundle&&Object.keys(data).length>1){throw new Error("Import target ambiguous, aborting.")}source=targetBundle&&data[targetBundle]||data[Object.keys(data)[0]]}var ancestors=[];var seen=[];function setupInheritance(base,baseList,bundleData,seen){var sourceData=bundleData;var seenList=seen;baseList.unshift(base);if(!base.inherits){return}if(base.inherits&&!Y.Lang.isArray(base.inherits)){base.inherits=[base.inherits]}base.inherits.forEach(function(ancestor){var baseDeploy=sourceData[ancestor];if(baseDeploy===undefined){throw new Error("Unable to resolve bundle inheritence.")}if(seenList.indexOf(ancestor)===-1){seenList.push(ancestor);setupInheritance(baseDeploy,baseList,bundleData,seenList)}})}setupInheritance(source,ancestors,data,seen);source={};ancestors.forEach(function(ancestor){Y.mix(source,ancestor,true,undefined,0,true)});var error="";Object.keys(source.services).forEach(function(serviceName){var existing=db.services.getById(serviceName);if(existing){console.log(source);error=serviceName+" is already present in the database."+" Change service name and try again."}source.services[serviceName].name=serviceName});if(error){return{error:error}}else{return{services:source.services,relations:source.relations}}},importDeployer:function importDeployer(YAMLData,name,callback){var self=this;if(!this.get("authenticated")){return callback(UNAUTHENTICATED_ERROR)}var data;if(typeof YAMLData==="string"){try{data=jsyaml.safeLoad(YAMLData)}catch(e){console.log("error parsing deployer bundle");return callback(VALUE_ERROR)}}else{data=YAMLData}var options={};if(name){options.targetBundle=name}var ingestedData=this.ingestDeployer(data,options);var servicePromises=[];if(ingestedData.error){callback(ingestedData);return}Y.each(ingestedData.services,function(serviceData){if(!serviceData.unitCount){serviceData.unitCount=serviceData.num_units}if(serviceData.options){serviceData.config=serviceData.options}servicePromises.push(self.promiseDeploy(serviceData.charm,serviceData))});self._deploymentId+=1;var deployStatus={DeploymentId:self._deploymentId,Status:"started",Timestamp:Math.round(Date.now()/1e3)};self._importChanges.push(deployStatus);if(self._importChanges.length>5){self._importChanges=self._importChanges.slice(-5)}Y.batch.apply(this,servicePromises).then(function(serviceDeployResult){serviceDeployResult.forEach(function(sdr){var serviceId=sdr.service.get("id");var serviceData=ingestedData.services[serviceId];if(serviceData.expose){self.expose(serviceId)}});ingestedData.relations.forEach(function(relationData){var relResult=self.addRelations(relationData[0],relationData[1],true);if(!Y.Lang.isArray(relResult)){relResult=[relResult]}relResult.forEach(function(result){self.changes.relations[result.relation.get("id")]=[result.relation,true]})})}).then(function(){deployStatus.Status="completed";callback({DeploymentId:self._deploymentId})},function(err){deployStatus.Status="failed";console.log(err,err.stack);callback({Error:err.error})})},promiseImport:function promiseImport(YAMLData,name){var self=this;return new Y.Promise(function(resolve){self.importDeployer(YAMLData,name,resolve)})},statusDeployer:function statusDeployer(callback){if(!this.get("authenticated")){return callback(UNAUTHENTICATED_ERROR)}callback({LastChanges:this._importChanges})},deployerWatch:function deployerWatch(deploymentId,callback){return},deployerNext:function deployerNext(watcherId,callback){return},_createErrorEvent:function _createErrorEvent(message,type,status){return{type:type||"error",target:{responseText:{Error:message},status:status||400}}},_createSuccessEvent:function _createSuccessEvent(responseText){return{target:{responseText:responseText,status:200}}},_handleLocalCharmEntries:function _handleLocalCharmEntries(contents,series,callback,errback){var metadata,config,options;try{metadata=jsyaml.safeLoad(contents.metadata)}catch(err){if(err instanceof jsyaml.YAMLException){errback("Invalid charm archive: invalid metadata: "+err);return}}var errors=models.validateCharmMetadata(metadata);if(errors.length){errback("Invalid charm archive: invalid metadata: "+errors.join(", "));return}if(contents.config){try{config=jsyaml.safeLoad(contents.config)}catch(err){if(err instanceof jsyaml.YAMLException){errback("Invalid charm archive: invalid options: "+err);return}}options=config.options}var revision=parseInt(contents.revision,10)||0;var scheme="local";var charm=this.db.charms.addFromCharmData(metadata,series,revision,scheme,options);var evt=this._createSuccessEvent(JSON.stringify({CharmURL:charm.get("url")}));callback(evt)},handleUploadLocalCharm:function handleUploadLocalCharm(file,series,completedCallback){var self=this;var errback=function errback(error){completedCallback(self._createErrorEvent(error))};var callback=function callback(allEntries){var entries=ziputils.findCharmEntries(allEntries);if(!entries.metadata){errback("Invalid charm archive: missing metadata.yaml");return}ziputils.readCharmEntries(entries,Y.rbind(self._handleLocalCharmEntries,self,series,completedCallback,errback))};ziputils.getEntries(file,callback,errback)},handleLocalCharmFileRequest:function handleLocalCharmFileRequest(charmUrl,filename,completedCallback){var evt;var charm=this.db.charms.getById(charmUrl);if(!charm){evt=this._createErrorEvent("unable to retrieve and save the charm: "+"charm not found in the provider storage","load",400);completedCallback(evt);return}if(filename){evt=this._createErrorEvent("page not found","load",404);completedCallback(evt);return}var files=[];evt=this._createSuccessEvent(JSON.stringify({Files:files}));completedCallback(evt)},getLocalCharmFileUrl:function getLocalCharmFileUrl(charmUrl,filename){if(filename==="icon.svg"){return"/juju-ui/assets/images/non-sprites/charm_160.svg"}console.error("unexpected getLocalCharmFileUrl request for "+filename)}});Y.namespace("juju.environments").FakeBackend=FakeBackend},"0.1.0",{requires:["base","js-yaml","juju-models","promise","zip-utils","jujulib-utils","juju-view-utils"]});