"use strict";YUI.add("juju-env-go",function(Y){var PING_INTERVAL=10;var environments=Y.namespace("juju.environments");var utils=Y.namespace("juju.views.utils");var endpointToName=function endpointToName(endpoint){if(!endpoint[1].name){return endpoint[0]}return endpoint[0]+":"+endpoint[1].name};var createRelationKey=function createRelationKey(endpoints){var roles=Object.create(null);Y.each(endpoints,function(value,key){roles[value.Role]=key+":"+value.Name});return roles.requirer+" "+roles.provider};var lowerObjectKeys=function lowerObjectKeys(obj){var newObj=Object.create(null);Y.each(obj,function(value,key){newObj[key.toLowerCase()]=value});return newObj};var stringifyObjectValues=function stringifyObjectValues(obj){var newObj=Object.create(null);Y.each(obj,function(value,key){if(value===null){newObj[key]=value}else{newObj[key]=value+""}});return newObj};var machineJobs={HOST_UNITS:"JobHostUnits",MANAGE_ENVIRON:"JobManageEnviron"};function GoEnvironment(config){GoEnvironment.superclass.constructor.apply(this,arguments)}GoEnvironment.NAME="go-env";Y.extend(GoEnvironment,environments.BaseEnvironment,{genericConstraints:["cpu-power","cpu-cores","mem","arch","tags","root-disk"],integerConstraints:["cpu-power","cpu-cores","mem","root-disk"],series:Object.keys(utils.getSeriesList()),facadeVersions:{CrossModelRelations:1,EnvironmentManager:1,Service:2},defaultFacades:{AllWatcher:[0],Client:[0],Pinger:[0],ChangeSet:[0],Deployer:[0],GUIToken:[0]},initializer:function initializer(){this.defaultUser="admin";this.on("_rpc_response",this._handleRpcResponse)},dispatch_result:function dispatch_result(data){var tid=data.RequestId;if(tid in this._txn_callbacks){this._txn_callbacks[tid].call(this,data);delete this._txn_callbacks[tid]}},_send_rpc:function _send_rpc(op,callback){var facade=op.Type;if(facade!=="Admin"&&!this.facadeSupported(facade)){console.error("operation not supported by API server:",op);return}var tid=this._counter+=1;if(callback){this._txn_callbacks[tid]=callback}op.RequestId=tid;if(!op.Params){op.Params={}}var version=this.facadeVersions[facade]||0;if(version!==0){op.Version=version}var msg=Y.JSON.stringify(op);this.ws.send(msg)},_watchAll:function _watchAll(){this._send_rpc({Type:"Client",Request:"WatchAll"},function(data){if(data.Error){console.log("aiiiiie!")}else{this._allWatcherId=data.Response.AllWatcherId;this._next()}})},_handleRpcResponse:function _handleRpcResponse(data){this._next();var deltas=[],cmp={serviceInfo:1,relationInfo:2,unitInfo:3,machineInfo:4,annotationInfo:5,remoteserviceInfo:100};data.Response.Deltas.forEach(function(delta){var kind=delta[0],operation=delta[1],entityInfo=delta[2];deltas.push([kind+"Info",operation,entityInfo])});deltas.sort(function(a,b){if(!cmp[a[0]]){return 1}if(!cmp[b[0]]){return-1}var scoreA=cmp[a[0]];var scoreB=cmp[b[0]];if(a[1]==="remove"){scoreA=-scoreA}if(b[1]==="remove"){scoreB=-scoreB}return scoreA-scoreB});this.fire("delta",{data:{result:deltas}})},_next:function _next(){this._send_rpc({Type:"AllWatcher",Request:"Next",Id:this._allWatcherId,Params:{}},function(data){if(data.Error){console.log("aiiiiie!")}else{this.fire("_rpc_response",data)}})},prepareConstraints:function prepareConstraints(constraints){if(typeof constraints==="string"){var constraintsObj={};constraints.trim().split(/\s+/).forEach(function(constraint){var constraintParts=constraint.trim().split("=");if(constraintParts.length!==2){console.error("Got unexpected malformed constraint",constraint);return}constraintsObj[constraintParts[0].trim()]=constraintParts[1].trim()});constraints=constraintsObj}var result=Object.create(null);Object.keys(constraints).forEach(function(key){var value;if(this.integerConstraints.indexOf(key)!==-1){value=parseInt(constraints[key],10)}else if(this.genericConstraints.indexOf(key)!==-1){value=(constraints[key]||"").trim()}if(value||value===0){result[key]=value}},this);var tags=result.tags;if(tags){result.tags=tags.split(",").reduce(function(collected,value){var tag=value.trim().split(/\s+/).join("-");if(tag){collected.push(tag)}return collected},[])}return result},handleLogin:function handleLogin(data,fromToken){fromToken=!!fromToken;this.pendingLoginResponse=false;this.userIsAuthenticated=!data.Error;if(this.userIsAuthenticated){var response=data.Response;if(response&&response.AuthTag&&response.Password){this.setCredentials({user:response.AuthTag,password:response.Password})}var facadeList=response.Facades||[];var facades=facadeList.reduce(function(previous,current){previous[current.Name]=current.Versions;return previous},{});this.set("facades",facades);this.environmentInfo();this._watchAll();if(!this.pinger){this.pinger=setInterval(this.ping.bind(this),PING_INTERVAL*1e3)}this.failedAuthentication=this.failedTokenAuthentication=false}else{this.setCredentials(null);this.failedAuthentication=!fromToken;this.failedTokenAuthentication=fromToken}this.fire("login",{data:{result:this.userIsAuthenticated,fromToken:fromToken}})},facadeSupported:function facadeSupported(name){var facades=this.get("facades")||{};var versions=facades[name]||this.defaultFacades[name]||[];var version=this.facadeVersions[name]||0;return versions.indexOf(version)>-1},handleTokenLogin:function handleTokenLogin(data){this.handleLogin(data,true)},login:function login(){if(this.userIsAuthenticated){this.fire("login",{data:{result:true}});return}if(this.pendingLoginResponse){return}var credentials=this.getCredentials();if(credentials&&credentials.areAvailable){this._send_rpc({Type:"Admin",Request:"Login",Params:{AuthTag:credentials.user,Password:credentials.password}},this.handleLogin);this.pendingLoginResponse=true}else{console.warn("Attempted login without providing credentials.");this.fire("login",{data:{result:false}})}},ping:function ping(){this._send_rpc({Type:"Pinger",Request:"Ping"})},tokenLogin:function tokenLogin(token){if(this.userIsAuthenticated){this.fire("login",{data:{result:true}});return}if(this.pendingLoginResponse){return}this._send_rpc({Type:"GUIToken",Request:"Login",Params:{Token:token}},this.handleTokenLogin)},handleEnvironmentInfo:function handleEnvironmentInfo(data){var _this=this;if(data.Error){console.warn("Error retrieving environment information.");return}var response=data.Response;this.set("defaultSeries",response.DefaultSeries);this.set("providerType",response.ProviderType);if(localStorage.getItem("environmentName")){this.set("environmentName",localStorage.getItem("environmentName"))}else{this.set("environmentName",response.Name)}if(response.ProviderType!=="maas"){this.set("maasServer",null);return}this.environmentGet(function(data){if(data.err){console.warn("error calling EnvironmentGet API: "+data.err);return}_this.set("maasServer",data.config["maas-server"])})},environmentInfo:function environmentInfo(){this._send_rpc({Type:"Client",Request:"EnvironmentInfo"},this.handleEnvironmentInfo)},environmentGet:function environmentGet(callback){var intermediateCallback;if(callback){intermediateCallback=Y.bind(this._handleEnvironmentGet,null,callback)}this._send_rpc({Type:"Client",Request:"EnvironmentGet"},intermediateCallback)},_handleEnvironmentGet:function _handleEnvironmentGet(callback,data){var transformedData={err:data.Error};if(!data.Error){transformedData.config=data.Response.Config}callback(transformedData)},uploadLocalCharm:function uploadLocalCharm(file,series,progress,callback){if(!this.userIsAuthenticated){console.warn("Attempted upload files without providing credentials.");this.fire("login",{data:{result:false}});return}var credentials=this.getCredentials();var path="/juju-core/charms?series="+series;var headers={"Content-Type":"application/zip"};var webHandler=this.get("webHandler");webHandler.sendPostRequest(path,headers,file,credentials.user,credentials.password,progress,callback)},getLocalCharmFileUrl:function getLocalCharmFileUrl(charmUrl,filename){var credentials=this.getCredentials();var path="/juju-core/charms?url="+charmUrl+"&file="+filename;var webHandler=this.get("webHandler");return webHandler.getUrl(path,credentials.user,credentials.password)},_jujuHttpGet:function _jujuHttpGet(path,progress,callback){var credentials=this.getCredentials();var webHandler=this.get("webHandler");var headers=Object.create(null);webHandler.sendGetRequest(path,headers,credentials.user,credentials.password,progress,callback)},listLocalCharmFiles:function listLocalCharmFiles(charmUrl,progress,callback){var path="/juju-core/charms?url="+charmUrl;this._jujuHttpGet(path,progress,callback)},getLocalCharmFileContents:function getLocalCharmFileContents(charmUrl,filename,progress,callback){var path="/juju-core/charms?url="+charmUrl+"&file="+filename;this._jujuHttpGet(path,progress,callback)},deployerStatus:function deployerStatus(callback){var intermediateCallback;if(callback){intermediateCallback=Y.bind(this._handleDeployerStatus,this,callback)}this._send_rpc({Type:"Deployer",Request:"Status"},intermediateCallback)},_handleDeployerStatus:function _handleDeployerStatus(userCallback,data){var lastChanges=data.Response.LastChanges||[];var transformedData={err:data.Error,changes:lastChanges.map(function(change){return{deploymentId:change.DeploymentId,status:change.Status,time:change.Time,queue:change.Queue,err:change.Error}})};userCallback(transformedData)},deployerWatch:function deployerWatch(deploymentId,callback){var intermediateCallback;if(callback){intermediateCallback=Y.bind(this.handleDeployerWatch,this,callback)}this._send_rpc({Type:"Deployer",Request:"Watch",Params:{DeploymentId:deploymentId}},intermediateCallback)},handleDeployerWatch:function handleDeployerWatch(userCallback,data){var transformedData={err:data.Error,WatchId:data.Response.WatcherId};userCallback(transformedData)},deployerNext:function deployerNext(watchId,callback){var intermediateCallback;if(callback){intermediateCallback=Y.bind(this.handleDeployerNext,this,callback)}this._send_rpc({Type:"Deployer",Request:"Next",Params:{WatcherId:watchId}},intermediateCallback)},handleDeployerNext:function handleDeployerNext(userCallback,data){var transformedData={err:data.Error,Changes:data.Response.Changes};userCallback(transformedData)},addCharm:function addCharm(url,macaroon,callback,options){var ecs=this.get("ecs");var args=ecs._getArgs(arguments);if(options&&options.immediate){this._addCharm.apply(this,args)}else{ecs._lazyAddCharm(arguments)}},_addCharm:function _addCharm(url,macaroon,callback){var handleAddCharm=function(userCallback,url,data){if(!userCallback){console.log("data returned by addCharm API call:",data);return}userCallback({err:data.Error,url:url})}.bind(this,callback,url);var request={Type:"Client",Request:"AddCharm",Params:{URL:url}};if(macaroon){request.Request="AddCharmWithAuthorization";request.Params.CharmStoreMacaroon=macaroon}this._send_rpc(request,handleAddCharm)},deploy:function deploy(charmUrl,serviceName,config,configRaw,numUnits,constraints,toMachine,callback,options){var ecs=this.get("ecs");var args=ecs._getArgs(arguments);if(options&&options.immediate){this._deploy.apply(this,args)}else{ecs._lazyDeploy(arguments)}},_deploy:function _deploy(charmUrl,serviceName,config,configRaw,numUnits,constraints,toMachine,callback){var serviceFacadeSupported=this.facadeSupported("Service");var handleDeploy=function(userCallback,serviceName,charmUrl,data){if(!userCallback){console.log("data returned by deploy API call:",data);return}if(serviceFacadeSupported){data=data.Response.Results[0]}userCallback({err:data.Error,service_name:serviceName,charm_url:charmUrl})}.bind(this,callback,serviceName,charmUrl);if(constraints){if(typeof constraints==="function"){console.error("Constraints need to be an object not a function");console.warn(constraints)}constraints=this.prepareConstraints(constraints)}else{constraints={}}var serviceParams={ServiceName:serviceName,Config:stringifyObjectValues(config),ConfigYAML:configRaw,Constraints:constraints,CharmUrl:charmUrl,NumUnits:numUnits,ToMachineSpec:toMachine};if(serviceFacadeSupported){this._send_rpc({Type:"Service",Request:"ServicesDeploy",Params:{Services:[serviceParams]}},handleDeploy);return}this._send_rpc({Type:"Client",Request:"ServiceDeploy",Params:serviceParams},handleDeploy)},addMachines:function addMachines(params,callback,options){var ecs=this.get("ecs");var args=ecs._getArgs(arguments);if(options&&options.immediate){return this._addMachines.apply(this,args)}else{return ecs.lazyAddMachines(args,options)}},_addMachines:function _addMachines(params,callback){var self=this;if(!params.length){console.log("addMachines called without machines to add");return}var intermediateCallback=null;if(callback){intermediateCallback=Y.bind(self._handleAddMachines,self,callback)}var machineParams=params.map(function(param){var machineParam={Jobs:param.jobs||[machineJobs.HOST_UNITS],Series:param.series,ParentId:param.parentId,ContainerType:param.containerType};if(param.constraints){machineParam.Constraints=self.prepareConstraints(param.constraints)}return machineParam});var request={Type:"Client",Request:"AddMachines",Params:{MachineParams:machineParams}};self._send_rpc(request,intermediateCallback)},_handleAddMachines:function _handleAddMachines(userCallback,data){var machines=data.Response.Machines||[];var transformedData={err:data.Error,machines:machines.map(function(machine){var error=null;var machineError=machine.Error;if(machineError){error=machineError.Message;if(machineError.Code){error+=" (code "+machineError.Code+")"}}return{err:error,name:machine.Machine}})};userCallback(transformedData)},destroyMachines:function destroyMachines(names,force,callback,options){var ecs=this.get("ecs");var args=ecs._getArgs(arguments);if(options&&options.immediate){return this._destroyMachines.apply(this,args)}else{return ecs._lazyDestroyMachines(args,options)}},_destroyMachines:function _destroyMachines(names,force,callback){if(!names.length){console.log("destroyMachines called without machines to remove");return}var intermediateCallback=null;if(callback){intermediateCallback=Y.bind(this._handleDestroyMachines,this,callback,names)}var request={Type:"Client",Request:"DestroyMachines",Params:{MachineNames:names,Force:!!force}};this._send_rpc(request,intermediateCallback)},_handleDestroyMachines:function _handleDestroyMachines(userCallback,names,data){var transformedData={err:data.Error,names:names};userCallback(transformedData)},setCharm:function setCharm(service_name,charm_url,force,callback){var intermediateCallback=null;if(callback){intermediateCallback=Y.bind(this.handleSetCharm,this,callback,service_name,charm_url)}this._send_rpc({Type:"Client",Request:"ServiceSetCharm",Params:{ServiceName:service_name,CharmUrl:charm_url,Force:force}},intermediateCallback)},handleSetCharm:function handleSetCharm(userCallback,service_name,charm_url,data){var transformedData={err:data.Error,service_name:service_name,charm_url:charm_url};userCallback(transformedData)},add_unit:function add_unit(service,numUnits,toMachine,callback,options){var ecs=this.get("ecs");var args=ecs._getArgs(arguments);if(options&&options.immediate){this._add_unit.apply(this,args)}else{ecs.lazyAddUnits(args,options)}},_add_unit:function _add_unit(service,numUnits,toMachine,callback){var intermediateCallback;if(callback){intermediateCallback=Y.bind(this._handleAddUnit,null,callback,service,numUnits)}this._send_rpc({Type:"Client",Request:"AddServiceUnits",Params:{ServiceName:service,NumUnits:numUnits,ToMachineSpec:toMachine}},intermediateCallback)},_handleAddUnit:function _handleAddUnit(userCallback,service,numUnits,data){var transformedData={err:data.Error,service_name:service};if(data.Error){transformedData.num_units=numUnits}else{var units=data.Response.Units;transformedData.result=units;transformedData.num_units=units.length}userCallback(transformedData)},placeUnit:function placeUnit(unit,machineId){return this.get("ecs").placeUnit(unit,machineId)},remove_units:function remove_units(unit_names,callback,options){var ecs=this.get("ecs"),args=ecs._getArgs(arguments);if(options&&options.immediate){this._remove_units.apply(this,args)}else{ecs._lazyRemoveUnit(args)}},_remove_units:function _remove_units(unit_names,callback){var intermediateCallback;if(callback){intermediateCallback=Y.bind(this.handleRemoveUnits,null,callback,unit_names)}this._send_rpc({Type:"Client",Request:"DestroyServiceUnits",Params:{UnitNames:unit_names}},intermediateCallback)},handleRemoveUnits:function handleRemoveUnits(userCallback,unitNames,data){var transformedData={err:data.Error,unit_names:unitNames};userCallback(transformedData)},expose:function expose(service,callback,options){var ecs=this.get("ecs"),args=ecs._getArgs(arguments);if(options.immediate){this._expose.apply(this,args)}else{ecs.lazyExpose(args)}},_expose:function _expose(service,callback){var intermediateCallback;if(callback){intermediateCallback=Y.bind(this.handleServiceCalls,null,callback,service)}this._send_rpc({Type:"Client",Request:"ServiceExpose",Params:{ServiceName:service}},intermediateCallback)},unexpose:function unexpose(service,callback,options){var ecs=this.get("ecs"),args=ecs._getArgs(arguments);if(options.immediate){this._unexpose.apply(this,args)}else{ecs.lazyUnexpose(args)}},_unexpose:function _unexpose(service,callback){var intermediateCallback;if(callback){intermediateCallback=Y.bind(this.handleServiceCalls,null,callback,service)}this._send_rpc({Type:"Client",Request:"ServiceUnexpose",Params:{ServiceName:service}},intermediateCallback)},handleServiceCalls:function handleServiceCalls(userCallback,service,data){var transformedData={err:data.Error,service_name:service};userCallback(transformedData)},handleSetConfig:function handleSetConfig(userCallback,serviceName,newValues,data){var transformedData={err:data.Error,service_name:serviceName,newValues:newValues};userCallback(transformedData)},update_annotations:function update_annotations(entity,type,data,callback){var intermediateCallback;if(callback){intermediateCallback=Y.bind(this.handleSetAnnotations,null,callback,entity)}this._send_rpc({Type:"Client",Request:"SetAnnotations",Params:{Tag:type+"-"+entity,Pairs:stringifyObjectValues(data)}},intermediateCallback)},remove_annotations:function remove_annotations(entity,type,keys,callback){var intermediateCallback;if(callback){intermediateCallback=Y.bind(this.handleSetAnnotations,null,callback,entity)}var data={};Y.each(keys,function(key){data[key]=""});this._send_rpc({Type:"Client",Request:"SetAnnotations",Params:{Tag:type+"-"+entity,Pairs:data}},intermediateCallback)},handleSetAnnotations:function handleSetAnnotations(userCallback,entity,data){userCallback({err:data.Error,entity:entity})},get_annotations:function get_annotations(entity,type,callback){var intermediateCallback;if(callback){intermediateCallback=Y.bind(this.handleGetAnnotations,null,callback,entity)}this._send_rpc({Type:"Client",Request:"GetAnnotations",Params:{Tag:type+"-"+entity}},intermediateCallback)},handleGetAnnotations:function handleGetAnnotations(userCallback,entity,data){userCallback({err:data.Error,entity:entity,results:data.Response&&data.Response.Annotations})},get_service:function get_service(serviceName,callback){var intermediateCallback;if(callback){intermediateCallback=Y.bind(this.handleGetService,null,callback,serviceName)}this._send_rpc({Type:"Client",Request:"ServiceGet",Params:{ServiceName:serviceName}},intermediateCallback)},handleGetService:function handleGetService(userCallback,serviceName,data){data.Response.name=data.Response.Service;var config=(data.Response||{}).Config;var transformedConfig={};Y.each(config,function(value,key){transformedConfig[key]=value.value});userCallback({err:data.Error,service_name:serviceName,result:{config:transformedConfig,constraints:(data.Response||{}).Constraints}})},set_config:function set_config(serviceName,config,data,serviceConfig,callback,options){var ecs=this.get("ecs");var args=ecs._getArgs(arguments);if(options&&options.immediate){if(ecs.changeSet[serviceName]){throw"You cannot immediately setConfig on a queued service"}else{this._set_config.apply(this,args)}}else{ecs._lazySetConfig(args)}},_set_config:function _set_config(serviceName,config,data,serviceConfig,callback){if(Y.Lang.isValue(config)&&Y.Lang.isValue(data)||!Y.Lang.isValue(config)&&!Y.Lang.isValue(data)){throw"Exactly one of config and data must be provided"}var intermediateCallback,newValues,request;request={Type:"Client",Params:{ServiceName:serviceName}};if(data){request.Request="ServiceSetYAML";request.Params.Config=data}else{newValues=config;request.Request="ServiceSet";request.Params.Options=stringifyObjectValues(newValues)}if(callback){intermediateCallback=Y.bind(this.handleSetConfig,null,callback,serviceName,newValues)}this._send_rpc(request,intermediateCallback)},destroy_service:function destroy_service(service,callback,options){var ecs=this.get("ecs");var args=ecs._getArgs(arguments);if(options&&options.immediate){this._destroyService.apply(this,args)}else{ecs._lazyDestroyService(args)}},_destroyService:function _destroyService(service,callback){var intermediateCallback;if(callback){intermediateCallback=Y.bind(this.handleServiceCalls,null,callback,service)}this._send_rpc({Type:"Client",Request:"ServiceDestroy",Params:{ServiceName:service}},intermediateCallback)},set_constraints:function set_constraints(serviceName,constraints,callback){var intermediateCallback,sendData;if(callback){intermediateCallback=Y.bind(this.handleSetConstraints,null,callback,serviceName)}constraints=this.prepareConstraints(constraints);sendData={Type:"Client",Request:"SetServiceConstraints",Params:{ServiceName:serviceName,Constraints:constraints}};this._send_rpc(sendData,intermediateCallback)},handleSetConstraints:function handleSetConstraints(userCallback,serviceName,data){var transformedData={err:data.Error,service_name:serviceName};userCallback(transformedData)},resolved:function resolved(unitName,relationName,retry,callback){if(typeof unitName!=="string"){console.error("unitName must be a string value to resolve.")}var intermediateCallback,sendData;if(callback){intermediateCallback=Y.bind(this.handleResolved,null,callback,unitName)}sendData={Type:"Client",Request:"Resolved",Params:{UnitName:unitName,Retry:!!retry}};this._send_rpc(sendData,intermediateCallback)},handleResolved:function handleResolved(userCallback,unitName,data){userCallback({op:"resolved",err:data.Error,unit_name:unitName})},add_relation:function add_relation(endpointA,endpointB,callback,options){var ecs=this.get("ecs"),args=ecs._getArgs(arguments);if(options&&options.immediate){this._add_relation.apply(this,args)}else{ecs._lazyAddRelation(args,options)}},_add_relation:function _add_relation(endpointA,endpointB,callback){var endpoint_a=endpointToName(endpointA);var endpoint_b=endpointToName(endpointB);var intermediateCallback;if(callback){intermediateCallback=Y.bind(this.handleAddRelation,null,callback,endpoint_a,endpoint_b)}this._send_rpc({Type:"Client",Request:"AddRelation",Params:{Endpoints:[endpoint_a,endpoint_b]}},intermediateCallback)},handleAddRelation:function handleAddRelation(userCallback,endpoint_a,endpoint_b,data){var result={};var response=data.Response;if(response&&response.Endpoints){var serviceNameA=endpoint_a.split(":")[0];var serviceNameB=endpoint_b.split(":")[0];result.endpoints=[];Y.each([serviceNameA,serviceNameB],function(serviceName){var jujuEndpoint=response.Endpoints[serviceName];var guiEndpoint={};guiEndpoint[serviceName]={name:jujuEndpoint.Name};result.endpoints.push(guiEndpoint)});result.id=createRelationKey(response.Endpoints);result["interface"]=response.Endpoints[serviceNameA].Interface;result.scope=response.Endpoints[serviceNameA].Scope}userCallback({request_id:data.RequestId,endpoint_a:endpoint_a,endpoint_b:endpoint_b,err:data.Error,result:result})},remove_relation:function remove_relation(endpointA,endpointB,callback,options){var ecs=this.get("ecs"),args=ecs._getArgs(arguments);if(options&&options.immediate){this._remove_relation.apply(this,args)}else{ecs._lazyRemoveRelation(args)}},_remove_relation:function _remove_relation(endpointA,endpointB,callback){var endpoint_a=endpointToName(endpointA);var endpoint_b=endpointToName(endpointB);var intermediateCallback;if(callback){intermediateCallback=Y.bind(this.handleRemoveRelation,null,callback,endpoint_a,endpoint_b)}this._send_rpc({Type:"Client",Request:"DestroyRelation",Params:{Endpoints:[endpoint_a,endpoint_b]}},intermediateCallback)},handleRemoveRelation:function handleRemoveRelation(userCallback,endpoint_a,endpoint_b,data){userCallback({err:data.Error,endpoint_a:endpoint_a,endpoint_b:endpoint_b})},get_charm:function get_charm(charmURL,callback){var intermediateCallback;if(callback){intermediateCallback=Y.bind(this.handleCharmInfo,null,callback)}this._send_rpc({Type:"Client",Request:"CharmInfo",Params:{CharmURL:charmURL}},intermediateCallback)},handleCharmInfo:function handleCharmInfo(userCallback,data){var parseItems=function parseItems(items){var result={};Y.each(items,function(value,key){result[key]=lowerObjectKeys(value)});return result};var result,response=data.Response;if(!Y.Object.isEmpty(response)){var meta=response.Meta;result={config:{options:parseItems(response.Config.Options)},peers:parseItems(meta.Peers),provides:parseItems(meta.Provides),requires:parseItems(meta.Requires),url:response.URL,revision:response.Revision,description:meta.Description,format:meta.Format,name:meta.Name,subordinate:meta.Subordinate,summary:meta.Summary}}var transformedData={err:data.Error,result:result};userCallback(transformedData)},getBundleChanges:function getBundleChanges(bundleYAML,changesToken,callback){self=this;var handleLegacy=function handleLegacy(userCallback,data){if(!userCallback){console.log("data returned by ChangeSet.GetChanges:",data);return}userCallback({errors:data.Error&&[data.Error]||data.Response.Errors,changes:data.Response&&data.Response.Changes})};var handle=function handle(userCallback,data){if(data.ErrorCode==="not implemented"){self._send_rpc({Type:"ChangeSet",Request:"GetChanges",Params:params},handleLegacy.bind(self,userCallback));return}if(!userCallback){console.log("data returned by Client.GetBundleChanges:",data);return}userCallback({errors:data.Error&&[data.Error]||data.Response.errors,changes:data.Response&&data.Response.changes})};var params=Object.create(null);if(bundleYAML!==null){params.YAML=bundleYAML}else{params.Token=changesToken}self._send_rpc({Type:"Client",Request:"GetBundleChanges",Params:params},handle.bind(self,callback))},offer:function offer(service,endpoints,url,users,description,callback){if(!url){var user=this.getCredentials().user.replace(/^user-/,"");var envName=this.get("environmentName");url="local:/u/"+user+"/"+envName+"/"+service}var handleOffer=function(userCallback,service,endpoints,url,data){if(!userCallback){console.log("data returned by offer API call:",data);return}var err=data.Error;if(!err){var errResponse=data.Response.Results[0].Error;err=errResponse&&errResponse.Message}userCallback({err:err,service:service,endpoints:endpoints,url:url})}.bind(this,callback,service,endpoints,url);if(users&&users.length){users=users.map(function(user){return"user-"+user})}else{users=["user-public"]}var offer={servicename:service,endpoints:endpoints,serviceurl:url,allowedusers:users,servicedescription:description};this._send_rpc({Type:"CrossModelRelations",Request:"Offer",Params:{Offers:[offer]}},handleOffer)},listOffers:function listOffers(filters,callback){var handleListOffers=function(userCallback,data){if(!userCallback){console.log("data returned by listOffers API call:",data);return}if(data.Error){userCallback({err:data.Error,results:[]});return}var apiResults=data.Response.results[0].result;var results=apiResults.map(function(apiResult){if(apiResult.error){return{err:apiResult.error}}var result=apiResult.result;return{service:result.servicename,url:result.serviceurl,charm:result.charmname,endpoints:result.endpoints.map(function(endpoint){return{name:endpoint.name,interface:endpoint["interface"],role:endpoint.role}})}});userCallback({results:results})}.bind(this,callback);var filter={FilterTerms:[]};this._send_rpc({Type:"CrossModelRelations",Request:"ListOffers",Params:{Filters:[filter]}},handleListOffers)},getOffer:function getOffer(url,callback){var handleGetOffer=function(userCallback,data){if(!userCallback){console.log("data returned by getOffer API call:",data);return}var err=data.Error,response={};if(!err){response=data.Response.results[0];err=response.error&&response.error.Message}if(err){userCallback({err:err});return}var result=response.result;userCallback({service:result.servicename,url:result.serviceurl,description:result.servicedescription,sourceName:result.sourcelabel,sourceId:result.sourceenviron.replace(/^environment-/,""),endpoints:result.endpoints.map(function(endpoint){return{name:endpoint.name,interface:endpoint["interface"],role:endpoint.role}})})}.bind(this,callback);this._send_rpc({Type:"CrossModelRelations",Request:"ServiceOffers",Params:{serviceurls:[url]}},handleGetOffer)},createEnv:function createEnv(envName,userTag,callback){var _this2=this;var intermediateCallback;if(callback){intermediateCallback=this._handleCreateEnv.bind(null,callback)}else{intermediateCallback=function(callback,data){console.log("createEnv done: err:",data.Error)}}this._send_rpc({Type:"EnvironmentManager",Request:"ConfigSkeleton"},function(data){if(data.Error){intermediateCallback({Error:"cannot get configuration skeleton: "+data.Error});return}var config=data.Response.Config;_this2.environmentGet(function(data){if(data.err){intermediateCallback({Error:"cannot get environment configuration: "+data.err});return}config.name=envName;config["authorized-keys"]="ssh-rsa INVALID";var ptype=_this2.get("providerType");switch(ptype){case"local":config.namespace=data.config.namespace;break;case"ec2":config["access-key"]=data.config["access-key"];config["secret-key"]=data.config["secret-key"];break;case"openstack":config["tenant-name"]=data.config["tenant-name"];config.username=data.config.username;config.password=data.config.password;break;case"maas":config["maas-server"]=data.config["maas-server"];config["maas-oauth"]=data.config["maas-oauth"];config["maas-agent-name"]=data.config["maas-agent-name"];break;default:intermediateCallback({Error:ptype+" provider is not supported yet"});return}_this2._send_rpc({Type:"EnvironmentManager",Request:"CreateEnvironment",Params:{OwnerTag:userTag,Config:config}},intermediateCallback)})})},_handleCreateEnv:function _handleCreateEnv(callback,data){var transformedData={err:data.Error};if(!data.Error){var response=data.Response;transformedData.name=response.Name;transformedData.owner=response.OwnerTag;transformedData.uuid=response.UUID}callback(transformedData)},listEnvs:function listEnvs(userTag,callback){var intermediateCallback;if(callback){intermediateCallback=this._handleListEnvs.bind(null,callback)}this._send_rpc({Type:"EnvironmentManager",Request:"ListEnvironments",Params:{Tag:userTag}},intermediateCallback)},_handleListEnvs:function _handleListEnvs(callback,data){var transformedData={err:data.Error};if(!data.Error){var response=data.Response;transformedData.envs=response.UserEnvironments.map(function(value){return{name:value.Name,owner:value.OwnerTag,uuid:value.UUID,lastConnection:value.LastConnection}})}callback(transformedData)}});environments.endpointToName=endpointToName;environments.createRelationKey=createRelationKey;environments.GoEnvironment=GoEnvironment;environments.lowerObjectKeys=lowerObjectKeys;environments.stringifyObjectValues=stringifyObjectValues;environments.machineJobs=machineJobs;var KVM={label:"LXC",value:"lxc"},LXC={label:"KVM",value:"kvm"};environments.providerFeatures={all:{supportedContainerTypes:[KVM,LXC]},azure:{supportedContainerTypes:[]},demonstration:{supportedContainerTypes:[KVM,LXC]},ec2:{supportedContainerTypes:[]},joyent:{supportedContainerTypes:[]},local:{supportedContainerTypes:[]},maas:{supportedContainerTypes:[KVM,LXC]},openstack:{supportedContainerTypes:[]},manual:{supportedContainerTypes:[]}}},"0.1.0",{requires:["base","json-parse","json-stringify","juju-env-base","juju-view-utils"]
});