"use strict";YUI.add("juju-fakebackend-simulator",function(Y){var environmentsModule=Y.namespace("juju.environments");var DEFAULT_INTERVAL=3e3;var RAND=function RAND(prob){return Math.random()<=prob};var createContainer=function createContainer(state){var machines=state.db.machines.filterByParent(null);if(!machines.length){return null}var names=machines.map(function(machine){return machine.id});var name=names[Math.floor(Math.random()*names.length)];var result=state.addMachines([{parentId:name,containerType:"lxc"}]);return result.machines[0].name};environmentsModule.createContainer=createContainer;var DEFAULT_AGENTS={landscape:{start:function start(context){var db=context.state.db;var envAnno=db.environment.get("annotations");envAnno["landscape-url"]="http://landscape.example.com";envAnno["landscape-computers"]="/computers/criteria/environment:test";envAnno["landscape-reboot-alert-url"]="+alert:computer-reboot/info#power";envAnno["landscape-security-alert-url"]="+alert:security-upgrades/packages/list?filter=security";context.state.updateAnnotations("env",envAnno);context.serviceAnnotations(context)},serviceAnnotations:function serviceAnnotations(context){context.state.db.services.each(function(service){var annotations=service.get("annotations")||{};var sid=service.get("id");if(!annotations["landscape-computers"]){annotations["landscape-computers"]="+service:"+sid;context.state.updateAnnotations(sid,annotations)}})},unitAnnotations:function unitAnnotations(context){context.selection.each(function(service){service.get("units").each(function(unit){var annotations=unit.annotations||{};if(!annotations["landscape-computer"]){annotations["landscape-computer"]="+unit:"+unit.urlName;context.state.updateAnnotations(unit.id,annotations)}})})},select:{list:"services"},reboot_chance_per_unit:.05,upgrade_chance_per_unit:.05,run:function run(context){context.serviceAnnotations(context);context.unitAnnotations(context);context.selection.each(function(service){service.get("units").each(function(unit){var annotations=unit.annotations||{};var changed=false;if(RAND(context.reboot_chance_per_unit)){annotations["landscape-needs-reboot"]=!annotations["landscape-needs-reboot"];changed=true}if(RAND(context.upgrade_chance_per_unit)){annotations["landscape-security-upgrades"]=!annotations["landscape-security-upgrades"];changed=true}if(changed){context.state.updateAnnotations(unit.id,annotations)}})})}},unitCounts:{select:{list:"services",random:.1},run:function run(context){context.selection.each(function(service){if(RAND(.5)){var toMachine;if(RAND(.6)){toMachine=null}else{toMachine=createContainer(context.state)}context.state.addUnit(service.get("id"),1,toMachine)}else{var units=service.get("units");if(units.length>1){var unit=units.item(units.length-1);context.state.removeUnits([unit.id])}}})}},unitStatus:{select:{list:"services"},run:function run(context){context.selection.each(function(service){service.get("units").each(function(unit){if(RAND(.95)){return}var roll=Math.random();if(roll<=.35){unit.agent_state="started";unit.agent_state_info=undefined;unit.agent_state_data={}}else if(roll<=.7){if(roll<=.5){unit.agent_state="installing"}else{unit.agent_state="pending"}unit.agent_state_info=undefined;unit.agent_state_data={}}else if(roll<=1){unit.agent_state="error";var db=context.state.db;var serviceName=this.service;var relations=db.relations.get_relations_for_service(db.services.getById(serviceName));if(roll<=.8&&relations.length>0){var relation=relations[Math.floor(Math.random()*relations.length)];var interfaceName,remoteUnit;relation.get("endpoints").forEach(function(endpoint){if(endpoint[0]!==serviceName){remoteUnit=endpoint[0];return}interfaceName=endpoint[1].name});unit.agent_state_info='hook failed: "'+interfaceName+'-relation-changed"';unit.agent_state_data={hook:interfaceName+"-relation-changed","relation-id":1,"remote-unit":remoteUnit+"/0"}}else if(roll<=.9){unit.agent_state_info='hook failed: "install"';unit.agent_state_data={hook:"install"}}else if(roll<=1){unit.agent_state_info='hook failed: "config-changed"';unit.agent_state_data={hook:"config-changed"}}}context.state.changes.units[unit.id]=[unit,true]})})}},position:{threshold:0,start:function start(context){var canvas=Y.one("body"),width=canvas.getDOMNode().getClientRects()[0].width,height=canvas.getDOMNode().getClientRects()[0].height;this.set("width",width);this.set("height",height)},select:{list:"services"},run:function run(context){var width=context.width,height=context.height;var axis=RAND(.5)&&"x"||"y";context.selection.each(function(s){var annotations=s.get("annotations")||{};var x=annotations["gui-x"];var y=annotations["gui-y"];if(!Y.Lang.isNumber(x)){return}if(axis==="x"){annotations["gui-x"]=width-x}else{annotations["gui-y"]=height-y}context.state.updateAnnotations(s.get("id"),annotations)})}}};environmentsModule.DEFAULT_AGENTS=DEFAULT_AGENTS;function Agent(config){Agent.superclass.constructor.apply(this,arguments)}Agent.NAME="Agent";Agent.ATTRS={started:{value:false}};Y.extend(Agent,Y.Base,{_allowAdHocAttrs:true,getContext:function getContext(){var context=this.getAttrs();delete context.initialized;delete context.destroyed;return context},start:function start(){var context=this.getContext();if(this.get("started")===true){return}if(context.start){context.start.call(this,context)}this.set("started",true)},select:function select(context){var select=context.select;var db=context.state.db;if(!select){return}if(select.list){context.selection=db[select.list]}if(select.filter){context.selection=select.filter(context)}if(context.selection!==undefined){context.selection=context.selection.filter({asList:true},function(model){return(model.pending||model.get&&model.get("pending"))!==true})}if(select.random!==undefined){context.selection=context.selection.filter({asList:true},function(){return Math.random()<=select.random})}},run:function run(){var context=this.getContext();if(context.threshold!==undefined&&!RAND(context.threshold)){return}if(context.select){this.select(context);this.set("selection",context.selection)}if(context.run){context.run.call(this,context)}}});environmentsModule.Agent=Agent;function Simulator(config){Simulator.superclass.constructor.apply(this,arguments)}Simulator.NAME="Simulator";Simulator.ATTRS={agents:{},state:{},useDefaultAgents:{value:true},interval:{value:DEFAULT_INTERVAL}};Y.extend(Simulator,Y.Base,{initializer:function initializer(){this._agents=null;this._scheduler=null;this.publish("tick");if(this.get("useDefaultAgents")){var agents=this.get("agents")||{};this.set("agents",Y.mix(agents,DEFAULT_AGENTS))}this._updateAgents();this.after("stateChange",this._updateAgents,this);this.after("agentsChange",this._updateAgents,this);return this},destructor:function destructor(){this.stop()},_updateAgents:function _updateAgents(){var decls=this.get("agents");var state=this.get("state");var agents={};Y.each(decls,function(spec,name){spec=spec||{};spec.state=state;agents[name]=new Agent(spec)});this._agents=agents},start:function start(){var self=this,state=this.get("state");if(this._scheduler){this.stop()}var tick=function tick(){if(state.get("authenticated")===true){Y.each(self._agents,function(agent,name){if(agent.get("started")!==true){agent.start.call(agent)}agent.run.call(agent)})}self.fire("tick")};this._scheduler=Y.later(self.get("interval"),self,tick,undefined,true);tick();return this},stop:function stop(){if(this._scheduler){this._scheduler.cancel();this._scheduler=null}return this},toggle:function toggle(){if(this._scheduler){this.stop()}else{this.start()}return this}});environmentsModule.Simulator=Simulator},"0.1.0",{requires:["base","event","juju-models","promise","yui-later"]});