"use strict";YUI.add("bundle-importer",function(Y){var ns=Y.namespace("juju");function BundleImporter(cfg){this.env=cfg.env;this.db=cfg.db;this.fakebackend=cfg.fakebackend;this.hideDragOverNotification=cfg.hideDragOverNotification;this._dryRunIndex=-1;this._collectedServices=[]}BundleImporter.prototype={importBundleYAML:function importBundleYAML(bundleYAML){this.db.notifications.add({title:"Fetching bundle data",message:"Fetching detailed bundle data, this may take some time",level:"important"});this.fetchDryRun(bundleYAML,null)},importChangesToken:function importChangesToken(changesToken){this.fetchDryRun(null,changesToken)},importBundleFile:function importBundleFile(file){var reader=this._generateFileReader();reader.onload=this._fileReaderOnload.bind(this,file);reader.readAsText(file);this.hideDragOverNotification();return reader},importBundleDryRun:function importBundleDryRun(records){this.recordSet=this._sortDryRunRecords(records);this._executeDryRun(this.recordSet)},_ensureV4Format:function _ensureV4Format(bundleYAML){try{var bundle=jsyaml.safeLoad(bundleYAML);if(bundle.services&&!bundle.services.services){return bundleYAML}else{var firstBundleName=Object.keys(bundle)[0];var firstBundle=bundle[firstBundleName];return JSON.stringify(firstBundle)}}catch(e){return bundleYAML}},fetchDryRun:function fetchDryRun(bundleYAML,changesToken){if(bundleYAML){bundleYAML=this._ensureV4Format(bundleYAML)}this.env.getBundleChanges(bundleYAML,changesToken,this._handleFetchDryRun.bind(this))},_handleFetchDryRun:function _handleFetchDryRun(response){if(response.errors&&response.errors.length){this.db.notifications.add({title:"Error generating changeSet",message:"The following errors occurred while retrieving bundle "+"changes: "+response.errors.join(", "),level:"error"});return}this.importBundleDryRun(response.changes)},_generateFileReader:function _generateFileReader(){return new FileReader},_fileReaderOnload:function _fileReaderOnload(file,e){var data;var notifications=this.db.notifications;var extension=file.name.split(".").pop();var result=e.target.result;if(extension==="json"){try{data=JSON.parse(result)}catch(e){notifications.add({title:"Invalid changeset format",message:"The supplied file could not be parsed as JSON.",level:"error"});return}notifications.add({title:"Processing File",message:"Changeset processing started.",level:"important"});this.importBundleDryRun(data)}else if(extension==="yaml"){notifications.add({title:"Processing File",message:"Changeset processing started.",level:"important"});this.fetchDryRun(result,null)}},_collectRequires:function _collectRequires(records,record,requires){if(record.requires){record.requires.forEach(function(requiredRecordId){requires.push(requiredRecordId);this._collectRequires(records,records.filter(function(r){return r.id===requiredRecordId})[0],requires)},this)}return requires},_sortDryRunRecords:function _sortDryRunRecords(records){var changeSet=[];var count=records.length;var record;for(var i=0;i<count;i+=1){record=records[i];if(record.requires.length===0){changeSet.push(record);continue}var prereq=this._collectRequires(records,record,[]).every(function(recordId){return changeSet.some(function(record){return record.id===recordId?true:false})});if(prereq){var exists=changeSet.some(function(set){return set.id===record.id});if(!exists){changeSet.push(record)}}else{records.push(record);count+=1;continue}}return changeSet},_saveModelToRequires:function _saveModelToRequires(id,model){this.recordSet.forEach(function(record){record.requires.forEach(function(require){if(require===id){record[id]=model}})})},_executeDryRun:function _executeDryRun(records){if(this._dryRunIndex===records.length-1){this.db.notifications.add({title:"Import Complete",message:"ChangeSet import complete.",level:"important"});this._dryRunIndex=-1;var collectedServices=this._collectedServices;this._collectedServices=[];this.db.fire("bundleImportComplete",{services:collectedServices});return}this._dryRunIndex+=1;this._executeRecord(records[this._dryRunIndex],records)},_executeRecord:function _executeRecord(record,records){var method=this["_execute_"+record.method];if(typeof method==="function"){this["_execute_"+record.method](record,this._executeDryRun.bind(this,records))}else{this.db.notifications.add({title:"Unknown method type",message:record.method+"is not supported. Stopping bundle import.",level:"error"})}},_execute_expose:function _execute_expose(record,next){var serviceId=record[record.args[0].replace(/^\$/,"")].get("id");this.env.expose(serviceId,null,{});next()},_execute_addMachines:function _execute_addMachines(record,next){var parentKey=record.args[0].parentId;parentKey=parentKey&&parentKey.replace(/^\$/,"");var parentId="";if(parentKey){if(parentKey.indexOf("addMachine")>-1){parentId=record[parentKey].id}else if(parentKey.indexOf("addUnit")>-1){if(record[parentKey].machine){parentId=record[parentKey].machine}else{parentId=record[parentKey].id}}record.args[0].parentId=parentId}var machine=this.db.machines.addGhost(record.args[0].parentId,record.args[0].containerType);this.env.addMachines(record.args,function(machine){this.db.machines.remove(machine)}.bind(this,machine),{modelId:machine.id});this._saveModelToRequires(record.id,machine);next(machine)},_execute_deploy:function _execute_deploy(record,next){record.args.forEach(function(arg,index){if(typeof arg==="string"&&arg.indexOf("$")===0&&arg.split("-").length===2){var recordId=arg.replace(/^\$/,"");var requiredModel=record[recordId];switch(index){case 0:record.args[0]=requiredModel.get("id");break}}});this.fakebackend._loadCharm(record.args[0],{success:function(charm){var ghostService=this.db.services.ghostService(charm);if(record.annotations){ghostService.annotations["gui-x"]=record.annotations["gui-x"];ghostService.annotations["gui-y"]=record.annotations["gui-y"]}var config={};var charmOptions=charm.get("options");if(charmOptions){Object.keys(charmOptions).forEach(function(key){if(record.args[2][key]){config[key]=record.args[2][key]}else{var value=charmOptions[key];config[key]=value["default"]}})}var displayName=record.args[1];ghostService.set("name",displayName);ghostService.set("displayName",displayName);ghostService.set("config",config);var constraints=record.args[3]||{};this.env.deploy(charm.get("id"),record.args[1],record.args[2],undefined,0,constraints,null,function(ghostService){var name=ghostService.get("name");ghostService.setAttrs({id:name,displayName:undefined,pending:false,loading:false,config:ghostService.get("config"),constraints:constraints});this.env.update_annotations(name,"service",ghostService.get("annotations"))}.bind(this,ghostService),{modelId:ghostService.get("id")});this._saveModelToRequires(record.id,ghostService);this._collectedServices.push(ghostService);next()}.bind(this),failure:function failure(){this.db.notifications.add({title:"Unable to load charm",message:"Charm "+record.args[0]+" was not able to be loaded.",level:"error"})}})},_execute_addCharm:function _execute_addCharm(record,next){var db=this.db;var charmId=record.args[0];this.fakebackend._loadCharm(charmId,{success:function(charm){if(db.charms.getById(charm.get("id"))===null){charm.loaded=true;db.charms.add(charm)}this._saveModelToRequires(record.id,charm);next()}.bind(this),failure:function failure(){db.notifications.add({title:"Unable to load charm",message:"Charm "+charmId+" was not able to be loaded.",level:"error"})}})},_execute_addUnit:function _execute_addUnit(record,next){var serviceId,charmUrl,size,name;if(record.args.length===2){record.args[2]=record.args[1];record.args[1]=1}record.args.forEach(function(arg,index){if(typeof arg==="string"&&arg.indexOf("$")===0&&arg.split("-").length===2){var recordId=arg.replace(/^\$/,"");var requiredModel=record[recordId];switch(index){case 0:serviceId=requiredModel.get("id");record.args[0]=serviceId;charmUrl=requiredModel.get("charm");size=requiredModel.get("units").size();name=requiredModel.get("name")+"/"+size;break;case 2:record.args[2]=requiredModel.id;break}}},this);var unitId=serviceId+"/"+size;var ghostUnit=this.db.addUnits({id:unitId,displayName:name,charmUrl:charmUrl,subordinate:this.db.charms.getById(charmUrl).get("is_subordinate")});this._saveModelToRequires(record.id,ghostUnit);function removeGhostCallback(ghostUnit,db,e){ghostUnit.service=e.service_name;db.removeUnits(ghostUnit)}record.args[3]=removeGhostCallback.bind(this,ghostUnit,this.db);if(record.args.length===3){record.args.push(null)}record.args.push({modelId:unitId});this.env.add_unit.apply(this.env,record.args);if(record.args[2]===null){this._execute_addMachines({args:[{}],id:record.id},function(machine){record.args[2]=machine.id}.bind(this))}this.env.placeUnit(ghostUnit,record.args[2]);next()},_execute_addRelation:function _execute_addRelation(record,next){var ep1=record.args[0].split(":");var ep2=record.args[1].split(":");var endpoints=[[ep1[0],{name:ep1[1]}],[ep2[0],{name:ep2[1]}]];endpoints.forEach(function(ep,index){endpoints[index][0]=record[ep[0].replace(/^\$/,"")].get("id")},this);var relationId="pending-"+record.args[0]+record.args[1];var relation=this.db.relations.add({relation_id:relationId,interface:endpoints[0][1].name,endpoints:endpoints,pending:true,scope:"global",display_name:"pending"});this.env.add_relation(endpoints[0],endpoints[1],function(e){this.db.relations.create({relation_id:e.result.id,type:e.result["interface"],endpoints:endpoints,pending:false,scope:e.result.scope})}.bind(this),{modelId:relation.get("id")});next()},_execute_setAnnotations:function _execute_setAnnotations(record,next){if(record.args[1]==="service"){var entityName=record[record.args[0].replace(/^\$/,"")].get("id");var service=this.db.services.getById(entityName);service.set("annotations",record.args[2])}next()}};ns.BundleImporter=BundleImporter},"",{requires:["juju-env-go","environment-change-set"]});