"use strict";YUI.add("environment-change-set",function(Y){var ns=Y.namespace("juju"),utils=Y.namespace("juju.views.utils");var name="environment-change-set";ns.EnvironmentChangeSet=Y.Base.create(name,Y.Base,[],{initializer:function initializer(){this.changeSet={};this.currentCommit=[];this.currentIndex=0},getCurrentChangeSet:function getCurrentChangeSet(){var currentChangeSet={};Y.Object.each(this.changeSet,function(value,key){if(value.index===this.currentIndex){currentChangeSet[key]=value}},this);return currentChangeSet},_updateChangesetFromResults:function _updateChangesetFromResults(record,results){var changeSet=this.changeSet,changeSetRecord;Object.keys(changeSet).forEach(function(key){changeSetRecord=changeSet[key];if(changeSetRecord.command.onParentResults&&changeSetRecord.parents&&changeSetRecord.parents.indexOf(record.key)!==-1){changeSetRecord.command.onParentResults(record,results)}})},_getArgs:function _getArgs(args){var lastParam=args[args.length-1];var cut;if(Y.Lang.isObject(lastParam)&&Y.Lang.isFunction(args[args.length-2])){cut=-1}return Y.clone(Array.prototype.slice.call(args,0,cut))},_generateRandomNumber:function _generateRandomNumber(){return Math.floor(Math.random()*1e3+1)},_generateUniqueKey:function _generateUniqueKey(type){var key=this._generateRandomNumber();while(this.changeSet[type+"-"+key]!==undefined){key=this._generateRandomNumber()}return key},_createNewRecord:function _createNewRecord(type,command,parents){var key=type+"-"+this._generateUniqueKey(type);parents=parents||[];this.changeSet[key]={id:key,index:this.currentIndex,parents:Y.Array.filter(parents,function(parent){return!!parent}),executed:false,command:command,timestamp:Date.now()};this.fire("changeSetModified");this._wrapCallback(this.changeSet[key]);return key},_removeExistingRecord:function _removeExistingRecord(id){delete this.changeSet[id];this.fire("changeSetModified")},_wrapCallback:function _wrapCallback(record){var args=record.command.args;var index=args.length-1;var callback;if(Y.Lang.isFunction(args[index])){callback=args[index]}else{callback=function(){};index+=1}var self=this;function _callbackWrapper(){record.executed=true;self._markCommitStatus("committed",record.command);var result=callback.apply(this,self._getArgs(arguments));self.fire("taskComplete",{id:record.id,record:record,result:arguments});self.levelRecordCount-=1;delete self.changeSet[record.id];self._updateChangesetFromResults(record,arguments);self.fire("changeSetModified");return result}args[index]=_callbackWrapper},_execute:function _execute(env,record){var command=record.command;if(command.prepare){command.prepare(this.get("db"))}this._markCommitStatus("in-progress",record.command);env[command.method].apply(env,command.args)},_buildHierarchy:function _buildHierarchy(removeUnplaced){var hierarchy=[[]],command,keyToLevelMap={},currLevel=1,keys=[],db=this.get("db"),unplacedUnits=db.units.filterByMachine(null);this.placedCount=0;Y.Object.each(this.changeSet,function(value,key){if(value.index===this.currentIndex){keys.push(key)}},this);if(unplacedUnits&&removeUnplaced){var unplacedIds=unplacedUnits.map(function(u){return u.id});keys=keys.filter(function(key){var command=this.changeSet[key].command,modelId=command.options&&command.options.modelId;if(command.method!=="_add_unit"){return true}if(unplacedIds.indexOf(modelId)<0){return true}else{this.changeSet[key].index+=1;return false}},this)}keys.forEach(Y.bind(function(key){command=this.changeSet[key];command.key=key;if(!command.parents||command.parents.length===0){hierarchy[0].push(Y.clone(command));command.placed=true;keyToLevelMap[key]=0;this.placedCount+=1}else{keyToLevelMap[key]=1}},this));while(this.placedCount<keys.length){hierarchy.push([]);Y.Object.each(keyToLevelMap,Y.bind(this._placeIfNeeded,this,currLevel,keyToLevelMap,hierarchy));currLevel+=1}return hierarchy},_placeIfNeeded:function _placeIfNeeded(currLevel,keyToLevelMap,hierarchy,value,key){var command=this.changeSet[key];if(!command||command.placed){return}var alreadyPlacedParents=true;if(command.parents.length>0){for(var i=0;i<command.parents.length;i+=1){if(keyToLevelMap[command.parents[i]]>=currLevel){alreadyPlacedParents=false}}}if(alreadyPlacedParents){hierarchy[currLevel].push(Y.clone(command));command.placed=true;keyToLevelMap[key]=currLevel;this.placedCount+=1}},_commitNext:function _commitNext(env,currentIndex){var record;this.currentLevel+=1;this.levelRecordCount=this.currentCommit[this.currentLevel].length;this.currentCommit[this.currentLevel].forEach(function(changeSetRecord){record=this.changeSet[changeSetRecord.key];this._execute(env,record);this.fire("commit",record)},this);this.levelTimer=Y.later(200,this,this._waitOnLevel,[env,currentIndex],true)},_waitOnLevel:function _waitOnLevel(env,currentIndex){if(this.levelRecordCount===0){this.levelTimer.cancel();if(this.currentLevel<this.currentCommit.length-1){Y.soon(Y.bind(this._commitNext,this,env,currentIndex))}else{this.currentLevel=-1;delete this.currentCommit;this.fire("currentCommitFinished",{index:currentIndex})}}},_markCommitStatus:function _markCommitStatus(status,command){var db=this.get("db"),modelList;switch(command.method){case"_addMachines":modelList=db.machines;break}if(modelList){var model=modelList.getById(command.options.modelId);if(model){if(!(model instanceof Y.Model)){model=modelList.revive(model)}model.set("commitStatus",status);if(typeof modelList.free==="function"){modelList.free(model)}}}},commit:function commit(env){this.currentCommit=this._buildHierarchy(true);this.currentIndex+=1;this.currentLevel=-1;this._commitNext(env,this.currentIndex-1)},clear:function clear(){var toClear=this._buildHierarchy(false);toClear.reverse().forEach(function(level){level.forEach(function(change){this._clearFromDB(change.command)}.bind(this))}.bind(this));Y.Object.each(this.changeSet,function(value,key){if(value.index===this.currentIndex){delete this.changeSet[key]}},this);this.currentIndex+=1;this.currentCommit=[];this.fire("changeSetModified");this.get("db").fire("update")},_clearFromDB:function _clearFromDB(command){var db=this.get("db"),services=db.services,machines=db.machines,relations=db.relations,units=db.units;switch(command.method){case"_deploy":services.remove(services.getById(command.options.modelId));break;case"_destroyService":services.getById(command.args[0]).set("deleted",false);break;case"_destroyMachines":var machineId=command.args[0][0];machines.getById(command.args[0]).deleted=false;machines.filterByAncestor(machineId).forEach(function(machine){machine.deleted=false});units.filterByMachine(machineId,true).forEach(function(unit){unit.deleted=false});break;case"_set_config":var service=services.getById(command.args[0]);var config=service.get("config");var envConfig=service.get("environmentConfig");Object.keys(config).forEach(function(key){config[key]=envConfig[key]});service.set("config",config);break;case"_add_relation":relations.remove(relations.getById(command.options.modelId));break;case"_remove_relation":relations.getRelationFromEndpoints([command.args[0],command.args[1]]).set("deleted",false);break;case"_remove_units":command.args[0].forEach(function(unit){units.getById(unit).deleted=false});break;case"_expose":services.getById(command.args[0]).set("exposed",false);break;case"_unexpose":services.getById(command.args[0]).set("exposed",true);break;case"_addMachines":machines.remove(machines.getById(command.options.modelId));break;case"_add_unit":db.removeUnits(units.getById(command.options.modelId));break}},_lazyDeploy:function _lazyDeploy(args){var command={method:"_deploy",args:this._getArgs(args),prepare:function prepare(db){if(!this.options||!this.options.modelId){return}var ghostService=db.services.getById(this.options.modelId);this.args[1]=ghostService.get("name");Object.keys(this.args[2]).forEach(function(key){if(this.args[2][key]===undefined){delete this.args[2][key]}},this)}};if(command.args.length!==args.length){command.options=args[args.length-1]}var toMachine=command.args[6];if(!this.changeSet[parent]){toMachine=[]}return this._createNewRecord("service",command,toMachine)},_lazyDestroyService:function _lazyDestroyService(args){var command={method:"_destroyService",args:this._getArgs(args)};if(command.args.length!==args.length){command.options=args[args.length-1]}var existingService;Object.keys(this.changeSet).forEach(function(key){if(this.changeSet[key].command.method==="_deploy"){if(this.changeSet[key].command.options.modelId===args[0]){existingService=key}}},this);if(existingService){this._destroyQueuedService(existingService)}else{var service=this.get("db").services.getById(args[0]);var units=[];service.get("units").each(function(unit){units.push(unit.id)},this);this._lazyRemoveUnit([units]);service.set("deleted",true);return this._createNewRecord("destroyService",command,[])}},_destroyQueuedService:function _destroyQueuedService(service){Object.keys(this.changeSet).forEach(function(key){if(this.changeSet[key].parents.indexOf(service)!==-1){this._removeExistingRecord(key)}},this);var db=this.get("db");var modelId=this.changeSet[service].command.options.modelId;var model=db.services.getById(modelId);var units=model.get("units");var relations=model.get("relations");units.each(function(unit){db.removeUnits(unit)});db.relations.remove(relations);db.services.remove(model);model.updateSubordinateUnits(db);model.destroy();this._removeExistingRecord(service)},_lazyDestroyMachines:function _lazyDestroyMachines(args){var command={method:"_destroyMachines",args:this._getArgs(args)};if(command.args.length!==args.length){command.options=args[args.length-1]}var existingMachine;Object.keys(this.changeSet).forEach(function(key){if(this.changeSet[key].command.method==="_addMachines"){if(this.changeSet[key].command.options.modelId===args[0][0]){existingMachine=key}}},this);var db=this.get("db");var machine=db.machines.getById(command.args[0]);var removedUnits=[];var units=db.units.filterByMachine(machine.id,true);units.forEach(function(unit){var unitModel=db.units.revive(unit);if(!unit.agent_state){delete unit.machine;removedUnits.push(unit);unitModel.set("machine",null)}else{unitModel.set("deleted",true)}db.units.free(unitModel)},this);if(machine.parentId){var parentMachine=db.machines.getById(machine.parentId);removedUnits.forEach(function(unit){var idx=parentMachine.units.indexOf(unit);parentMachine.units.splice(idx,1)})}if(existingMachine){this._destroyQueuedMachine(existingMachine)}else{var allMachines=db.machines.filterByAncestor(machine.id);allMachines.unshift(machine);allMachines.forEach(function(machine){var machineModel=db.machines.revive(machine);machineModel.set("deleted",true);db.machines.free(machineModel)});return this._createNewRecord("destroyMachines",command,[])}},_destroyQueuedMachine:function _destroyQueuedMachine(machine){Object.keys(this.changeSet).forEach(function(key){var change=this.changeSet[key];var idx=change.parents?change.parents.indexOf(machine):-1;if(idx!==-1){if(change.command.method==="_add_unit"){change.parents.splice(idx,1);change.command.args[2]=null}else{this._removeExistingRecord(key)}}},this);var db=this.get("db");var modelId=this.changeSet[machine].command.options.modelId;db.machines.remove(db.machines.getById(modelId));this._removeExistingRecord(machine)},_lazySetConfig:function _lazySetConfig(args){var ghostServiceName=args[0],parent=[];Y.Object.each(this.changeSet,function(value,key){if(value.command.method==="_deploy"){if(value.command.options.modelId===args[0]){parent.push(key)}}});var command={method:"_set_config",args:args,onParentResults:function onParentResults(record,results){if(record.command.method==="_deploy"){var tempId=this.args[0];if(tempId.indexOf("$")>-1&&record.command.options.modelId===tempId){this.args[0]=results[0].service_name}}}};var config=args[1];var service=this.get("db").services.getById(ghostServiceName);var changedFields=config;var DIRTYFIELDS="_dirtyFields";var dirtyFields=service.get(DIRTYFIELDS);dirtyFields=dirtyFields.concat(Object.keys(changedFields));service.set(DIRTYFIELDS,dirtyFields);service.set("config",Y.mix(service.get("config"),changedFields,true,null,null,true));return this._createNewRecord("setConfig",command,parent)},_lazyAddRelation:function _lazyAddRelation(args,options){var serviceA;var serviceB;Y.Object.each(this.changeSet,function(value,key){if(value.command.method==="_deploy"){if(value.command.options.modelId===args[0][0]){serviceA=key}if(value.command.options.modelId===args[1][0]){serviceB=key}}});var db=this.get("db");var service=db.services.getServiceByName(args[0][0]);service.updateSubordinateUnits(db);var parent=[serviceA,serviceB];var command={method:"_add_relation",args:args,options:options,onParentResults:function onParentResults(record,results){if(record.command.method==="_deploy"){this.args.forEach(function(arg,index){if(Y.Lang.isArray(arg)&&record.command.options.modelId===arg[0]){this.args[index][0]=results[0].service_name}},this)}}};return this._createNewRecord("addRelation",command,parent)},_lazyRemoveRelation:function _lazyRemoveRelation(args){var changeSet=this.changeSet,argsEndpoints=[args[0],args[1]],ghosted=false,command,record;var relations=this.get("db").relations;Object.keys(changeSet).forEach(function(key){command=changeSet[key].command;if(command.method==="_add_relation"){if(relations.compareRelationEndpoints([command.args[0],command.args[1]],argsEndpoints)){ghosted=true;this._removeExistingRecord(key);relations.remove(relations.getRelationFromEndpoints(argsEndpoints))}}},this);if(!ghosted){record=this._createNewRecord("removeRelation",{method:"_remove_relation",args:args});relations.getRelationFromEndpoints(argsEndpoints).set("deleted",true)}return record},_lazyRemoveUnit:function _lazyRemoveUnit(args){var changeSet=this.changeSet,toRemove=args[0],db=this.get("db"),units=db.units,command,record;Object.keys(changeSet).forEach(function(key){command=changeSet[key].command;if(command.method==="_add_unit"){var unitName=command.options.modelId;var unitIndex=toRemove.indexOf(unitName);if(unitIndex!==-1){toRemove.splice(unitIndex,1);this._removeExistingRecord(key);var unit=units.getById(unitName);db.removeUnits(unit);db.services.getServiceByName(unit.service).updateSubordinateUnits(db)}}},this);if(toRemove.length>0){args[0]=toRemove;record=this._createNewRecord("removeUnit",{method:"_remove_units",args:args});args[0].forEach(function(unit){var unit=units.getById(unit);var unitModel=units.revive(unit);unitModel.set("deleted",true);units.free(unitModel);db.fire("update")})}return record},lazyExpose:function lazyExpose(args){var db=this.get("db");var parent=[];Y.Object.each(this.changeSet,function(value,key){if(value.command.method==="_deploy"){if(value.command.options.modelId===args[0]){parent.push(key)}}});db.services.getById(args[0]).set("exposed",true);return this._createNewRecord("expose",{method:"_expose",args:args,onParentResults:function onParentResults(record,results){if(record.command.method==="_deploy"){var tempId=this.args[0];if(tempId.indexOf("$")>-1&&record.command.options.modelId===tempId){this.args[0]=results[0].service_name}}}},parent)},lazyUnexpose:function lazyUnexpose(args){var existingExpose;var db=this.get("db");Object.keys(this.changeSet).forEach(function(key){if(this.changeSet[key].command.method==="_expose"){if(this.changeSet[key].command.args[0]===args[0]){existingExpose=key}}},this);db.services.getById(args[0]).set("exposed",false);if(existingExpose){this._removeExistingRecord(existingExpose)}else{return this._createNewRecord("unexpose",{method:"_unexpose",args:args})}},lazyAddMachines:function lazyAddMachines(args,options){var parent=[];args[0].forEach(function(param){if(param.parentId){Y.Object.each(this.changeSet,function(value,key){var command=value.command;if(command.method==="_addMachines"&&command.options.modelId===param.parentId){parent.push(key)}},this)}},this);var command={method:"_addMachines",args:args,options:options,prepare:function prepare(db){var units=db.units.filterByMachine(this.options.modelId);if(!units.length){return}var url=units[0].charmUrl;this.args[0][0].series=utils.getSeries(url)},onParentResults:function onParentResults(record,results){if(record.command.method==="_addMachines"){var currentParentId=record.command.options.modelId;var newParentId=results[0].machines[0].name;this.args[0].forEach(function(param){param.parentId=param.parentId.replace(currentParentId,newParentId)})}}};return this._createNewRecord("addMachines",command,parent)},lazyAddUnits:function lazyAddUnits(args,options){var parent=[];Y.Object.each(this.changeSet,function(value,key){if(value.command.method==="_deploy"){if(value.command.options.modelId===args[0]){parent.push(key);args[0]=value.command.args[1]}}});var toMachine=args[2];if(toMachine){Y.Object.each(this.changeSet,function(value,key){var command=value.command;if(command.method==="_addMachines"&&command.options.modelId===toMachine){parent.push(key)}},this)}var db=this.get("db");var command={method:"_add_unit",args:args,options:options,onParentResults:function onParentResults(record,results){switch(record.command.method){case"_addMachines":var newMachineId=results[0].machines[0].name;this.args[2]=newMachineId;break;case"_deploy":var newServiceId=record.command.args[1];this.args[0]=newServiceId;var unit=db.updateUnitId(newServiceId,this.options.modelId);this.options.modelId=unit.id;break}}};var service=db.services.getServiceByName(args[0]);service.updateSubordinateUnits(db);return this._createNewRecord("addUnits",command,parent)},_retrieveUnitRecord:function _retrieveUnitRecord(unitId){var record;Y.Object.some(this.changeSet,function(value,key){var command=value.command;if(command.method==="_add_unit"&&command.options.modelId===unitId){record=value;return true}});return record},placeUnit:function placeUnit(unit,machineId){var record=this._retrieveUnitRecord(unit.id);if(!record){return"attempted to place a unit which has not been added: "+unit.id}var db=this.get("db");var error=this.validateUnitPlacement(unit,db.machines.getById(machineId));if(error){db.notifications.add({title:"Error placing unit",message:"Error placing unit: "+error,level:"error"});return error}record.parents=record.parents.filter(function(parent){return parent.indexOf("addMachines")!==0});var containerExists=true;Y.Object.each(this.changeSet,function(value,key){var command=value.command;if(command.method==="_addMachines"&&command.options.modelId===machineId){record.parents.push(key);containerExists=false}},this);if(containerExists&&machineId){record.command.args[2]=machineId}var unitsDb=db.units;var unitModel=unitsDb.revive(unit);unitModel.set("machine",machineId);unitsDb.free(unitModel);return null},validateUnitPlacement:function validateUnitPlacement(unit,machine){var unitSeries=utils.getSeries(unit.charmUrl);if(machine.series){if(machine.series!==unitSeries){return"unable to place a "+unitSeries+" unit on the "+machine.series+" machine "+machine.id}return null}var error=null;var db=this.get("db");db.units.filterByMachine(machine.id).some(function(existingUnit){var existingUnitSeries=utils.getSeries(existingUnit.charmUrl);if(existingUnitSeries!==unitSeries){error="machine "+machine.id+" already includes units with a "+"different series: "+existingUnitSeries;return true}});return error}},{ATTRS:{db:{}}})},"",{requires:["base","base-build","juju-view-utils"]});