"use strict";YUI.add("juju-topology-relation",function(Y){var views=Y.namespace("juju.views"),models=Y.namespace("juju.models"),utils=Y.namespace("juju.views.utils"),topoUtils=Y.namespace("juju.topology.utils"),d3=Y.namespace("d3"),components=Y.namespace("d3-components"),Templates=views.Templates;var RelationModule=Y.Base.create("RelationModule",components.Module,[],{events:{scene:{".rel-indicator":{click:"relationClick",mousemove:"mousemove"},".relation-remove":{click:{callback:"relationRemoveClick"}},".inspect-relation":{click:{callback:"inspectRelationClick"}},".dragline":{click:{callback:"draglineClicked"}},".zoom-plane":{mousemove:{callback:"mousemove"}}},yui:{addRelationDrag:"addRelationDrag",addRelationDragEnd:"addRelationDragEnd",addRelationDragStart:"addRelationDragStart",cancelRelationBuild:"cancelRelationBuild",clearState:"clearState",fade:"fade",mouseMove:"mouseMoveHandler",rendered:"renderedHandler",rerenderRelations:"rerender",serviceMoved:"updateLinkEndpoints",servicesRendered:"updateLinks",show:"show",snapOutOfService:"snapOutOfService",snapToService:"snapToService"}},initializer:function initializer(options){RelationModule.superclass.constructor.apply(this,arguments);this.relations=[]},render:function render(){RelationModule.superclass.render.apply(this,arguments);return this},update:function update(){RelationModule.superclass.update.apply(this,arguments);var topo=this.get("component");var db=topo.get("db");var relations=db.relations.toArray();this.relations=this.decorateRelations(relations);this.updateLinks();this.updateSubordinateRelationsCount();this.updateRelationVisibility();return this},rerender:function rerender(){var topo=this.get("component");topo.vis.selectAll(".rel-group").remove();this.update()},renderedHandler:function renderedHandler(){this.update()},processRelation:function processRelation(relation){var self=this;var topo=self.get("component");var endpoints=relation.get("endpoints");var rel_services=[];Y.each(endpoints,function(endpoint){rel_services.push([endpoint[1].name,topo.service_boxes[endpoint[0]]])});return rel_services},decorateRelations:function decorateRelations(relations){var self=this;var decorated=[];Y.each(relations,function(relation){var pair=self.processRelation(relation);if(pair.length===2){var source=pair[0][1];var target=pair[1][1];if(!source||!target){return}var decoratedRelation=views.DecoratedRelation(relation,source,target);decorated.push(decoratedRelation)}});return utils.toRelationCollections(decorated)},updateLinks:function updateLinks(){var g=this.drawRelationGroup();g.each(this.drawRelation);if(this.get("relationMenuActive")){this.showRelationMenu(this.get("relationMenuRelation"))}g.exit().remove()},updateLinkEndpoints:function updateLinkEndpoints(evt){var self=this;var service=evt.service;var topo=self.get("component");var parentId=topo._yuid;if(!service.relations||service.relations.size()===0){return}Y.each(Y.Array.filter(self.relations,function(relation){return relation.source.id===service.id||relation.target.id===service.id}),function(relation){var rel_group=topo.vis.select("#"+utils.generateSafeDOMId(relation.id,parentId));var connectors=relation.source.getConnectorPair(relation.target);var s=connectors[0];var t=connectors[1];rel_group.select("line").attr("x1",s[0]).attr("y1",s[1]).attr("x2",t[0]).attr("y2",t[1])})},drawRelationGroup:function drawRelationGroup(){var self=this;var topo=this.get("component");var vis=topo.vis;var parentId=topo._yuid;var imageSize=20;var g=vis.selectAll("g.rel-group").data(self.relations,function(r){return r.compositeId});var enter=g.enter().insert("g","g.service").attr("id",function(d){return utils.generateSafeDOMId(d.id,parentId)}).classed("rel-group",true);enter.append("svg:line","g.service").attr("class",function(d){return"relation "+d.aggregatedStatus});enter.append("circle").attr({cx:0,cy:0,r:4,class:function _class(d){return"connector1 "+d.aggregatedStatus}});enter.append("circle").attr({cx:0,cy:0,r:4,class:function _class(d){return"connector2 "+d.aggregatedStatus}});enter.append("g").classed("rel-indicator",true).append("image").attr({width:imageSize,height:imageSize,x:imageSize/-2,y:imageSize/-2,rx:imageSize/2,ry:imageSize/2});enter.append("text").append("tspan").text(function(d){return d.display_name});g.filter(function(d){var currStatus=d3.select(this).select("image").attr("xlink:href")||"";currStatus=currStatus.split("relation-icon-").reverse()[0].split(".")[0];return currStatus!==d.aggregatedStatus}).selectAll("image").attr("xlink:href",function(d){return"juju-ui/assets/svgs/relation-icon-"+d.aggregatedStatus+".svg"});return g},drawRelation:function drawRelation(relation){var connectors=relation.source.getConnectorPair(relation.target);var s=connectors[0];var t=connectors[1];var link=d3.select(this).select("line");var connector1=d3.select(this).select(".connector1");var connector2=d3.select(this).select(".connector2");var relationIcon=d3.select(this).select(".rel-indicator");var sRadius=relation.source.w/2-4;var tRadius=relation.target.w/2-4;link.attr("x1",s[0]).attr("y1",s[1]).attr("x2",t[0]).attr("y2",t[1]).attr("class",function(d){return"relation "+relation.aggregatedStatus});var deg=Math.atan2(s[1]-t[1],s[0]-t[0]);var dot1=[s[0]+-(Math.cos(deg)*sRadius),s[1]+-(Math.sin(deg)*sRadius)];var dot2=[t[0]+Math.cos(deg)*tRadius,t[1]+Math.sin(deg)*tRadius];connector1.attr("cx",dot1[0]).attr("cy",dot1[1]);connector2.attr("cx",dot2[0]).attr("cy",dot2[1]);relationIcon.attr("transform",function(d){return"translate("+[Math.max(dot1[0],dot2[0])-Math.abs((dot1[0]-dot2[0])/2),Math.max(dot1[1],dot2[1])-Math.abs((dot1[1]-dot2[1])/2)]+")"});return link},updateSubordinateRelationsCount:function updateSubordinateRelationsCount(){var topo=this.get("component");var vis=topo.vis;var self=this;vis.selectAll(".service.subordinate").selectAll(".sub-rel-block tspan").text(function(d){return self.subordinateRelationsForService(d).length})},draglineClicked:function draglineClicked(d,self){var topo=self.get("component");topo.fire("clearState")},mousemove:function mousemove(d,self){if(self.clickAddRelation){var mouse=d3.mouse(self.get("dragplane"));var box=self.get("addRelationStart_service");d3.event.x=mouse[0];d3.event.y=mouse[1];self.addRelationDrag.call(self,{box:box})}},mouseMoveHandler:function mouseMoveHandler(evt){var container=this.get("container");this.mousemove.call(container.one(".zoom-plane").getDOMNode(),null,this)},snapToService:function snapToService(evt){var d=evt.service;var rect=evt.rect;if(d===this.get("addRelationStart_service")){return}this.set("potential_drop_point_service",d);this.set("potential_drop_point_rect",rect);utils.addSVGClass(rect,"hover");if(this.dragline){var connectors=d.getConnectorPair(this.get("addRelationStart_service"));var s=connectors[0];var t=connectors[1];this.dragline.attr("x1",t[0]).attr("y1",t[1]).attr("x2",s[0]).attr("y2",s[1]).attr("class","relation pending-relation dragline");this.draglineOverService=true}},snapOutOfService:function snapOutOfService(){this.clearRelationSettings();if(this.dragline){this.dragline.attr("class","relation pending-relation dragline dragging");this.draglineOverService=false;this.clickAddRelation=true;this.get("component").buildingRelation=true}},addRelationDragStart:function addRelationDragStart(evt){var d=evt.service;var vis=this.get("component").vis;var dragline=vis.insert("line",":first-child").attr("class","relation pending-relation dragline dragging");var self=this;this.set("dragplane",Y.one(".the-canvas g").getDOMNode());var mouse=d3.mouse(this.get("dragplane"));self.cursorBox=new views.BoundingBox;self.cursorBox.pos={x:mouse[0],y:mouse[1],w:0,h:0};var point=self.cursorBox.getConnectorPair(d);dragline.attr("x1",point[0][0]).attr("y1",point[0][1]).attr("x2",point[1][0]).attr("y2",point[1][1]);self.dragline=dragline;vis.select(".plus-service").classed("fade",true);self.addRelationStart(d,self)},addRelationDrag:function addRelationDrag(evt){var d=evt.box;if(!d||!this.dragline){this.clearRelationSettings();return}if(!this.draglineOverService){if(!this.cursorBox){this.addRelationDragStart(evt)}this.cursorBox.pos={x:d3.event.x,y:d3.event.y,w:0,h:0};var connectors=this.cursorBox.getConnectorPair(d),s=connectors[1];this.dragline.attr("x1",s[0]).attr("y1",s[1]).attr("x2",d3.event.x).attr("y2",d3.event.y)}},addRelationDragEnd:function addRelationDragEnd(){var self=this;var topo=self.get("component");var rect=self.get("potential_drop_point_rect");var endpoint=self.get("potential_drop_point_service");topo.buildingRelation=false;self.cursorBox=null;if(rect){self.ambiguousAddRelationCheck(endpoint,self,rect)}else{self.cancelRelationBuild()}topo.fire("addRelationEnd")},removeRelation:function removeRelation(relation,view,confirmButton){var topo=this.get("component");var env=topo.get("env");topo.fire("clearState");var relationElement=view.get("container").one("#"+utils.generateSafeDOMId(relation.relation_id,topo._yuid));utils.addSVGClass(relationElement,"to-remove pending-relation");env.remove_relation(relation.endpoints[0],relation.endpoints[1],Y.bind(this._removeRelationCallback,this,view,relationElement,relation.relation_id,confirmButton))},_removeRelationCallback:function _removeRelationCallback(view,relationElement,relationId,confirmButton,ev){var topo=this.get("component"),db=topo.get("db");if(ev.err){db.notifications.add({title:"Error deleting relation",message:"Relation "+ev.endpoint_a+" to "+ev.endpoint_b,level:"error"});utils.removeSVGClass(this.relationElement,"to-remove pending-relation")}else{var relation=db.relations.getById(relationId);var service;relation.get("endpoints").forEach(function(endpoint){if(!endpoint){console.error("invalid endpoints on relation");return}service=db.services.getById(endpoint[0]);service.removeRelations(relation.get("relation_id"))});db.relations.remove(relation);topo.update()}topo.fire("clearState")},clearState:function clearState(){this.clearRelationSettings();this.cancelRelationBuild();this.set("relationMenuActive",false);this.set("relationMenuRelation",undefined)},cancelRelationBuild:function cancelRelationBuild(){var topo=this.get("component");var vis=topo.vis;if(this.dragline){this.dragline.remove();this.dragline=null}this.clickAddRelation=null;topo.buildingRelation=false;topo.update();vis.selectAll(".service").classed("selectable-service",false);vis.selectAll(".plus-service").classed("fade",false);topo.fire("addRelationEnd")},clearRelationSettings:function clearRelationSettings(){var topo=this.get("component");topo.buildingRelation=false;this.clickAddRelation=null;this.draglineOverService=false;this.set("potential_drop_point_service",undefined);this.set("potential_drop_point_rect",undefined)},updateRelationVisibility:function updateRelationVisibility(){var db=this.get("component").get("db");var actions={fade:[],show:[],hide:[]};var name;db.services.each(function(service){name=service.get("id");if(service.get("fade")){actions.fade.push(name)}if(service.get("hide")){actions.hide.push(name)}if(!service.get("fade")&&!service.get("hide")){actions.show.push(name)}});if(actions.fade.length>0){this.fade({serviceNames:actions.fade})}if(actions.hide.length>0){this.hide({serviceNames:actions.hide})}if(actions.show.length>0){this.show({serviceNames:actions.show})}},show:function show(evt){var serviceNames=evt.serviceNames;var topo=this.get("component");if(!serviceNames||serviceNames.length===0){serviceNames=Object.keys(topo.service_boxes)}var selection=topo.vis.selectAll(".rel-group").filter(function(d){return(serviceNames.indexOf(d.source.id)>-1||serviceNames.indexOf(d.target.id)>-1)&&d.target.hide===false&&d.source.hide===false&&d.target.fade===false&&d.source.fade===false});selection.classed(topoUtils.getVisibilityClasses("show"))},fade:function fade(evt){var serviceNames=evt.serviceNames;if(!serviceNames){return}var topo=this.get("component");var selection=topo.vis.selectAll(".rel-group").filter(function(d){return serviceNames.indexOf(d.source.id)>-1||serviceNames.indexOf(d.target.id)>-1});selection.classed(topoUtils.getVisibilityClasses("fade"))},hide:function hide(evt){var serviceNames=evt.serviceNames;if(!serviceNames){return}var topo=this.get("component");var selection=topo.vis.selectAll(".rel-group").filter(function(d){return serviceNames.indexOf(d.source.id)>-1||serviceNames.indexOf(d.target.id)>-1});selection.classed(topoUtils.getVisibilityClasses("hide"))},startRelation:function startRelation(service){var topo=this.get("component");var vis=topo.vis;topo.buildingRelation=true;this.clickAddRelation=true;topo.fire("show",{selection:vis.selectAll(".service")});var db=topo.get("db");var endpointsController=topo.get("endpointsController");var endpoints=models.getEndpoints(service,endpointsController);var possible_relations=Y.Array.map(Y.Array.flatten(Y.Object.values(endpoints)),function(ep){return ep.service});var invalidRelationTargets={};db.services.each(function(s){if(Y.Array.indexOf(possible_relations,s.get("id"))===-1){invalidRelationTargets[s.get("id")]=true}});var sel=vis.selectAll(".service").classed("selectable-service",true).filter(function(d){return d.id in invalidRelationTargets&&d.id!==service.get("id")});topo.fire("fade",{selection:sel,serviceNames:Object.keys(invalidRelationTargets)});sel.classed("selectable-service",false);this.set("addRelationStart_possibleEndpoints",endpoints);this.set("currentServiceClickAction","ambiguousAddRelationCheck")},addRelationStart:function addRelationStart(m,view,context){var topo=view.get("component");var service=topo.serviceForBox(m);view.startRelation(service);view.set("addRelationStart_service",m)},ambiguousAddRelationCheck:function ambiguousAddRelationCheck(m,view,context){var endpoints=view.get("addRelationStart_possibleEndpoints")[m.id];var topo=view.get("component");if(endpoints&&endpoints.length===1){var ep=endpoints[0];var endpoints_item=[[ep[0].service,{name:ep[0].name,role:"server"}],[ep[1].service,{name:ep[1].name,role:"client"}]];view.addRelationEnd(endpoints_item,view,context);return}endpoints=endpoints.sort(function(a,b){return a[0].name+a[1].name<b[0].name+b[1].name});endpoints=this._getServiceDisplayName(endpoints,topo);view.clickAddRelation=null;var menu=this._renderAmbiguousRelationMenu(endpoints);this._attachAmbiguousReleationSelect(menu,view,context);this._positionAmbiguousRelationMenu(menu,topo,m,context)},_getServiceDisplayName:function _getServiceDisplayName(endpoints,topo){var serviceName,displayName;return endpoints.map(function(endpoint){endpoint.forEach(function(handle){serviceName=handle.service;if(serviceName.indexOf("$")>0){displayName=topo.get("db").services.getById(serviceName).get("displayName").replace(/^\(/,"").replace(/\)$/,"")}else{displayName=serviceName}handle.displayName=displayName});return[endpoint[0],endpoint[1]]},this)},_renderAmbiguousRelationMenu:function _renderAmbiguousRelationMenu(endpoints){var menu=this.get("container").one("#ambiguous-relation-menu");if(menu.one(".menu")){menu.one(".menu").remove(true)}menu.append(Templates.ambiguousRelationList({endpoints:endpoints}));return menu},_attachAmbiguousReleationSelect:function _attachAmbiguousReleationSelect(menu,view,context){menu.one(".menu").delegate("click",function(evt){var el=evt.target;var endpoints_item=[[el.getData("startservice"),{name:el.getData("startname"),role:"server"}],[el.getData("endservice"),{name:el.getData("endname"),role:"client"}]];menu.removeClass("active");view.addRelationEnd(endpoints_item,view,context)},"li");menu.one(".cancel").on("click",function(evt){menu.removeClass("active");view.cancelRelationBuild()})},_positionAmbiguousRelationMenu:function _positionAmbiguousRelationMenu(menu,topo,m,context){var tr=topo.zoom.translate();var z=topo.zoom.scale();var locateAt=topoUtils.locateRelativePointOnCanvas(m,tr,z);menu.setStyle("left",locateAt[0]);menu.setStyle("top",locateAt[1]);menu.addClass("active");topo.set("active_service",m);topo.set("active_context",context);topo.fire("resized")},addRelationEnd:function addRelationEnd(endpoints,module){module.cancelRelationBuild();module.clearRelationSettings();var topo=module.get("component");var env=topo.get("env");if(endpoints[0][0]===endpoints[1][0]){return}var relation=this._addPendingRelation(endpoints);topo.update();topo.bindAllD3Events();env.add_relation(endpoints[0],endpoints[1],Y.bind(this._addRelationCallback,this,module,relation.get("relation_id")),{modelId:relation.get("id")})},_addPendingRelation:function _addPendingRelation(endpoints){var topo=this.get("component");var db=topo.get("db");var endpoint1=endpoints[0][0],endpoint2=endpoints[1][0];var idBlock=""+endpoint1+endpoint2;var interfaceBlock=""+endpoints[0][1].name+endpoints[1][1].name;var endpointData=utils.parseEndpointStrings(db,[endpoint1,endpoint2]);var match=utils.findEndpointMatch(endpointData);var relation=db.relations.add({relation_id:"pending-"+idBlock+interfaceBlock,interface:match["interface"],endpoints:endpoints,pending:true,scope:match.scope||"global",display_name:"pending"});endpoints.forEach(function(endpoint){var serviceBox=topo.service_boxes[endpoint[0]];serviceBox.relations.add(relation)});return relation},_addRelationCallback:function _addRelationCallback(module,relation_id,ev){var topo=module.get("component");var db=topo.get("db");var vis=topo.vis;db.relations.remove(db.relations.getById(relation_id));vis.select("#"+utils.generateSafeDOMId(relation_id,topo._yuid)).remove();if(ev.err){db.notifications.add({title:"Error adding relation",message:"Relation "+ev.endpoint_a+" to "+ev.endpoint_b+": "+ev.err,level:"error"})}else{var result=ev.result;var endpoints=Y.Array.map(result.endpoints,function(item){var id=Y.Object.keys(item)[0];return[id,item[id]]});db.relations.create({relation_id:result.id,type:result["interface"],endpoints:endpoints,pending:false,scope:result.scope})}topo.update();topo.bindAllD3Events()},subordinateRelationsForService:function subordinateRelationsForService(service){return this.relations.filter(function(relation){return(relation.source.modelId===service.modelId||relation.target.modelId===service.modelId)&&relation.isSubordinate})},relationClick:function relationClick(relation,self){if(self.get("disableRelationInteraction")){return}self.showRelationMenu(relation)},showSubRelDialog:function showSubRelDialog(){var subRelDialog=views.createModalPanel("You may not remove a subordinate relation.","#rmsubrelation-modal-panel");subRelDialog.addButton({value:"Cancel",section:Y.WidgetStdMod.FOOTER,action:function action(e){e.preventDefault();subRelDialog.hide();subRelDialog.destroy()},classNames:["button"]});subRelDialog.get("boundingBox").all(".yui3-button").removeClass("yui3-button")},showRelationMenu:function showRelationMenu(relation){var menu=Y.one("#relation-menu");var menuInternals=menu.one(".menu");if(menuInternals){menuInternals.remove(true)}menu.append(Templates.relationList({relations:relation.relations}));menu.addClass("active");this.set("relationMenuActive",true);this.set("relationMenuRelation",relation);var topo=this.get("component");var tr=topo.zoom.translate();var z=topo.zoom.scale();var line=relation.source.getConnectorPair(relation.target);var coords=topoUtils.findCenterPoint(line[0],line[1]);var point={x:coords[0],y:coords[1],w:0,h:0};var locateAt=topoUtils.locateRelativePointOnCanvas(point,tr,z);locateAt[0]-=menu.get("clientWidth")/2;locateAt[1]-=menu.get("clientHeight")+16;menu.setStyle("left",locateAt[0]);menu.setStyle("top",locateAt[1]);menu.one(".triangle").setStyle("left",menu.get("clientWidth")/2-5);topo.fire("resized")},relationRemoveClick:function relationRemoveClick(_,self){var topo=self.get("component");var db=topo.get("db");var relationId=Y.one(this).get("parentNode").getData("relationid");var relation=db.relations.getById(relationId);relation=self.decorateRelations([relation])[0];if(relation.isSubordinate){topo.fire("clearState");self.showSubRelDialog()}else{self.removeRelation(relation.relations[0],self);topo.fire("clearState")}},inspectRelationClick:function inspectRelationClick(_,self){var topo=self.get("component");var endpoint=Y.one(this).getAttribute("data-endpoint");var serviceId=endpoint.split(":")[0].trim();topo.fire("changeState",{sectionA:{component:"inspector",metadata:{id:serviceId}}})}},{ATTRS:{component:{},dragplane:{},disableRelationInteraction:{},relationMenuActive:{value:false},relationMenuRelation:{}}});views.RelationModule=RelationModule},"0.1.0",{requires:["d3","d3-components","node","event","juju-models","juju-topology-utils"]});