"use strict";YUI.add("juju-topology-service",function(Y){var d3=Y.namespace("d3"),components=Y.namespace("d3-components"),models=Y.namespace("juju.models"),topoUtils=Y.namespace("juju.topology.utils"),utils=Y.namespace("juju.views.utils"),views=Y.namespace("juju.views"),ziputils=Y.namespace("juju.ziputils");var ServiceModuleCommon=function ServiceModuleCommon(){this.centerOnLoad=true};ServiceModuleCommon.prototype.updateData=function(){var _this=this;var topo=this.get("component");var vis=topo.vis;var db=topo.get("db");var env=topo.get("env");var visibleServices=db.services.visible();views.toBoundingBoxes(this,visibleServices,topo.service_boxes,env);var serviceCount=visibleServices.size();visibleServices.reset();this.node=vis.selectAll(".service").data(Y.Object.values(topo.service_boxes),function(d){return d.modelId});if(this.centerOnLoad&&serviceCount>0){this.centerOnLoad=false;setTimeout(function(){_this.panToCenter()})}};ServiceModuleCommon.prototype.updateServiceNodes=function(node){if(node.empty()){return}var self=this,topo=this.get("component");var movedNodes=0;node.each(function(d){var service=d.model,annotations=service.get("annotations"),x,y;d.subordinate?d.w=d.h=130:d.w=d.h=190;if(!annotations||d.inDrag){return}x=annotations["gui-x"];y=annotations["gui-y"];if(x===undefined||y===undefined){return}x=parseFloat(x);y=parseFloat(y);if(x!==d.x||y!==d.y){if(!d.inDrag){var useTransitions=self.get("useTransitions");self.drag.call(this,d,self,{x:x,y:y},useTransitions);movedNodes+=1;topo.annotateBoxPosition(d)}}});if(movedNodes>1){this.findCentroid()}node.filter(function(d){return d.subordinate}).classed("subordinate",true);node.attr({width:function width(box){return box.w},height:function height(box){return box.h}});node.select(".service-block").attr({cx:function cx(d){return d.subordinate?65:95},cy:function cy(d){return d.subordinate?65:95},r:function r(d){return d.subordinate?60:90}});node.select(".service-block__halo").attr({cx:function cx(d){return d.subordinate?65:95},cy:function cy(d){return d.subordinate?65:95},r:function r(d){return d.subordinate?80:110}});node.select(".service-icon").attr("transform",function(d){return d.subordinate?"translate(17, 17)":"translate(47, 47)"});node.select(".relation-button").attr("transform",function(d){return"translate("+[d.subordinate?65:95,30]+")"});var rerenderRelations=false;node.select(".service-block").each(function(d){var curr_node=d3.select(this),parent_node=d3.select(this.parentNode),is_pending=false,is_uncommitted=false,is_erroring=false;if(d.subordinate){curr_node.attr({stroke:"#888888","stroke-width":1})}else if(d.pending||d.deleted){curr_node.attr({stroke:"#19b6ee","stroke-width":3});rerenderRelations=true}else if(d.highlighted){rerenderRelations=true}else{var units=d.units._items;units.forEach(function(unit){if(unit.agent_state==="installing"||unit.agent_state==="pending"){is_pending=true}else if(unit.agent_state==="error"){is_erroring=true}else if(!unit.agent_state){is_uncommitted=true}});if(is_erroring){parent_node.classed("is-erroring",true).classed("is-pending",false).classed("is-uncommitted",false).classed("is-running",false)}else if(is_pending){parent_node.classed("is-pending",true).classed("is-erroring",false).classed("is-uncommitted",false).classed("is-running",false)}else if(is_uncommitted){parent_node.classed("is-uncommitted",true).classed("is-erroring",false).classed("is-pending",false).classed("is-running",false)}else{parent_node.classed("is-running",true).classed("is-erroring",false).classed("is-uncommitted",false).classed("is-pending",false)}rerenderRelations=true}curr_node.attr({width:d.w,height:d.h})});if(rerenderRelations){topo.fire("rerenderRelations")}var subRelationIndicator=node.filter(function(d){return d3.select(this).select(".sub-rel-block").empty()&&d.subordinate}).insert("g",":first-child").attr("class","sub-rel-block").attr("transform",function(d){return"translate("+[d.w-5,d.h/2-26]+")"});subRelationIndicator.append("line").attr({x1:0,y1:30,x2:20,y2:30}).attr("stroke-width",1).attr("stroke","#888888");subRelationIndicator.append("circle").attr({cx:0,cy:30,r:4}).attr("fill","#888888");subRelationIndicator.append("circle").attr({cx:35,cy:30,r:15}).attr("stroke-width",1.1).attr("stroke","#888888").attr("fill","#f5f5f5");subRelationIndicator.append("text").append("tspan").attr({class:"sub-rel-count",x:35,y:45*.8});var service_height=224,name_size=22,charm_label_size=16,name_padding=26,charm_label_padding=150;node.select(".name").attr({style:function style(d){return"font-size:"+d.h*(name_size/service_height)+"px"},x:function x(d){return d.w/2},y:function y(d){return d.h*(name_padding/service_height)+d.h*(name_size/service_height)/2}});node.select(".name").text(function(d){return self.truncateServiceName(d)});node.select(".charm-label").attr({style:function style(d){return"font-size:"+d.h*(charm_label_size/service_height)+"px"},x:function x(d){return d.w/2},y:function y(d){return d.h*(charm_label_padding/service_height)-d.h*(charm_label_size/service_height)/2}});var exposed=node.filter(function(d){return d.exposed});exposed.each(function(d){d3.select(this).classed("is-exposed",true)});var unexposed=node.filter(function(d){return!d.exposed});unexposed.each(function(d){d3.select(this).classed("is-exposed",false)})};views.ServiceModuleCommon=ServiceModuleCommon;var ServiceModule=Y.Base.create("ServiceModule",components.Module,[ServiceModuleCommon],{events:{scene:{".service":{click:"serviceClick",mouseenter:"serviceMouseEnter",mouseleave:"serviceMouseLeave",mousemove:"serviceMouseMove"},".service-status":{mouseover:"serviceStatusMouseOver",mouseout:"serviceStatusMouseOut"},".zoom-plane":{mouseup:"canvasClick"}},d3:{".service":{"mousedown.addrel":"serviceAddRelMouseDown","mouseup.addrel":"serviceAddRelMouseUp"}},yui:{highlight:"highlight",unhighlight:"unhighlight",show:"show",hide:"hide",fade:"fade",dragstart:"dragstart",drag:"drag",dragend:"dragend",clearState:"clearStateHandler",panToCenter:"panToCenter"}},subordinate_margins:{top:.05,bottom:.1,left:.084848,right:.084848},service_margins:{top:.01,bottom:.01,left:.01,right:.01},initializer:function initializer(options){ServiceModule.superclass.constructor.apply(this,arguments);this.set("currentServiceClickAction","showServiceDetails")},_attachDragEvents:function _attachDragEvents(){var container=this.get("container"),ZP=".zoom-plane",EC=".environment-help";container.delegate("drop",this.canvasDropHandler,ZP,this);container.delegate("dragenter",this._ignore,ZP,this);container.delegate("dragover",this._ignore,ZP,this);container.delegate("drop",this.canvasDropHandler,EC,this);container.delegate("dragenter",this._ignore,EC,this);container.delegate("dragover",this._ignore,EC,this)},_attachAdditionalEvents:function _attachAdditionalEvents(){var db=this.get("component").get("db");db.after("bundleImportComplete",this.panToBundle.bind(this))},panToBundle:function panToBundle(evt){var topo=this.get("component");var services=evt.services;var vertices=[];services.forEach(function(service){var box=topo.service_boxes[service.get("id")];if(box){vertices.push([box.x,box.y])}});this.findCentroid(vertices)},_ignore:function _ignore(e){e.preventDefault()},attachTouchstartEvents:function attachTouchstartEvents(data,node){var topo=this.get("component"),yuiNode=Y.Node(node);if(!d3.select(node).classed("pending")){yuiNode.on("touchstart",this._touchstartServiceTap,this,topo)}},_touchstartServiceTap:function _touchstartServiceTap(e,topo){var node=e.currentTarget.getDOMNode(),box=d3.select(node).datum();if(e.touches.length>1){box.tapped=false;return}box.tapped=true;this.serviceClick.call(node,box,this,"touch")},hoverService:function hoverService(id,hover){var node=this.getServiceNode(id);if(node){if(hover){utils.addSVGClass(node,"hover")}else{this.unhoverServices()}}},unhoverServices:function unhoverServices(){this.get("component").vis.selectAll(".hover").classed("hover",false)},deselectNodes:function deselectNodes(){var topo=this.get("component");topo.vis.selectAll(".is-selected").classed("is-selected",false)},selectNode:function selectNode(node){this.deselectNodes();utils.addSVGClass(node,"is-selected")},selectService:function selectService(id){var node=this.getServiceNode(id);if(node){this.selectNode(node)}},panToService:function panToService(id){var node=this.getServiceNode(id);if(node){var box=d3.select(node).datum();this.get("component").fire("panToPoint",{point:[box.x,box.y]})}},serviceClick:function serviceClick(box,self,eType){var topo=self.get("component");var container=self.get("container");if(eType!=="touch"){var mouse_coords=d3.mouse(container.one(".the-canvas").getDOMNode());if(!box.containsPoint(mouse_coords,topo.zoom)){return}}else{box.ignoreNextClick=true}if(box.ignoreNextClick){box.ignoreNextClick=false;return}if(topo.ignoreServiceClick){topo.ignoreServiceClick=false;return}var curr_click_action=self.get("currentServiceClickAction");if(box.node){self.selectNode(box.node)}self[curr_click_action](box,topo)},serviceMouseEnter:function serviceMouseEnter(box,context){var topo=context.get("component");topo.fire("hoverService",{id:box.id});var rect=Y.one(this);if(!utils.hasSVGClass(rect,"selectable-service")){return}topo.fire("snapToService",{service:box,rect:rect})},serviceMouseLeave:function serviceMouseLeave(box,context){var topo=context.get("component");topo.fire("hoverService",{id:null});context.unhoverServices();var container=context.get("container");var mouse_coords=d3.mouse(container.one(".the-canvas").getDOMNode());if(box.containsPoint(mouse_coords,topo.zoom)){return}topo.fire("snapOutOfService")},serviceMouseMove:function serviceMouseMove(box,context){var topo=context.get("component");topo.fire("mouseMove")},serviceStatusMouseOver:function serviceStatusMouseOver(box,context){d3.select(this).select(".unit-count").classed("unit-count",true).classed("hide-count",false).classed("show-count",true)},serviceStatusMouseOut:function serviceStatusMouseOut(box,context){d3.select(this).select(".unit-count").classed("unit-count",true).classed("show-count",false).classed("hide-count",true)},canvasClick:function canvasClick(box,self){var topo=self.get("component");if(!topo.zoomed){topo.fire("clearState")}},canvasDropHandler:function canvasDropHandler(evt){evt.halt();var files=evt._event.dataTransfer.files;var topo=this.get("component");var env=topo.get("env");var db=topo.get("db");return this._canvasDropHandler(files,topo,env,db,evt._event)},_canvasDropHandler:function _canvasDropHandler(files,topo,env,db,evt){var self=this;if(files&&files.length){Array.prototype.forEach.call(files,function(file){var ext=file.name.split(".").slice(-1).toString();if((file.type==="application/zip"||file.type==="application/x-zip-compressed")&&ext==="zip"){self._extractCharmMetadata.call(self,file,topo,env,db)}else{self.get("component").get("bundleImporter").importBundleFile(file)}})}else{this._deployFromCharmbrowser(evt,topo);return}return"event ignored"},_deployLocalCharm:function _deployLocalCharm(file,env,db){var topo=this.get("component");topo.fire("changeState",{sectionA:{component:"inspector",metadata:{id:null,localType:"new",flash:{file:file}}}})},_extractCharmMetadata:function _extractCharmMetadata(file,topo,env,db){ziputils.getEntries(file,this._findCharmEntries.bind(this,file,topo,env,db),this._zipExtractionError.bind(this,db))},_findCharmEntries:function _findCharmEntries(file,topo,env,db,allEntries){var entries=ziputils.findCharmEntries(allEntries);if(!entries.metadata){db.notifications.add({title:"Import failed",message:'Import from "'+file.name+'" failed. Invalid charm '+"file, missing metadata.yaml",level:"error"});return}this._readCharmEntries(file,topo,env,db,entries)},_readCharmEntries:function _readCharmEntries(file,topo,env,db,entries){ziputils.readCharmEntries(entries,this._checkForExistingServices.bind(this,file,topo,env,db),this._zipExtractionError.bind(this,db,file))},_checkForExistingServices:function _checkForExistingServices(file,topo,env,db,contents){var charmName=jsyaml.safeLoad(contents.metadata).name;var services=db.services.getServicesFromCharmName(charmName);if(services.length>0){this._showUpgradeOrNewInspector(services,file,env,db)}else{this._deployLocalCharm(file,env,db)}},_zipExtractionError:function _zipExtractionError(db,file,error){db.notifications.add({title:"Import failed",message:'Import from "'+file.name+'" failed. See console for'+"error object",level:"error"});console.error(error)},_showUpgradeOrNewInspector:function _showUpgradeOrNewInspector(services,file,env,db){services.forEach(function(service,index,source){source[index]=service.getAttrs()});var topo=this.get("component");topo.fire("changeState",{sectionA:{component:"inspector",metadata:{id:null,localType:"update",flash:{file:file,services:services}}}})},_deployFromCharmbrowser:function _deployFromCharmbrowser(evt,topo){var dragData=JSON.parse(evt.dataTransfer.getData("Text"));var translation=topo.get("translate");var scale=topo.get("scale");var ghostAttributes={coordinates:[]};var dropXY=[evt.clientX,evt.clientY-71];Y.Array.each(dropXY,function(_,index){ghostAttributes.coordinates[index]=(dropXY[index]-translation[index])/scale});if(dragData.dataType==="token-drag-and-drop"){var entityData=Y.JSON.parse(dragData.data);if(utils.determineEntityDataType(entityData)==="charm"){ghostAttributes.icon=dragData.iconSrc;var charm=new models.Charm(entityData);Y.fire("initiateDeploy",charm,ghostAttributes)}else{this.get("component").get("db").notifications.add({title:"Processing File",message:"Changeset processing started.",level:"important"});var charmstore=topo.get("charmstore");charmstore.getBundleYAML(entityData.id.replace("cs:",""),function(error,bundleYAML){if(error){console.error(error);return}topo.get("bundleImporter").importBundleYAML(bundleYAML)}.bind(this))}}},clearStateHandler:function clearStateHandler(){var container=this.get("container"),topo=this.get("component");container.all(".environment-menu.active").removeClass("active");this.deselectNodes();this.unhoverServices();topo.fire("changeState",{sectionA:{component:"services",metadata:null},sectionC:{component:null,metadata:null}})},allowBuildRelation:function allowBuildRelation(topo,service){var charm=topo.get("db").charms.getById(service.get("charm"));return charm&&charm.loaded},serviceAddRelMouseDown:function serviceAddRelMouseDown(box,context){var evt=d3.event;var topo=context.get("component");context.longClickTimer=Y.later(750,this,function(d,e){if((Math.abs(box.x-box.px)+Math.abs(box.y-box.py))/2>5){return}if(!context.allowBuildRelation(topo,box.model)){return}d3.event=e;topo.fire("addRelationDragStart",{service:box})},[box,evt],false)},serviceAddRelMouseUp:function serviceAddRelMouseUp(box,context){if(context.longClickTimer){context.longClickTimer.cancel()}},dragstart:function dragstart(box,self){box.inDrag=views.DRAG_START},dragend:function dragend(box,self){var topo=self.get("component");if(box.tapped){box.tapped=false;if(!topo.buildingRelation){return}}if(topo.buildingRelation){topo.ignoreServiceClick=true;topo.fire("addRelationDragEnd")}else{if(box.inDrag!==views.DRAG_ACTIVE){return}topo.ignoreServiceClick=true;topo.annotateBoxPosition(box)}},drag:function drag(box,self,pos,includeTransition){if(box.tapped){return}var topo=self.get("component");var selection=d3.select(this);if(topo.buildingRelation){if(box){topo.fire("addRelationDrag",{box:box});return}else{topo.buildingRelation=false}}if(self.longClickTimer){self.longClickTimer.cancel()}if(pos){box.x=pos.x;box.y=pos.y}else{box.x+=d3.event.dx;box.y+=d3.event.dy}if(includeTransition){selection=selection.transition().duration(500).ease("elastic")}selection.attr("transform",function(d,i){return d.translateStr});self.get("container").all(".environment-menu.active").removeClass("active");if(box.inDrag===views.DRAG_START){box.inDrag=views.DRAG_ACTIVE}topo.fire("cancelRelationBuild");topo.fire("serviceMoved",{service:box})},update:function update(){var self=this,topo=this.get("component"),width=topo.get("width"),height=topo.get("height");if(!this.rendered){this._attachDragEvents();this._attachAdditionalEvents();this.rendered=true}if(!this.service_scale){this.service_scale=d3.scale.log().range([150,200]);this.service_scale_width=d3.scale.log().range([164,200]);this.service_scale_height=d3.scale.log().range([64,100])}if(!this.dragBehavior){this.dragBehavior=d3.behavior.drag().on("dragstart",function(d){self.dragstart.call(this,d,self)}).on("drag",function(d){self.drag.call(this,d,self)}).on("dragend",function(d){self.dragend.call(this,d,self)})}this.updateData();var node=this.node;node.on("mousewheel.zoom",topo.handleZoom.bind(topo)).on("wheel.zoom",topo.handleZoom.bind(topo));var vertices=[];Y.each(topo.service_boxes,function(boundingBox){var annotations=boundingBox.annotations,addToVertices=0;if(annotations["gui-x"]&&boundingBox.x===undefined){boundingBox.x=annotations["gui-x"];addToVertices+=1}if(annotations["gui-y"]&&boundingBox.y===undefined){boundingBox.y=annotations["gui-y"];addToVertices+=1}if(addToVertices===2&&!boundingBox.model.get("pending")){vertices.push([boundingBox.x,boundingBox.y])}});var new_service_boxes=Y.Object.values(topo.service_boxes).filter(function(boundingBox){if(boundingBox.model){var annotations=boundingBox.model.get("annotations");return!Y.Lang.isNumber(boundingBox.x)&&!(annotations&&annotations["gui-x"])}return false});if(new_service_boxes.length>0){if(new_service_boxes.length===1&&new_service_boxes[0].model.get("pending")&&(new_service_boxes[0].x===undefined||new_service_boxes[0].y===undefined)){var coords=topo.servicePointOutside();new_service_boxes[0].x=coords[0];new_service_boxes[0].y=coords[1];topo.fire("panToPoint",{point:coords})}else{d3.layout.pack().size([width,height]).value(function(d){return Math.max(d.unit_count,1)}).padding(300).radius(50).nodes({children:new_service_boxes});if(new_service_boxes.length<Y.Object.size(topo.service_boxes)){var pointOutside;var newVertices=[];Y.each(new_service_boxes,function(boxModel){pointOutside=topo.servicePointOutside(newVertices);boxModel.x+=pointOutside[0]-boxModel.x;boxModel.y+=pointOutside[1]-boxModel.y;newVertices.push([boxModel.x,boxModel.y])})}Y.each(new_service_boxes,function(box){var existing=box.model.get("annotations")||{};if(!existing||!existing["gui-x"]){vertices.push([box.x||0,box.y||0]);topo.annotateBoxPosition(box)}else{if(vertices.length>0){vertices.push([existing["gui-x"]||box.x||0,existing["gui-y"]||box.y||0])}}})}}node.enter().append("g").attr({"pointer-events":"all",class:function _class(d){return(d.subordinate?"subordinate ":"")+"service"}}).call(this.dragBehavior).call(self.createServiceNode,self).attr("transform",function(d){return d.translateStr});self.updateServiceNodes(node);node.exit().each(function(d){delete topo.service_boxes[d.id]}).remove();this.updateElementVisibility()},panToCenter:function panToCenter(evt){var topo=this.get("component");var vertices=topoUtils.serviceBoxesToVertices(topo.service_boxes);this.findCentroid(vertices)},findCentroid:function findCentroid(vertices){var topo=this.get("component"),centroid=topoUtils.centroid(vertices);topo.fire("panToPoint",{point:centroid})},getServiceNode:function getServiceNode(id){if(this.node===undefined){return null}var node=this.node.filter(function(d,i){return d.id===id});return node&&node[0][0]||null},truncateServiceName:function truncateServiceName(service){var name=service.displayName;if(service.pending){name=name.match(/^\(?(.{0,}?)\)?$/)[1]}if(name.length>10){name=name.substr(0,9)+"…"}if(service.pending){name="("+name+")"}return name},createServiceNode:function createServiceNode(node,self){node.attr({"data-name":function dataName(d){return d.name}});var relationButton=node.filter(function(d){return d3.select(this).select(".relation-button").empty()}).insert("g",":first-child").attr("class","relation-button").attr("transform",function(d){return"translate("+[d.subordinate?65:95,30]+")"});relationButton.append("line").attr({x1:0,y1:0,x2:0,y2:30}).attr("stroke-width",1).attr("stroke","#888888");relationButton.append("circle").attr({cx:0,cy:34,r:4}).attr("fill","#888888");relationButton.append("circle").classed("relation-button__link",true).attr({cx:0,cy:0,r:15,fill:"#f8f8f8",stroke:"#888888","stroke-width":1.1}).on("click",function(d){self.get("component").fire("addRelationDragStart",{service:d})});relationButton.append("image").classed("relation-button__image",true).attr({"xlink:href":"juju-ui/assets/svgs/build-relation_16.svg",width:16,height:16,transform:"translate(-8, -8)"});node.append("circle").attr({cx:function cx(d){return d.subordinate?65:95},cy:function cy(d){return d.subordinate?65:95},r:function r(d){return d.subordinate?80:110},fill:"transparent","stroke-dasharray":"5, 5"}).classed("service-block__halo",true);node.append("circle").attr({cx:function cx(d){return d.subordinate?65:95},cy:function cy(d){return d.subordinate?65:95},r:function r(d){return d.subordinate?60:90},fill:"#f5f5f5","stroke-width":1,stroke:"#888888"}).classed("service-block",true);node.append("circle").attr({id:function id(d){return"service-icon-mask-"+d.name},cx:48,cy:48,r:45});var clip=node.append("clipPath").attr({id:function id(d){return"clip-"+d.name}});clip.append("use").attr({"xlink:href":function xlinkHref(d){return"#service-icon-mask-"+d.name}});node.append("image").classed("service-icon",true).attr({"xlink:href":function xlinkHref(d){return d.icon},width:96,height:96,transform:function transform(d){return d.subordinate?"translate(17, 17)":"translate(47, 47)"},"clip-path":function clipPath(d){return"url(#clip-"+d.name+")"}});node.each(function(data){self.attachTouchstartEvents(data,this)})},updateElementVisibility:function updateElementVisibility(){var actions={fade:[],highlight:[],hide:[],show:[]};var db=this.get("component").get("db");var fade,hide,highlight,name;db.services.each(function(service){fade=service.get("fade");highlight=service.get("highlight");hide=service.get("hide");name=service.get("id");if(fade){actions.fade.push(name)}if(highlight){actions.highlight.push(name)}if(hide){actions.hide.push(name)}if(!fade&&!highlight&&!hide){actions.show.push(name)}});if(actions.fade.length>0){this.show({serviceNames:actions.fade});this.unhighlight({serviceName:actions.fade});this.fade({serviceNames:actions.fade})}if(actions.highlight.length>0){this.show({serviceNames:actions.highlight});this.highlight({serviceName:actions.highlight})}if(actions.hide.length>0){this.unhighlight({serviceName:actions.hide});this.hide({serviceNames:actions.hide})}if(actions.show.length>0){this.unhighlight({serviceName:actions.show});this.show({serviceNames:actions.show})}},highlight:function highlight(evt){var serviceNames=[evt.serviceName];if(Y.Lang.isArray(evt.serviceName)){serviceNames=evt.serviceName}var topo=this.get("component");if(evt.highlightRelated){var service=topo.service_boxes[serviceNames[0]].model;var relationData=utils.getRelationDataForService(topo.get("db"),service);relationData.forEach(function(relation){serviceNames.push(relation.far.service)})}serviceNames.forEach(function(service){topo.service_boxes[service].highlighted=true});var selection=this.selectionFromServiceNames(serviceNames);selection.classed(topoUtils.getVisibilityClasses("highlight"))},unhighlight:function unhighlight(evt){var serviceNames=[evt.serviceName];if(Y.Lang.isArray(evt.serviceName)){serviceNames=evt.serviceName}var topo=this.get("component");if(evt.unhighlightRelated){var service=topo.service_boxes[serviceNames[0]].model;var relationData=utils.getRelationDataForService(topo.get("db"),service);relationData.forEach(function(relation){serviceNames.push(relation.far.service)})}serviceNames.forEach(function(service){topo.service_boxes[service].highlighted=false});var selection=this.selectionFromServiceNames(serviceNames);selection.classed(topoUtils.getVisibilityClasses("unhighlight"));var image,href;selection.each(function(d){image=d3.select(this).select(".service-block-image");href="juju-ui/assets/svgs/service_module.svg";if(d.pending||d.deleted){href="juju-ui/assets/svgs/service_module_pending.svg"}image.attr("href",href)})},show:function show(evt){var selection=evt.selection;if(!selection){var serviceNames=evt.serviceNames;if(!serviceNames||serviceNames.length===0){serviceNames=Object.keys(this.get("component").service_boxes)}selection=this.selectionFromServiceNames(serviceNames)}selection.classed(topoUtils.getVisibilityClasses("show"))},hide:function hide(evt){var selection=evt.selection;if(!selection){var serviceNames=evt.serviceNames;if(!serviceNames){return}selection=this.selectionFromServiceNames(serviceNames)}selection.classed(topoUtils.getVisibilityClasses("hide"))},fade:function fade(evt){var selection=evt.selection;if(!selection){var serviceNames=evt.serviceNames;if(!serviceNames){return}selection=this.selectionFromServiceNames(serviceNames)}selection.classed(topoUtils.getVisibilityClasses("fade"))},selectionFromServiceNames:function selectionFromServiceNames(serviceNames){var topo=this.get("component");return topo.vis.selectAll(".service").filter(function(d){return serviceNames.indexOf(d.id)>-1})},backgroundClicked:function backgroundClicked(){var topo=this.get("component");topo.fire("clearState")},showServiceDetails:function showServiceDetails(box,topo){topo.fire("changeState",{sectionA:{component:"inspector",metadata:{id:box.id,flash:{hideHelp:true}}}})},show_service:function show_service(service){var topo=this.get("component");var createServiceInspector=topo.get("createServiceInspector");topo.detachContainer();createServiceInspector(service)}},{ATTRS:{component:{}}});views.ServiceModule=ServiceModule},"0.1.0",{requires:["d3","d3-components","d3-statusbar","juju-templates","juju-models","zip-utils"]});